/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:logic:LinuxCNC HAL component providing configurable logic functions");
MODULE_INFO(linuxcnc, "pin:in-##:bit:(16, 'personality & 0xff'):in::None:None");
MODULE_INFO(linuxcnc, "pin:and:bit:0:out::None:personality & 0x100");
MODULE_INFO(linuxcnc, "pin:or:bit:0:out::None:personality & 0x200");
MODULE_INFO(linuxcnc, "pin:xor:bit:0:out::None:personality & 0x400");
MODULE_INFO(linuxcnc, "funct:_:0:");
MODULE_INFO(linuxcnc, "descr:\nGeneral logic function' component.  Can perform AND, OR and XOR of up to 16 inputs.\n\nDetermine the proper value for `personality'\nby adding the inputs and outputs then convert to hex:\n\n    The number of input pins, usually from 2 to 16\n\n    256 (0x100)  if the `and' output is desired\n\n    512 (0x200)  if the `or' output is desired\n\n    1024 (0x400)  if the `xor' (exclusive or) output is desired\n\nOutputs can be combined, for example: \n\n2 + 256 + 1024 = 1282 converted to hex\nwould be 0x502 and would have two inputs and have both XOR and AND outputs.\n");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    int _personality;
    hal_bit_t *in[16];
    hal_bit_t *and;
    hal_bit_t *or;
    hal_bit_t *xor;
};
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg, long personality) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_personality = personality;
    for(j=0; j < (personality & 0xff); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->in[j]), comp_id,
            "%s.in-%02d", prefix, j);
        if(r != 0) return r;
    }
if(personality & 0x100) {
    r = hal_pin_bit_newf(HAL_OUT, &(inst->and), comp_id,
        "%s.and", prefix);
    if(r != 0) return r;
}
if(personality & 0x200) {
    r = hal_pin_bit_newf(HAL_OUT, &(inst->or), comp_id,
        "%s.or", prefix);
    if(r != 0) return r;
}
if(personality & 0x400) {
    r = hal_pin_bit_newf(HAL_OUT, &(inst->xor), comp_id,
        "%s.xor", prefix);
    if(r != 0) return r;
}
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}
static int default_count=1, count=0;
char *names[16] = {0,};
RTAPI_MP_INT(count, "number of logic");
RTAPI_MP_ARRAY_STRING(names, 16, "names of logic");
static int personality[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
RTAPI_MP_ARRAY_INT(personality, 16, "personality of each logic");
int rtapi_app_main(void) {
    int r = 0;
    int i;
    comp_id = hal_init("logic");
    if(comp_id < 0) return comp_id;
    if(count && names[0]) {
        rtapi_print_msg(RTAPI_MSG_ERR,"count= and names= are mutually exclusive\n");
        return -EINVAL;
    }
    if(!count && !names[0]) count = default_count;
    if(count) {
        for(i=0; i<count; i++) {
            char buf[HAL_NAME_LEN + 1];
            rtapi_snprintf(buf, sizeof(buf), "logic.%d", i);
        r = export(buf, i, personality[i%16]);
            if(r != 0) break;
       }
    } else {
        for(i=0; names[i]; i++) {
        r = export(names[i], i, personality[i%16]);
            if(r != 0) break;
       }
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in(i) (0+*(__comp_inst->in[i]))
#undef and
#define and (*__comp_inst->and)
#undef or
#define or (*__comp_inst->or)
#undef xor
#define xor (*__comp_inst->xor)
#undef personality
#define personality (__comp_inst->_personality)


#line 33 "hal/components/logic.comp"
FUNCTION(_) {
    int i, a=1, o=0, x=0;
    for(i=0; i < (personality & 0xff); i++) {
        if(in(i)) { o = 1; x = !x; }
        else { a = 0; }
    }
    if(personality & 0x100) and = a;
    if(personality & 0x200) or = o;
    if(personality & 0x400) xor = x;
}

static int __comp_get_data_size(void) { return 0; }
