/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:rtfault:generate RT faults on purpose");
MODULE_INFO(linuxcnc, "pin:fault:bit:0:in:cause a series of count RT faults:None:None");
MODULE_INFO(linuxcnc, "pin:count:u32:0:in:number of faults:None:None");
MODULE_INFO(linuxcnc, "pin:delay:u32:0:in:ms delay on fault ⁽less than 1000):None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *fault;
    hal_u32_t *count;
    hal_u32_t *delay;
};
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->fault), comp_id,
        "%s.fault", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_IN, &(inst->count), comp_id,
        "%s.count", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_IN, &(inst->delay), comp_id,
        "%s.delay", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}
int rtapi_app_main(void) {
    int r = 0;
    comp_id = hal_init("rtfault");
    if(comp_id < 0) return comp_id;
    r = export("rtfault", 0);
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef fault
#define fault (0+*__comp_inst->fault)
#undef count
#define count (0+*__comp_inst->count)
#undef delay
#define delay (0+*__comp_inst->delay)


#line 12 "hal/components/rtfault.comp"

#include "rtapi.h"
#if defined(BUILD_SYS_USER_DSO)
#include <time.h>
#include <stdio.h>
#endif
#include <stdbool.h>
static bool previous_fault;
static int n;

FUNCTION(_) {
    if (previous_fault ^ fault) {
	n = count;
    }
    previous_fault = fault;  
    if (n) {
#if defined(BUILD_SYS_USER_DSO)
	// printf() eventually calls write(), which will cause
	// a Xenomai domain switch

	struct timespec nap = {0, delay * 1000 * 1000};
	if (delay)
	    nanosleep(&nap, NULL);
	printf("fault # %d\n", n--);
#else
	do {
	    rtapi_delay(delay * 1000 * 1000);
	    n--;
	} while (n > 0);
	rtapi_print_msg(RTAPI_MSG_ERR, "RT delay ..\n");
#endif
    }
}

static int __comp_get_data_size(void) { return 0; }
