/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:rtmon:monitor RT faults and generate estop signal based on a parameterized function");
MODULE_INFO(linuxcnc, "descr:\nThis component is an example how realtime faults (e.g. timing violations) can be dealt with. The realtime API (RTAPI)\nonly collects relevant events but does not act upon them; every RT fault causes a call to the RTAPI\nexception handler, which is a function in RTAPI printing a message to the system log by default.\n\nThis exception handler may be overridden within a RT HAL component by means of the\nrtapi_set_exception(new_handler) function. The arguments of the handler provide detail about the cause\nof the fault.\n\nThe rtmon component intercepts this exception handler, and applies policy - for instance, to generate an\nestop signal based on a set of parameters.\n\nThe scheme implemented here was inspired by Andy Pugh's smart serial code, which works as follows:\n\nThere is a programable increment, decrement and limit. If there is an\nerror then the error count increments, if no error it decrements, when\nyou hit the limit, you trigger a reaction.\n\nNo decrement = no fault healing. No increment = no fault reaction.\n\nAssuming that the rtmon thread function is added to the servo thread (1mS) , then an increment of\n100 and decrement of 1 and threshold of 500 would trigger a fault\nreaction after 5 seconds of more than ten errors a second.\n\nAnother scenario could be where a certain amount of errors during startup is tolerated:\nIf you know that there will be 100 faults at startup, but those are\nOK, but any later ones are a problem, then increment of 1, decrement\nof zero and threshold of 101 (simplistically) gives that behaviour.\n");
MODULE_INFO(linuxcnc, "pin:estop:bit:0:out:activated if more than <threshold> exceptions occur.:None:None");
MODULE_INFO(linuxcnc, "pin:estop_reset:bit:0:in:a positive edge on this pin clears the estop and fault_count pins:None:None");
MODULE_INFO(linuxcnc, "pin:rt_faults:u32:0:out:total number of RT scheduling violations observed:None:None");
MODULE_INFO(linuxcnc, "pin:fault_count:u32:0:out:current level for RT scheduling violations; reset on estop_reset positive edge:None:None");
MODULE_INFO(linuxcnc, "pin:stats_updates:u32:0:out:total number of rtapi_task_update_stats() calls so far:None:None");
MODULE_INFO(linuxcnc, "param:fault_inc:u32:0:rw:increment fault_count by fault_inc for each RT fault detected:1:None");
MODULE_INFO(linuxcnc, "param:fault_dec:u32:0:rw:decrement fault_count in each thread iteration:0:None");
MODULE_INFO(linuxcnc, "param:fault_limit:u32:0:rw:if fault_count exceeds fault_limit, cause an estop:1:None");
MODULE_INFO(linuxcnc, "param:autoclear_estop:bit:0:rw:clear estop condition once fault_count reaches zero:0:None");
MODULE_INFO(linuxcnc, "param:stats_divisor:u32:0:rw:rtapi_task_update_stats() update frequency:1000:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *estop;
    hal_bit_t *estop_reset;
    hal_u32_t *rt_faults;
    hal_u32_t *fault_count;
    hal_u32_t *stats_updates;
    hal_u32_t fault_inc;
    hal_u32_t fault_dec;
    hal_u32_t fault_limit;
    hal_bit_t autoclear_estop;
    hal_u32_t stats_divisor;
    u32 stats_counter;

};
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
static void extra_cleanup(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_OUT, &(inst->estop), comp_id,
        "%s.estop", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->estop_reset), comp_id,
        "%s.estop-reset", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->rt_faults), comp_id,
        "%s.rt-faults", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->fault_count), comp_id,
        "%s.fault-count", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->stats_updates), comp_id,
        "%s.stats-updates", prefix);
    if(r != 0) return r;
    r = hal_param_u32_newf(HAL_RW, &(inst->fault_inc), comp_id,
        "%s.fault-inc", prefix);
    inst->fault_inc = 1;
    if(r != 0) return r;
    r = hal_param_u32_newf(HAL_RW, &(inst->fault_dec), comp_id,
        "%s.fault-dec", prefix);
    inst->fault_dec = 0;
    if(r != 0) return r;
    r = hal_param_u32_newf(HAL_RW, &(inst->fault_limit), comp_id,
        "%s.fault-limit", prefix);
    inst->fault_limit = 1;
    if(r != 0) return r;
    r = hal_param_bit_newf(HAL_RW, &(inst->autoclear_estop), comp_id,
        "%s.autoclear-estop", prefix);
    inst->autoclear_estop = 0;
    if(r != 0) return r;
    r = hal_param_u32_newf(HAL_RW, &(inst->stats_divisor), comp_id,
        "%s.stats-divisor", prefix);
    inst->stats_divisor = 1000;
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}
int rtapi_app_main(void) {
    int r = 0;
    comp_id = hal_init("rtmon");
    if(comp_id < 0) return comp_id;
    r = export("rtmon", 0);
    if(r) {
    extra_cleanup();
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    extra_cleanup();
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef estop
#define estop (*__comp_inst->estop)
#undef estop_reset
#define estop_reset (0+*__comp_inst->estop_reset)
#undef rt_faults
#define rt_faults (*__comp_inst->rt_faults)
#undef fault_count
#define fault_count (*__comp_inst->fault_count)
#undef stats_updates
#define stats_updates (*__comp_inst->stats_updates)
#undef fault_inc
#define fault_inc (__comp_inst->fault_inc)
#undef fault_dec
#define fault_dec (__comp_inst->fault_dec)
#undef fault_limit
#define fault_limit (__comp_inst->fault_limit)
#undef autoclear_estop
#define autoclear_estop (__comp_inst->autoclear_estop)
#undef stats_divisor
#define stats_divisor (__comp_inst->stats_divisor)
#undef stats_counter
#define stats_counter (__comp_inst->stats_counter)


#line 57 "hal/components/rtmon.comp"

#include "rtapi.h"
#include <stdbool.h>

// need a bit of trickery here	- we're accessing the (sole) instance data
// in a non-thread function to wiggle and read pins
static struct __comp_state *this;

static int rtmon_exception_handler(rtapi_exception_t type,
				   rtapi_exception_detail_t *detail,
				   rtapi_threadstatus_t *threadstatus)

{
    // substitute missing '__comp_inst' parameter to make pins accessible
    // this works for a singleton only
    struct __comp_state *__comp_inst  = this;

    int thread_id = rtapi_task_self();
    if (!estop)
	rtapi_print_msg(RTAPI_MSG_ERR, "RTMON: thread %d  exception: %d\n", thread_id, type);
    rt_faults = rt_faults + 1;
    fault_count += fault_inc;

    if ((fault_count > fault_limit) && !estop) {
	rtapi_print_msg(RTAPI_MSG_ERR, "RTMON: ------- setting estop\n");
	estop = 1;
    }
    return 0;
}

static rtapi_exception_handler_t previous;
static bool previous_estop_reset;

EXTRA_SETUP(){
    this = __comp_inst;
    stats_counter = stats_divisor;

    // make RTAPI upcall into local handler on RT faults:
    previous = rtapi_set_exception(rtmon_exception_handler);
    return 0;
}

EXTRA_CLEANUP(){
    // restore status ante: restore default handler in RTAPI
    rtapi_set_exception(previous);
    return;
}

FUNCTION(_){

    // track thread status every now and then
    stats_counter = stats_counter + 1;
    if (stats_counter > stats_divisor) {
	stats_updates = stats_updates + 1;
	rtapi_task_update_stats();
	stats_counter = 0;
    }

    // detect postive edge on estop_reset for explicit clear of estop condition
    if ((previous_estop_reset ^ estop_reset) && estop_reset) {
      rtapi_print_msg(RTAPI_MSG_ERR, "RTMON: -------  estop cleared by estop_reset\n");
      fault_count = 0; // forget history
      estop = 0;
    }
    previous_estop_reset = estop_reset;

    if (fault_count > fault_dec) {
	fault_count -= fault_dec;
    } else {
	fault_count = 0;
	if (estop && autoclear_estop) {
	    rtapi_print_msg(RTAPI_MSG_ERR, "RTMON: ------- auto-clear estop\n");
	    estop = 0;
	}
    }
}


static int __comp_get_data_size(void) { return 0; }
