/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:pcl720:Driver for the Advantech PCL 720 card.");
MODULE_INFO(linuxcnc, "descr:This driver supports the Advantech PCL720 ISA card. It might\nwork with the PCI version too, but this is untested. \n It creates hal pins corresonding to the digital inputs and outputs, but does\nnot support the the counters/timers.");
MODULE_INFO(linuxcnc, "pin:pin-##-out:bit:32:in:Output pins:None:None");
MODULE_INFO(linuxcnc, "pin:pin-##-in:bit:32:out:Input pins:None:None");
MODULE_INFO(linuxcnc, "pin:pin-##-in-not:bit:32:out:Inverted version of each input pin:None:None");
MODULE_INFO(linuxcnc, "param:reset-time:u32:0:rw:The time in nanoseconds after the write function\nhas run to reset the pins for which the \"reset\" parameter is set.:5000:None");
MODULE_INFO(linuxcnc, "param:pin-##-reset:bit:32:rw:specifies if the pin should be reset by the \"reset\"\nfunction:None:None");
MODULE_INFO(linuxcnc, "param:pin-##-out-invert:bit:32:rw:Set to true to invert the sense of the output pin:None:None");
MODULE_INFO(linuxcnc, "pin:wait_clocks:u32:0:out::None:None");
MODULE_INFO(linuxcnc, "funct:read:0:Reads each of the digital inputs and updates the HAL pins");
MODULE_INFO(linuxcnc, "funct:write:0:Writes the values of the output HAL pins to the digital IO");
MODULE_INFO(linuxcnc, "funct:reset:0:Waits for the length of time specified by the\n\\fBreset-time\\fP parameter and resets any pins for which the \\fBreset\\fP\nparameter has been set. This can be used to allow step generators to make a step\nevery thread rather than every other thread. This function must be added to the\nthread after the \"write\" function.\n Do not use this function if you do not wish to reset any pins.\n the stepgen \\fBstep-space\\fP parameter should be set to 0 to make use of this\nfunction.");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_INFO(linuxcnc, "author:Andy Pugh");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *pin_out[32];
    hal_bit_t *pin_in[32];
    hal_bit_t *pin_in_not[32];
    hal_u32_t *wait_clocks;
    hal_u32_t reset_time;
    hal_bit_t pin_reset[32];
    hal_bit_t pin_out_invert[32];
    unsigned base_addr;

    unsigned out;

    unsigned inv;

    unsigned res;

    u64 write_time;

};
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void read(struct __comp_state *__comp_inst, long period);
static void write(struct __comp_state *__comp_inst, long period);
static void reset(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    for(j=0; j < (32); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->pin_out[j]), comp_id,
            "%s.pin-%02d-out", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (32); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->pin_in[j]), comp_id,
            "%s.pin-%02d-in", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (32); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->pin_in_not[j]), comp_id,
            "%s.pin-%02d-in-not", prefix, j);
        if(r != 0) return r;
    }
    r = hal_pin_u32_newf(HAL_OUT, &(inst->wait_clocks), comp_id,
        "%s.wait-clocks", prefix);
    if(r != 0) return r;
    r = hal_param_u32_newf(HAL_RW, &(inst->reset_time), comp_id,
        "%s.reset-time", prefix);
    inst->reset_time = 5000;
    if(r != 0) return r;
    for(j=0; j < 32; j++) {
        r = hal_param_bit_newf(HAL_RW, &(inst->pin_reset[j]), comp_id,
            "%s.pin-%02d-reset", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < 32; j++) {
        r = hal_param_bit_newf(HAL_RW, &(inst->pin_out_invert[j]), comp_id,
            "%s.pin-%02d-out-invert", prefix, j);
        if(r != 0) return r;
    }
    rtapi_snprintf(buf, sizeof(buf), "%s.read", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))read, inst, 0, 0, comp_id);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.write", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))write, inst, 0, 0, comp_id);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.reset", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))reset, inst, 0, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}
static int get_count(void);
int rtapi_app_main(void) {
    int r = 0;
    int i;
    int count = get_count();
    comp_id = hal_init("pcl720");
    if(comp_id < 0) return comp_id;
    for(i=0; i<count; i++) {
        char buf[HAL_NAME_LEN + 1];
        rtapi_snprintf(buf, sizeof(buf), "pcl720.%d", i);
        r = export(buf, i);
    }
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef pin_out
#define pin_out(i) (0+*(__comp_inst->pin_out[i]))
#undef pin_in
#define pin_in(i) (*(__comp_inst->pin_in[i]))
#undef pin_in_not
#define pin_in_not(i) (*(__comp_inst->pin_in_not[i]))
#undef wait_clocks
#define wait_clocks (*__comp_inst->wait_clocks)
#undef reset_time
#define reset_time (__comp_inst->reset_time)
#undef pin_reset
#define pin_reset(i) (__comp_inst->pin_reset[i])
#undef pin_out_invert
#define pin_out_invert(i) (__comp_inst->pin_out_invert[i])
#undef base_addr
#define base_addr (__comp_inst->base_addr)
#undef out
#define out (__comp_inst->out)
#undef inv
#define inv (__comp_inst->inv)
#undef res
#define res (__comp_inst->res)
#undef write_time
#define write_time (__comp_inst->write_time)


#line 47 "hal/drivers/pcl720.comp"

#include <rtapi_io.h>
#define MAX_CHAN 8

static int ioaddr[MAX_CHAN] = {-1, -1, -1, -1, -1, -1, -1, -1};
RTAPI_MP_ARRAY_INT(ioaddr, MAX_CHAN, "Base addresses")

FUNCTION(read){
    unsigned R;
    int i;
    R =   inb(base_addr)
        + (inb(base_addr + 1) << 8)
        + (inb(base_addr + 2) << 16)
        + (inb(base_addr + 3) << 24);
    
    for (i = 0;i <= 31;i++){
        pin_in(i) = R & (1 << i);
        pin_in_not(i) = !pin_in(i);
    }
}

FUNCTION(write){
    int i;
    unsigned char b;
    out = 0;
    inv = 0;
    for (i = 0;i <= 31 ;i++){
        out |= pin_out(i) << i;
        inv |= pin_out_invert(i) << i;
    }
    
    out ^= inv;
    
    b = (out & 0xff);
    outb(b, base_addr);
    b = (out & 0xff00) >> 8;
    outb(b, base_addr + 1);
    b = (out & 0xff0000) >> 16;
    outb(b, base_addr + 2);
    b = (out & 0xff000000) >> 24;
    outb(b, base_addr + 3);
    
    write_time = rtapi_get_time();
}

FUNCTION(reset){
    int i;
    unsigned tmp;
    unsigned char b;
    
    res= 0;
    for (i = 0;i <= 31  ;i++){
        res |= pin_reset(i) << i;
    }
    
    if (res == 0) {return;} // no pins with reset set
    
    tmp = (out ^ inv) & (~res);
    if (tmp == out) {return;} // nothing to reset
    
    if(reset_time > period/4) reset_time = period/4;
    
    //compensate for any time elapsed since the write
    rtapi_delay(reset_time - (rtapi_get_time() - write_time));

    b = (tmp & 0xff);
    outb(b, base_addr);
    b = (tmp & 0xff00) >> 8;
    outb(b, base_addr + 1);
    b = (tmp & 0xff0000) >> 16;
    outb(b, base_addr + 2);
    b = (tmp & 0xff000000) >> 24;
    outb(b, base_addr + 3);
    
    out = tmp;
}


EXTRA_SETUP(){

    if (ioaddr[extra_arg] > 0) {
        base_addr = ioaddr[extra_arg];
        rtapi_print("Loading Advantech pcl720 driver at base addr %X\n", base_addr);
        return 0;
    }
    return -EINVAL;
}
    
    
int get_count(void){
    int i;
    for (i=0; ioaddr[i] > 0 && i < MAX_CHAN; i++){}
    return i;
}

static int __comp_get_data_size(void) { return 0; }
