/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#include "hal/drivers/pluto_common.h"
#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:pluto_servo:Hardware driver and firmware for the Pluto-P parallel-port FPGA, for use with servo machines.");
MODULE_INFO(linuxcnc, "descr:\nPluto_servo is a LinuxCNC software driver and associated firmware that allow the Pluto-P board to be used to control a servo-based CNC machine.\n\nThe driver has 4 PWM channels, 4 quadrature channels with index pulse, 18\ndigital outputs (8 shared with PWM), and 20 digital inputs (12 shared with\nquadrature).\n\n.SS Encoders\nThe encoder pins and parameters conform to the `canonical encoder' interface\ndescribed in the HAL manual.  It operates in `x4 mode'.\n\nThe sample rate of the encoder is 40MHz.  The maximum number quadrature rate is\n8191 counts per LinuxCNC servo cycle.  For correct handling of the index pulse, the\nnumber of encoder counts per revolution must be less than 8191.\n\n.SS PWM\nThe PWM pins and parameters conform to the `canonical analog output' interface\ndescribed in the HAL manual.  The output pins are `up/down' or `pwm/dir'\npins as described in the documentation of the `pwmgen' component.\n\nInternally the PWM generator is based on a 12-bit, 40MHz counter, giving 4095\nduty cycles from -100% to +100% and a frequency of approximately 19.5kHz.  In\nPDM mode, the duty periods are approximately 100ns long.\n\n.SS Digital I/O\nThe digital output pins conform to the `canonical digital output' interface\ndescribed in the HAL manual.\n\nThe digital input pins conform to the `canonical digital input' interface\ndescribed in the HAL manual.\n");
MODULE_INFO(linuxcnc, "pin:encoder.#.count:s32:4:out::None:None");
MODULE_INFO(linuxcnc, "pin:encoder.#.position:float:4:out::None:None");
MODULE_INFO(linuxcnc, "pin:encoder.#.velocity:float:4:out::None:None");
MODULE_INFO(linuxcnc, "pin:encoder.#.reset:bit:4:in::None:None");
MODULE_INFO(linuxcnc, "pin:encoder.#.index-enable:bit:4:io:encoder.\\fIM\\fR corresponds to the\npins labeled QA\\fIM\\fR, QB\\fIM\\fR, and QZ\\fIM\\fR on the pinout diagram:None:None");
MODULE_INFO(linuxcnc, "param:encoder.#.scale:float:4:rw::1:None");
MODULE_INFO(linuxcnc, "param:encoder.z-polarity:bit:0:rw:Set to TRUE if the index pulse is active low, FALSE if it is active high.  Affects all encoders.:None:None");
MODULE_INFO(linuxcnc, "pin:pwm.#.value:float:4:in::None:None");
MODULE_INFO(linuxcnc, "pin:pwm.#.enable:bit:4:in:pwm.\\fIM\\fR corresponds to the pins labeled UP\\fIM\\fR and DN\\fIM\\fR on the pinout diagram:None:None");
MODULE_INFO(linuxcnc, "param:pwm.#.offset:float:4:rw::None:None");
MODULE_INFO(linuxcnc, "param:pwm.#.scale:float:4:rw::1:None");
MODULE_INFO(linuxcnc, "param:pwm.#.max-dc:float:4:rw::1:None");
MODULE_INFO(linuxcnc, "param:pwm.#.min-dc:float:4:rw::0:None");
MODULE_INFO(linuxcnc, "param:pwm.#.pwmdir:bit:4:rw:Set to TRUE use PWM+direction mode.  Set to FALSE to use Up/Down mode.:0:None");
MODULE_INFO(linuxcnc, "param:pwm.is-pdm:bit:0:rw:Set to TRUE to use PDM (also called interleaved PWM) mode.  Set to FALSE to use traditional PWM mode.  Affects all PWM outputs.:None:None");
MODULE_INFO(linuxcnc, "pin:dout.##:bit:20:in:dout.\\fI0M\\fR corresponds to the pin labeled\nOUT\\fIM\\fR on the pinout diagram.  Other pins are shared with the PWM\nfunction, as follows:\n.RS 6\n.ta T 10 6\n.PP\n\\fBPin\tShared\\fR\n.PP\n\\fBLabel\twith\\fR\n.PP\ndout.10\tUP0\n.PP\ndout.10\tUP0\n.PP\ndout.12\tUP1\n.PP\ndout.14\tUP2\n.PP\ndout.18\tUP3\n.PP\ndout.11\tDOWN0\n.PP\ndout.13\tDOWN1\n.PP\ndout.15\tDOWN2\n.PP\ndout.19\tDOWN3\n.PP\n.RE \n.DT:None:None");
MODULE_INFO(linuxcnc, "param:dout.##-invert:bit:20:rw:If TRUE, the output on the corresponding \\fBdout.\\fIMM\\fR is inverted.:None:None");
MODULE_INFO(linuxcnc, "pin:din.##:bit:20:out::None:None");
MODULE_INFO(linuxcnc, "pin:din.##_not:bit:20:out:For M=0 through 7, din.\\fI0M\\fR corresponds to the pin labeled\nIN\\fIM\\fR on the pinout diagram.  Other pins are shared with the encoder\nfunction, as follows:\n.RS 6\n.ta T 10 6\n.PP\n\\fBPin\tShared\\fR\n.PP\n\\fBLabel\twith\\fR\n.PP\ndin.8\tQZ0\n.PP\ndin.9\tQZ1\n.PP\ndin.10\tQZ2\n.PP\ndin.11\tQZ3\n.PP\ndin.12\tQB0\n.PP\ndin.13\tQB1\n.PP\ndin.14\tQB2\n.PP\ndin.15\tQB3\n.PP\ndin.16\tQA0\n.PP\ndin.17\tQA1\n.PP\ndin.18\tQA2\n.PP\ndin.19\tQA3\n.PP\n.RE\n.DT:None:None");
MODULE_INFO(linuxcnc, "param:communication_error:u32:0:rw:Incremented each time \npluto-servo.read detects an error code in the EPP status register.  While\nthis register is nonzero, new values are not being written to the Pluto-P\nboard, and the status of digital outputs and the PWM duty cycle of the PWM\noutputs will remain unchanged.  If the watchdog is enabled, it will activate\nsoon after the communication error is detected.  To continue after a\ncommunication error, set this parameter back to zero.:None:None");
MODULE_INFO(linuxcnc, "param:debug_0:s32:0:rw::None:None");
MODULE_INFO(linuxcnc, "param:debug_1:s32:0:rw:These parameters can display values which are useful to developers or for debugging the driver and firmware.  They are not useful for integrators or users.:None:None");
MODULE_INFO(linuxcnc, "funct:ppread:1:Read all the inputs from the pluto-servo board");
MODULE_INFO(linuxcnc, "funct:ppwrite:1:Write all the outputs on the pluto-servo board");
MODULE_INFO(linuxcnc, "see_also:The \\fIpluto_servo\\fR section in the HAL User Manual, which shows the location of each physical pin on the pluto board.");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO

int test_encoder = 0;
RTAPI_MP_INT(test_encoder, "Internally connect dout0..2 to QA0, QB0, QZ0 to test quadrature counting");

struct __comp_state {
    struct __comp_state *_next;
    hal_s32_t *encoder_count[4];
    hal_float_t *encoder_position[4];
    hal_float_t *encoder_velocity[4];
    hal_bit_t *encoder_reset[4];
    hal_bit_t *encoder_index_enable[4];
    hal_float_t *pwm_value[4];
    hal_bit_t *pwm_enable[4];
    hal_bit_t *dout[20];
    hal_bit_t *din[20];
    hal_bit_t *din_not[20];
    hal_float_t encoder_scale[4];
    hal_bit_t encoder_z_polarity;
    hal_float_t pwm_offset[4];
    hal_float_t pwm_scale[4];
    hal_float_t pwm_max_dc[4];
    hal_float_t pwm_min_dc[4];
    hal_bit_t pwm_pwmdir[4];
    hal_bit_t pwm_is_pdm;
    hal_bit_t dout_invert[20];
    hal_u32_t communication_error;
    hal_s32_t debug_0;
    hal_s32_t debug_1;
    void *_data;
};
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void ppread(struct __comp_state *__comp_inst, long period);
static void ppwrite(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg);
static void extra_cleanup(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    inst->_data = (char*)inst + sizeof(struct __comp_state);
    r = extra_setup(inst, prefix, extra_arg);
    if(r != 0) return r;
    for(j=0; j < (4); j++) {
        r = hal_pin_s32_newf(HAL_OUT, &(inst->encoder_count[j]), comp_id,
            "%s.encoder.%01d.count", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (4); j++) {
        r = hal_pin_float_newf(HAL_OUT, &(inst->encoder_position[j]), comp_id,
            "%s.encoder.%01d.position", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (4); j++) {
        r = hal_pin_float_newf(HAL_OUT, &(inst->encoder_velocity[j]), comp_id,
            "%s.encoder.%01d.velocity", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (4); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->encoder_reset[j]), comp_id,
            "%s.encoder.%01d.reset", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (4); j++) {
        r = hal_pin_bit_newf(HAL_IO, &(inst->encoder_index_enable[j]), comp_id,
            "%s.encoder.%01d.index-enable", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (4); j++) {
        r = hal_pin_float_newf(HAL_IN, &(inst->pwm_value[j]), comp_id,
            "%s.pwm.%01d.value", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (4); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->pwm_enable[j]), comp_id,
            "%s.pwm.%01d.enable", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (20); j++) {
        r = hal_pin_bit_newf(HAL_IN, &(inst->dout[j]), comp_id,
            "%s.dout.%02d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (20); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->din[j]), comp_id,
            "%s.din.%02d", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < (20); j++) {
        r = hal_pin_bit_newf(HAL_OUT, &(inst->din_not[j]), comp_id,
            "%s.din.%02d-not", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < 4; j++) {
        r = hal_param_float_newf(HAL_RW, &(inst->encoder_scale[j]), comp_id,
            "%s.encoder.%01d.scale", prefix, j);
        if(r != 0) return r;
    inst->encoder_scale[j] = 1;
    }
    r = hal_param_bit_newf(HAL_RW, &(inst->encoder_z_polarity), comp_id,
        "%s.encoder.z-polarity", prefix);
    if(r != 0) return r;
    for(j=0; j < 4; j++) {
        r = hal_param_float_newf(HAL_RW, &(inst->pwm_offset[j]), comp_id,
            "%s.pwm.%01d.offset", prefix, j);
        if(r != 0) return r;
    }
    for(j=0; j < 4; j++) {
        r = hal_param_float_newf(HAL_RW, &(inst->pwm_scale[j]), comp_id,
            "%s.pwm.%01d.scale", prefix, j);
        if(r != 0) return r;
    inst->pwm_scale[j] = 1;
    }
    for(j=0; j < 4; j++) {
        r = hal_param_float_newf(HAL_RW, &(inst->pwm_max_dc[j]), comp_id,
            "%s.pwm.%01d.max-dc", prefix, j);
        if(r != 0) return r;
    inst->pwm_max_dc[j] = 1;
    }
    for(j=0; j < 4; j++) {
        r = hal_param_float_newf(HAL_RW, &(inst->pwm_min_dc[j]), comp_id,
            "%s.pwm.%01d.min-dc", prefix, j);
        if(r != 0) return r;
    inst->pwm_min_dc[j] = 0;
    }
    for(j=0; j < 4; j++) {
        r = hal_param_bit_newf(HAL_RW, &(inst->pwm_pwmdir[j]), comp_id,
            "%s.pwm.%01d.pwmdir", prefix, j);
        if(r != 0) return r;
    inst->pwm_pwmdir[j] = 0;
    }
    r = hal_param_bit_newf(HAL_RW, &(inst->pwm_is_pdm), comp_id,
        "%s.pwm.is-pdm", prefix);
    if(r != 0) return r;
    for(j=0; j < 20; j++) {
        r = hal_param_bit_newf(HAL_RW, &(inst->dout_invert[j]), comp_id,
            "%s.dout.%02d-invert", prefix, j);
        if(r != 0) return r;
    }
    r = hal_param_u32_newf(HAL_RW, &(inst->communication_error), comp_id,
        "%s.communication-error", prefix);
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RW, &(inst->debug_0), comp_id,
        "%s.debug-0", prefix);
    if(r != 0) return r;
    r = hal_param_s32_newf(HAL_RW, &(inst->debug_1), comp_id,
        "%s.debug-1", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.ppread", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))ppread, inst, 1, 0, comp_id);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s.ppwrite", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))ppwrite, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}
int rtapi_app_main(void) {
    int r = 0;
    comp_id = hal_init("pluto_servo");
    if(comp_id < 0) return comp_id;
    r = export("pluto-servo", 0);
    if(r) {
    extra_cleanup();
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    extra_cleanup();
    hal_exit(comp_id);
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef encoder_count
#define encoder_count(i) (*(__comp_inst->encoder_count[i]))
#undef encoder_position
#define encoder_position(i) (*(__comp_inst->encoder_position[i]))
#undef encoder_velocity
#define encoder_velocity(i) (*(__comp_inst->encoder_velocity[i]))
#undef encoder_reset
#define encoder_reset(i) (0+*(__comp_inst->encoder_reset[i]))
#undef encoder_index_enable
#define encoder_index_enable(i) (*(__comp_inst->encoder_index_enable[i]))
#undef pwm_value
#define pwm_value(i) (0+*(__comp_inst->pwm_value[i]))
#undef pwm_enable
#define pwm_enable(i) (0+*(__comp_inst->pwm_enable[i]))
#undef dout
#define dout(i) (0+*(__comp_inst->dout[i]))
#undef din
#define din(i) (*(__comp_inst->din[i]))
#undef din_not
#define din_not(i) (*(__comp_inst->din_not[i]))
#undef encoder_scale
#define encoder_scale(i) (__comp_inst->encoder_scale[i])
#undef encoder_z_polarity
#define encoder_z_polarity (__comp_inst->encoder_z_polarity)
#undef pwm_offset
#define pwm_offset(i) (__comp_inst->pwm_offset[i])
#undef pwm_scale
#define pwm_scale(i) (__comp_inst->pwm_scale[i])
#undef pwm_max_dc
#define pwm_max_dc(i) (__comp_inst->pwm_max_dc[i])
#undef pwm_min_dc
#define pwm_min_dc(i) (__comp_inst->pwm_min_dc[i])
#undef pwm_pwmdir
#define pwm_pwmdir(i) (__comp_inst->pwm_pwmdir[i])
#undef pwm_is_pdm
#define pwm_is_pdm (__comp_inst->pwm_is_pdm)
#undef dout_invert
#define dout_invert(i) (__comp_inst->dout_invert[i])
#undef communication_error
#define communication_error (__comp_inst->communication_error)
#undef debug_0
#define debug_0 (__comp_inst->debug_0)
#undef debug_1
#define debug_1 (__comp_inst->debug_1)
#undef data
#define data (*(internal*)(__comp_inst->_data))


#line 192 "hal/drivers/pluto_servo.comp"


typedef struct {
    int64_t last_index[4];
    int64_t last_count[4];
    int64_t reset_count[4];
} internal;

#define W 14
#define MASK ((1<<W)-1)

int PWM(int enable, double value, double offset, double scale, double min_dc, double max_dc, int dio0, int dio1, int is_pdm, int is_pwmdir) {
    int result;
    if(enable == 0) return 0;

    value = value / scale + offset;
    if(value < -max_dc) value = -max_dc;
    else if(value > -min_dc && value < 0) value = -min_dc;
    else if(value > 0 && value < min_dc) value = min_dc;
    else if(value > max_dc) value = max_dc;

    value = 2047 * value;
    if(value < -2047) value = -2047;
    if(value > 2047) value = 2047;

    if(value < 0) {
	if(is_pwmdir) {
	     result = (1<<13) | (int)(-value);
	} else {
	     result = (1<<15) | (int)(-value);
	}
    } else result = value;
    if(is_pdm) result |= 1<<14;
    if(dio0) result ^= 1<<12;
    if(dio1) result ^= 1<<13;

    return result;
}

FUNCTION(ppwrite) {
    int r = 0;
    int i;
    if(communication_error) return;

    EPP_ADDR(0);

    for(i=0; i<4; i++) {
        if(pwm_max_dc(i) > 1) pwm_max_dc(i) = 1;
        else if(pwm_max_dc(i) < 0) pwm_max_dc(i) = 0;
        if(pwm_min_dc(i) < 0) pwm_min_dc(i) = 0;
        else if(pwm_min_dc(i) > pwm_max_dc(i)) pwm_min_dc(i) = pwm_max_dc(i);
    }

#define D(x) (!dout(x) ^ !dout_invert(x))
#define P(x,y) PWM(pwm_enable(x), pwm_value(x), pwm_offset(x), pwm_scale(x), \
        pwm_min_dc(x), pwm_max_dc(x), D(y), D(y+1), pwm_is_pdm, pwm_pwmdir(x))
    write32( P(0,10) | (P(1, 12) << 16));
    write32( P(2,14) | (P(3, 16) << 16));

    for(i=0; i<10; i++) {
        if(!dout(i) ^ !dout_invert(i)) r |= (1<<i);
    }
    if (encoder_z_polarity) r |= 0x8000;
    if (watchdog) r |= 0x4000;
    if (test_encoder) r |= 0x2000;
    write16(r);
}

FUNCTION(ppread) {
    int i;
    __u32 ppdata;

    EPP_ADDR(0);
    EPP_DIR_READ();

    for(i=0; i<4; i++) {
        int64_t count, index;
	int newlow, indlow, indexed;
        int reset;
        ppdata = read32();
        reset = encoder_reset(i);
        if(i == 0) {
            int status = inb(ioaddr+1) & 1;
            if(status) {
                communication_error ++;
		pluto_clear_error_register();
            }
            if(communication_error) { EPP_DIR_WRITE(); return; }
        }

	newlow = ppdata & MASK;
	indlow = (ppdata >> W) & MASK;
	indexed = ppdata & (1<<(2*W));

        count = extend(data.last_count[i], newlow, W);
	if(indexed)
	    index = extend(count, indlow, W);
	else
	    index = data.last_index[i];

        if(encoder_index_enable(i) && indexed) {
            encoder_index_enable(i) = 0;
            data.reset_count[i] = index;
        }
        if(reset) encoder_velocity(i) = 0;
        else encoder_velocity(i) = (count - data.last_count[i]) /
            encoder_scale(i) / fperiod;
        data.last_index[i] = index;
        data.last_count[i] = count;
        if(reset) data.reset_count[i] = count;
        encoder_count(i) = count - data.reset_count[i];
        encoder_position(i) = encoder_count(i) / encoder_scale(i);

        if(i == 0) {
            debug_0 = ppdata; debug_1 = count;
        }
    }

    ppdata = read32();

    for(i=0; i< 20; i++) {
        int b = ppdata & (1<<i);
        din(i) = !!b; din_not(i) = !b;
    }

    EPP_DIR_WRITE();
}

#include "hal/drivers/pluto_servo_rbf.h"

EXTRA_SETUP() {
    return pluto_setup(firmware);
}

EXTRA_CLEANUP() {
    pluto_cleanup();
}

// vim:sts=4:et:sw=4

static int __comp_get_data_size(void) { return sizeof(internal); }
