
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:44 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "abs_s32v2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:abs_s32v2:Compute the absolute value and sign of the input signal");
MODULE_INFO(machinekit, "pin_ptr:in:s32:None:in:input value:None");
MODULE_INFO(machinekit, "pin_ptr:out:s32:None:out:output value, always non-negative:None");
MODULE_INFO(machinekit, "pin_ptr:sign:bit:None:out:Sign of input, false for positive, true for negative:None");
MODULE_INFO(machinekit, "pin_ptr:is_positive:bit:None:out:true if input is positive, false if input is 0 or negative:None");
MODULE_INFO(machinekit, "pin_ptr:is_negative:bit:None:out:true if input is negative, false if input is 0 or positive:None");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    s32_pin_ptr in;
    s32_pin_ptr out;
    bit_pin_ptr sign;
    bit_pin_ptr is_positive;
    bit_pin_ptr is_negative;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int abs_s32v2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->in = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.in", name);
    if (s32_pin_null(ip->in))
            return _halerrno;


    ip->out = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (s32_pin_null(ip->out))
            return _halerrno;


    ip->sign = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.sign", name);
    if (bit_pin_null(ip->sign))
            return _halerrno;


    ip->is_positive = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.is-positive", name);
    if (bit_pin_null(ip->is_positive))
            return _halerrno;


    ip->is_negative = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.is-negative", name);
    if (bit_pin_null(ip->is_negative))
            return _halerrno;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = abs_s32v2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int abs_s32v2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (ip->in)
#undef out
#define out (ip->out)
#undef sign
#define sign (ip->sign)
#undef is_positive
#define is_positive (ip->is_positive)
#undef is_negative
#define is_negative (ip->is_negative)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 27 "hal/i_components/abs_s32v2.icomp"
FUNCTION(_) {
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t tmp = gs(in);
    if ( tmp >= 0 ) 
        {
        sb(sign, false);
        ss(out, tmp);
    } else {
        sb(sign, true);
        ss(out, -tmp);
    }

    if (tmp > 0) 
        sb(is_positive, true);
    else 
        sb(is_positive, false);

    if (tmp < 0) 
        sb(is_negative, true);
    else 
        sb(is_negative, false);

return 0;
}


