
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:44 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "at_pidv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:at_pidv2:HAL component that provides Proportional     Integeral/Derivative control loops.  It is a realtime component.");
MODULE_INFO(machinekit, "descr:   This file, 'at_pid.icomp', is a HAL component that provides Proportional/\n  Integeral/Derivative control loops.  It is a realtime component.\n\n  In this documentation, it is assumed that we are discussing position\n  loops.  However this component can be used to implement other loops\n  such as speed loops, torch height control, and others.\n\n  The three most important pins are 'command', 'feedback', and\n  'output'.  For a position loop, 'command' and 'feedback' are\n  in position units.  For a linear axis, this could be inches,\n  mm, metres, or whatever is relavent.  Likewise, for a angular\n  axis, it could be degrees, radians, etc.  The units of the\n  'output' pin represent the change needed to make the feedback\n  match the command.  As such, for a position loop 'Output' is\n  a velocity, in inches/sec, mm/sec, degrees/sec, etc.\n\n  Each loop has several other pins as well.  'error' is equal to\n  'command' minus 'feedback'.  'enable' is a bit that enables\n  the loop.  If 'enable' is false, all integrators are reset,\n  and the output is forced to zero.  If 'enable' is true, the\n  loop operates normally.\n\n  The PID gains, limits, and other 'tunable' features of the\n  loop are implemented as parameters.  These are as follows:\n\n  Pgain        Proportional gain\n  Igain        Integral gain\n  Dgain        Derivative gain\n  bias         Constant offset on output\n  FF0          Zeroth order Feedforward gain\n  FF1          First order Feedforward gain\n  FF2          Second order Feedforward gain\n  deadband     Amount of error that will be ignored\n  maxerror     Limit on error\n  maxerrorI    Limit on error integrator\n  maxerrorD    Limit on error differentiator\n  maxcmdD      Limit on command differentiator\n  maxcmdDD     Limit on command 2nd derivative\n  maxoutput    Limit on output value\n\n  All of the limits (max____) are implemented such that if the\n  parameter value is zero, there is no limit.\n\n  A number of internal values which may be usefull for testing\n  and tuning are also available as parameters.  To avoid cluttering\n  the parameter list, these are only exported if \"debug=1\" is\n  specified on the insmod command line.\n\n  errorI       Integral of error\n  errorD       Derivative of error\n  cmdD     Derivative of the command\n  cmdDd    2nd derivative of the command\n\n  The PID loop calculations are as follows (see the code for\n  all the nitty gritty details):\n\n  error = command - feedback\n  if ( fabs(error) < deadband ) then error = 0\n  limit error to +/- maxerror\n  errorI += error * period\n  limit errorI to +/- maxerrorI\n  errorD = (error - previouserror) / period\n  limit errorD to +/- paxerrorD\n  cmdD = (command - previouscommand) / period\n  limit cmdD to +/- maxcmdD\n  cmdDd = (cmdD - previouscmdD) / period\n  limit cmdDd to +/- maxcmdDD\n  output = bias + error * Pgain + errorI * Igain +\n           errorD * Dgain + command * FF0 + cmdD * FF1 +\n           cmdDd * FF2\n  limit output to +/- maxoutput\n\n  This component exports one function called '<name>.do-pid-calcs'\n\n");
MODULE_INFO(machinekit, "pin_ptr:deadband:float:None:in:Amount of error that will be ignored:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxerror:float:None:in:Limit on error:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxerrorI:float:None:in:Limit on error integrator:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxerrorD:float:None:in:Limit on error differentiator:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxcmdD:float:None:in:Limit on command differentiator:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxcmdDD:float:None:in:Limit on command 2nd derivative:0.0");
MODULE_INFO(machinekit, "pin_ptr:bias:float:None:io:Constant offset on output:0.0");
MODULE_INFO(machinekit, "pin_ptr:Pgain:float:None:io:Proportional gain:1.0");
MODULE_INFO(machinekit, "pin_ptr:Igain:float:None:io:Integral gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:Dgain:float:None:io:Derivative gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:FF0:float:None:io:Zeroth order Feedforward gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:FF1:float:None:io:First order Feedforward gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:FF2:float:None:io:Second order Feedforward gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxoutput:float:None:io:Limit on output value:0.0");
MODULE_INFO(machinekit, "pin_ptr:tuneEffort:float:None:io: Control effort for limit cycle.:0.5");
MODULE_INFO(machinekit, "pin_ptr:tuneCycles:u32:None:io::50");
MODULE_INFO(machinekit, "pin_ptr:tuneType:u32:None:io::0");
MODULE_INFO(machinekit, "pin_ptr:errorI:float:None:out:Integral of error:None");
MODULE_INFO(machinekit, "pin_ptr:errorD:float:None:out:Derivative of error:None");
MODULE_INFO(machinekit, "pin_ptr:commandD:float:None:out:Derivative of the command:None");
MODULE_INFO(machinekit, "pin_ptr:commandDD:float:None:out:2nd derivative of the command:None");
MODULE_INFO(machinekit, "pin_ptr:ultimateGain:float:None:out:Calc by auto-tune from limit cycle.:None");
MODULE_INFO(machinekit, "pin_ptr:ultimatePeriod:float:None:io:Calc by auto-tune from limit cycle.:None");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:Enable/disabled the PID loop:0");
MODULE_INFO(machinekit, "pin_ptr:command:float:None:in:Commanded value:0.0");
MODULE_INFO(machinekit, "pin_ptr:feedback:float:None:in:Feedback input:0.0");
MODULE_INFO(machinekit, "pin_ptr:error:float:None:out:Current error:None");
MODULE_INFO(machinekit, "pin_ptr:output:float:None:out:Ouput value:None");
MODULE_INFO(machinekit, "pin_ptr:tuneMode:bit:None:in:0=PID, 1=tune.:0");
MODULE_INFO(machinekit, "pin_ptr:tuneStart:bit:None:io:Set to 1 to start an auto-tune cycle.                         Clears automatically when the cycle has finished.:0");
MODULE_INFO(machinekit, "funct:do_pid_calcs:1:");
MODULE_INFO(machinekit, "license:GPL v2");
MODULE_INFO(machinekit, "author:John Kasunich");
MODULE_LICENSE("GPL v2");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    float_pin_ptr deadband;
    float_pin_ptr maxerror;
    float_pin_ptr maxerrorI;
    float_pin_ptr maxerrorD;
    float_pin_ptr maxcmdD;
    float_pin_ptr maxcmdDD;
    float_pin_ptr bias;
    float_pin_ptr Pgain;
    float_pin_ptr Igain;
    float_pin_ptr Dgain;
    float_pin_ptr FF0;
    float_pin_ptr FF1;
    float_pin_ptr FF2;
    float_pin_ptr maxoutput;
    float_pin_ptr tuneEffort;
    u32_pin_ptr tuneCycles;
    u32_pin_ptr tuneType;
    float_pin_ptr errorI;
    float_pin_ptr errorD;
    float_pin_ptr commandD;
    float_pin_ptr commandDD;
    float_pin_ptr ultimateGain;
    float_pin_ptr ultimatePeriod;
    bit_pin_ptr enable;
    float_pin_ptr command;
    float_pin_ptr feedback;
    float_pin_ptr error;
    float_pin_ptr output;
    bit_pin_ptr tuneMode;
    bit_pin_ptr tuneStart;
    hal_float_t prevError;
    hal_float_t prevCmd;
    hal_float_t limitState;
    hal_u32_t cycleCount;
    hal_u32_t cyclePeriod;
    hal_float_t cycleAmplitude;
    hal_float_t totalTime;
    hal_float_t avgAmplitude;
    hal_u32_t state;
    hal_u32_t mode;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int do_pid_calcs(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->deadband = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.deadband", name);
    if (float_pin_null(ip->deadband))
            return _halerrno;

    set_float_pin(ip->deadband, 0.0);


    ip->maxerror = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxerror", name);
    if (float_pin_null(ip->maxerror))
            return _halerrno;

    set_float_pin(ip->maxerror, 0.0);


    ip->maxerrorI = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxerrorI", name);
    if (float_pin_null(ip->maxerrorI))
            return _halerrno;

    set_float_pin(ip->maxerrorI, 0.0);


    ip->maxerrorD = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxerrorD", name);
    if (float_pin_null(ip->maxerrorD))
            return _halerrno;

    set_float_pin(ip->maxerrorD, 0.0);


    ip->maxcmdD = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxcmdD", name);
    if (float_pin_null(ip->maxcmdD))
            return _halerrno;

    set_float_pin(ip->maxcmdD, 0.0);


    ip->maxcmdDD = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxcmdDD", name);
    if (float_pin_null(ip->maxcmdDD))
            return _halerrno;

    set_float_pin(ip->maxcmdDD, 0.0);


    ip->bias = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.bias", name);
    if (float_pin_null(ip->bias))
            return _halerrno;

    set_float_pin(ip->bias, 0.0);


    ip->Pgain = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.Pgain", name);
    if (float_pin_null(ip->Pgain))
            return _halerrno;

    set_float_pin(ip->Pgain, 1.0);


    ip->Igain = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.Igain", name);
    if (float_pin_null(ip->Igain))
            return _halerrno;

    set_float_pin(ip->Igain, 0.0);


    ip->Dgain = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.Dgain", name);
    if (float_pin_null(ip->Dgain))
            return _halerrno;

    set_float_pin(ip->Dgain, 0.0);


    ip->FF0 = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.FF0", name);
    if (float_pin_null(ip->FF0))
            return _halerrno;

    set_float_pin(ip->FF0, 0.0);


    ip->FF1 = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.FF1", name);
    if (float_pin_null(ip->FF1))
            return _halerrno;

    set_float_pin(ip->FF1, 0.0);


    ip->FF2 = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.FF2", name);
    if (float_pin_null(ip->FF2))
            return _halerrno;

    set_float_pin(ip->FF2, 0.0);


    ip->maxoutput = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.maxoutput", name);
    if (float_pin_null(ip->maxoutput))
            return _halerrno;

    set_float_pin(ip->maxoutput, 0.0);


    ip->tuneEffort = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.tuneEffort", name);
    if (float_pin_null(ip->tuneEffort))
            return _halerrno;

    set_float_pin(ip->tuneEffort, 0.5);


    ip->tuneCycles = halx_pin_u32_newf(HAL_IO, owner_id,
            "%s.tuneCycles", name);
    if (u32_pin_null(ip->tuneCycles))
            return _halerrno;

    set_u32_pin(ip->tuneCycles, 50);


    ip->tuneType = halx_pin_u32_newf(HAL_IO, owner_id,
            "%s.tuneType", name);
    if (u32_pin_null(ip->tuneType))
            return _halerrno;

    set_u32_pin(ip->tuneType, 0);


    ip->errorI = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.errorI", name);
    if (float_pin_null(ip->errorI))
            return _halerrno;


    ip->errorD = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.errorD", name);
    if (float_pin_null(ip->errorD))
            return _halerrno;


    ip->commandD = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.commandD", name);
    if (float_pin_null(ip->commandD))
            return _halerrno;


    ip->commandDD = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.commandDD", name);
    if (float_pin_null(ip->commandDD))
            return _halerrno;


    ip->ultimateGain = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.ultimateGain", name);
    if (float_pin_null(ip->ultimateGain))
            return _halerrno;


    ip->ultimatePeriod = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.ultimatePeriod", name);
    if (float_pin_null(ip->ultimatePeriod))
            return _halerrno;


    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;

    set_bit_pin(ip->enable, 0);


    ip->command = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.command", name);
    if (float_pin_null(ip->command))
            return _halerrno;

    set_float_pin(ip->command, 0.0);


    ip->feedback = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.feedback", name);
    if (float_pin_null(ip->feedback))
            return _halerrno;

    set_float_pin(ip->feedback, 0.0);


    ip->error = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.error", name);
    if (float_pin_null(ip->error))
            return _halerrno;


    ip->output = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.output", name);
    if (float_pin_null(ip->output))
            return _halerrno;


    ip->tuneMode = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.tuneMode", name);
    if (bit_pin_null(ip->tuneMode))
            return _halerrno;

    set_bit_pin(ip->tuneMode, 0);


    ip->tuneStart = halx_pin_bit_newf(HAL_IO, owner_id,
            "%s.tuneStart", name);
    if (bit_pin_null(ip->tuneStart))
            return _halerrno;

    set_bit_pin(ip->tuneStart, 0);

    ip->prevError = 0.0;
    ip->prevCmd = 0.0;
    ip->limitState = 0.0;
    ip->state = 0;
    ip->mode = 0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t do_pid_calcs_xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = do_pid_calcs,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.do-pid-calcs", name);
    r = hal_export_xfunctf(&do_pid_calcs_xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int name(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef deadband
#define deadband (ip->deadband)
#undef maxerror
#define maxerror (ip->maxerror)
#undef maxerrorI
#define maxerrorI (ip->maxerrorI)
#undef maxerrorD
#define maxerrorD (ip->maxerrorD)
#undef maxcmdD
#define maxcmdD (ip->maxcmdD)
#undef maxcmdDD
#define maxcmdDD (ip->maxcmdDD)
#undef bias
#define bias (ip->bias)
#undef Pgain
#define Pgain (ip->Pgain)
#undef Igain
#define Igain (ip->Igain)
#undef Dgain
#define Dgain (ip->Dgain)
#undef FF0
#define FF0 (ip->FF0)
#undef FF1
#define FF1 (ip->FF1)
#undef FF2
#define FF2 (ip->FF2)
#undef maxoutput
#define maxoutput (ip->maxoutput)
#undef tuneEffort
#define tuneEffort (ip->tuneEffort)
#undef tuneCycles
#define tuneCycles (ip->tuneCycles)
#undef tuneType
#define tuneType (ip->tuneType)
#undef errorI
#define errorI (ip->errorI)
#undef errorD
#define errorD (ip->errorD)
#undef commandD
#define commandD (ip->commandD)
#undef commandDD
#define commandDD (ip->commandDD)
#undef ultimateGain
#define ultimateGain (ip->ultimateGain)
#undef ultimatePeriod
#define ultimatePeriod (ip->ultimatePeriod)
#undef enable
#define enable (ip->enable)
#undef command
#define command (ip->command)
#undef feedback
#define feedback (ip->feedback)
#undef error
#define error (ip->error)
#undef output
#define output (ip->output)
#undef tuneMode
#define tuneMode (ip->tuneMode)
#undef tuneStart
#define tuneStart (ip->tuneStart)
#undef prevError
#define prevError (ip->prevError)
#undef prevCmd
#define prevCmd (ip->prevCmd)
#undef limitState
#define limitState (ip->limitState)
#undef cycleCount
#define cycleCount (ip->cycleCount)
#undef cyclePeriod
#define cyclePeriod (ip->cyclePeriod)
#undef cycleAmplitude
#define cycleAmplitude (ip->cycleAmplitude)
#undef totalTime
#define totalTime (ip->totalTime)
#undef avgAmplitude
#define avgAmplitude (ip->avgAmplitude)
#undef state
#define state (ip->state)
#undef mode
#define mode (ip->mode)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 150 "hal/i_components/at_pidv2.icomp"

#include "rtapi_math.h"

#define PI                              3.141592653589

typedef enum {
    STATE_PID = 0u,
    STATE_TUNE_IDLE = 1u,
    STATE_TUNE_START = 2u,
    STATE_TUNE_POS = 3u,
    STATE_TUNE_NEG = 4u,
    STATE_TUNE_ABORT = 5u
} State;

//static State state;

typedef enum {
    TYPE_PID = 0u,
    TYPE_PI_FF1 = 1u
} Mode;

//static Mode mode;

static void Pid_CycleEnd(void *arg)
{
struct inst_data *ip = arg;
    cycleCount++;
    avgAmplitude += cycleAmplitude / gu(tuneCycles);
    cycleAmplitude = 0;
    totalTime += cyclePeriod * 0.000000001;
    cyclePeriod = 0;
}

/*
 * Perform an auto-tune operation. Sets up a limit cycle using the specified
 * tune effort. Averages the amplitude and period over the specifed number of
 * cycles. This characterizes the process and determines the ultimate gain
 * and period, which are then used to calculate PID.
 *
 * CO(t) = P * [ e(t) + 1/Ti * (f e(t)dt) - Td * (d/dt PV(t)) ]
 *
 * Pu = 4/PI * tuneEffort / responseAmplitude
 * Ti = 0.5 * responsePeriod
 * Td = 0.125 * responsePeriod
 *
 * P = 0.6 * Pu
 * I = P * 1/Ti
 * D = P * Td
 */
static void Pid_AutoTune(void *arg, long period)
{
struct inst_data *ip = arg;
float lerror;

    // Calculate the error.
    lerror = gf(command) - gf(feedback);
    sf(error, lerror);

    // Check if enabled and if still in tune mode.
    if(!gb(enable) || !gb(tuneMode)){
        state = STATE_TUNE_ABORT;
    }

    switch(state){
    case STATE_TUNE_IDLE:
        // Wait for tune start command.
        if(gb(tuneStart))
            state = STATE_TUNE_START;
        break;

    case STATE_TUNE_START:
        // Initialize tuning variables and start limit cycle.
        state = STATE_TUNE_POS;
        cycleCount = 0;
        cyclePeriod = 0;
        cycleAmplitude = 0;
        totalTime = 0;
        avgAmplitude = 0;
        sf(ultimateGain, 0);
        sf(ultimatePeriod, 0);
        sf(output, gf(bias) + rtapi_fabs(gf(tuneEffort)));
        break;

    case STATE_TUNE_POS:
    case STATE_TUNE_NEG:
        cyclePeriod += period;

        if(lerror < 0.0){
            // Check amplitude.
            if(-lerror > cycleAmplitude)
                cycleAmplitude = -lerror;

            // Check for end of cycle.
            if(state == STATE_TUNE_POS){
                state = STATE_TUNE_NEG;
                Pid_CycleEnd(arg);
            }

            // Update output so user can ramp effort until movement occurs.
            sf(output, gf(bias) - rtapi_fabs(gf(tuneEffort)));
        }else{
            // Check amplitude.
            if(lerror > cycleAmplitude)
                cycleAmplitude = lerror;

            // Check for end of cycle.
            if(state == STATE_TUNE_NEG){
                state = STATE_TUNE_POS;
                Pid_CycleEnd(arg);
            }

            // Update output so user can ramp effort until movement occurs.
            sf(output, gf(bias) + rtapi_fabs(gf(tuneEffort)));
        }

        // Check if the last cycle just ended. This is really the number
        // of half cycles.
        if(cycleCount < gu(tuneCycles))
            break;

        // Calculate PID.
        sf(ultimateGain, (4.0 * rtapi_fabs(gf(tuneEffort)))/(PI * avgAmplitude));
        sf(ultimatePeriod, 2.0 * totalTime / gu(tuneCycles));
        sf(FF0, 0);
        sf(FF2, 0);

        if(gu(tuneType) == TYPE_PID){
            // PID.
            sf(Pgain, (0.6 * gf(ultimateGain)));
            sf(Igain, (gf(Pgain) / (gf(ultimatePeriod) / 2.0)));
            sf(Dgain, (gf(Pgain) * (gf(ultimatePeriod) / 8.0)));
            sf(FF1, 0);
        }else{
            // PI FF1.
            sf(Pgain, (0.45 * gf(ultimateGain)));
            sf(Igain, (gf(Pgain) / (gf(ultimatePeriod) / 1.2)));
            sf(Dgain, 0);

            // Scaling must be set so PID output is in user units per second.
            sf(FF1, 0);
        }

        // Fall through.

    case STATE_TUNE_ABORT:
    default:
        // Force output to zero.
        sf(output, 0);

        // Abort any tuning cycle in progress.
        sb(tuneStart, 0);
        state = (gb(tuneMode))? STATE_TUNE_IDLE: STATE_PID;
    }
}





FUNCTION(do_pid_calcs)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_float_t  lperiod, periodRecip;
hal_float_t  prevCmdD, lerror, loutput;

    if(state != STATE_PID){
        Pid_AutoTune(arg, period);
        return 0;
    }

    // Calculate the error.
    lerror = gf(command) - gf(feedback);

    // Store error to error pin.
    sf(error, lerror);

    // Check for tuning mode request.
    if(gb(tuneMode)){
        sf(errorI, 0);
        prevError = 0;
        sf(errorD, 0);
        prevCmd = 0;
        limitState = 0;
        sf(commandD, 0);
        sf(commandDD, 0);

        // Force output to zero.
        sf(output, 0);

        // Switch to tuning mode.
        state = STATE_TUNE_IDLE;

        return 0;
    }

    // Precalculate some timing constants.
    lperiod = period * 0.000000001;
    periodRecip = 1.0 / lperiod;

    // Apply error limits.
    if(gf(maxerror) != 0.0){
        if(lerror > gf(maxerror)){
            lerror = gf(maxerror);
        }else if(lerror < -gf(maxerror)){
            lerror = -gf(maxerror);
        }
    }

    // Apply the deadband.
    if(lerror > gf(deadband)){
        lerror -= gf(deadband);
    }else if(lerror < -gf(deadband)){
        lerror += gf(deadband);
    }else{
        lerror = 0;
    }

    // Calculate derivative term.
    sf(errorD, (lerror - prevError) * periodRecip);
    prevError = lerror;

    // Apply derivative limits.
    if(gf(maxerrorD) != 0.0){
        if(gf(errorD) > gf(maxerrorD)){
            sf(errorD, gf(maxerrorD));
        }else if(gf(errorD) < -gf(maxerrorD)){
            sf(errorD, -gf(maxerrorD));
        }
    }

    // Calculate derivative of command.
    // Save old value for 2nd derivative calc later.
    prevCmdD = gf(commandD);
    sf(commandD, (gf(command) - prevCmd) * periodRecip);
    prevCmd = gf(command);

    // Apply derivative limits.
    if(gf(maxcmdD) != 0.0){
        if(gf(commandD) > gf(maxcmdD)){
            sf(commandD, gf(maxcmdD));
        }else if(gf(commandD) < -gf(maxcmdD)){
            sf(commandD, -gf(maxcmdD));
        }
    }

    // Calculate 2nd derivative of command.
    sf(commandDD, (gf(commandD) - prevCmdD) * periodRecip);

    // Apply 2nd derivative limits.
    if(gf(maxcmdDD) != 0.0){
        if(gf(commandDD) > gf(maxcmdDD)){
            sf(commandDD, gf(maxcmdDD));
        }else if(gf(commandDD) < -gf(maxcmdDD)){
            sf(commandDD, -gf(maxcmdDD));
        }
    }

    // Check if enabled.
    if(!gb(enable)){
        // Reset integrator.
        sf(errorI, 0);

        // Force output to zero.
        sf(output, 0);
        limitState = 0;

        return 0;
    }

    // If output is in limit, don't let integrator wind up.
    if(lerror * limitState <= 0.0){
        // Compute integral term.
        sf(errorI, gf(errorI) + lerror * lperiod);
    }

    // Apply integrator limits.
    if(gf(maxerrorI) != 0.0){
        if(gf(errorI) > gf(maxerrorI)){
            sf(errorI, gf(maxerrorI));
        }else if(gf(errorI) < -gf(maxerrorI)){
            sf(errorI, -gf(maxerrorI));
        }
    }

    // Calculate the output value.
    loutput = gf(bias) + gf(Pgain) * lerror + gf(Igain) * gf(errorI) +
        gf(Dgain) * gf(errorD);
    loutput += gf(command) * gf(FF0) + gf(commandD) * gf(FF1) +
        gf(commandDD) * gf(FF2);

    // Apply output limits.
    if(gf(maxoutput) != 0.0){
        if(loutput > gf(maxoutput)){
            loutput = gf(maxoutput);
            limitState = 1;
        }else if(loutput < -gf(maxoutput)){
            loutput = -gf(maxoutput);
            limitState = -1;
        }else{
            limitState = 0;
        }
    }

    // Write final output value to output pin.
    sf(output, loutput);
    return 0;
}



