
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:44 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "biquad";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:biquad:Biquad IIR filter");
MODULE_INFO(machinekit, "descr:Biquad IIR filter. Implements the following transfer function:\nH(z) = (n0 + n1z-1 + n2z-2) / (1+ d1z-1 + d2z-2)");
MODULE_INFO(machinekit, "pin:in:float:None:in:Filter input.:None");
MODULE_INFO(machinekit, "pin:out:float:None:out:Filter output.:None");
MODULE_INFO(machinekit, "pin:enable:bit:None:in:Filter enable. When false, the in is passed to out without any filtering. A transition from false to true causes filter coefficients to be calculated according to parameters:false");
MODULE_INFO(machinekit, "pin:valid:bit:None:out:When false, indicates an error occured when caclulating filter coefficients.:false");
MODULE_INFO(machinekit, "pin:type_:u32:None:io:Filter type determines the type of filter coefficients calculated. When 0, coefficients must be loaded directly. When 1, a low pass filter is created. When 2, a notch filter is created.:0");
MODULE_INFO(machinekit, "pin:f0:float:None:io:The corner frequency of the filter.:250.0");
MODULE_INFO(machinekit, "pin:Q:float:None:io:The Q of the filter.:0.7071");
MODULE_INFO(machinekit, "pin:d1:float:None:io:1st-delayed denominator coef:0.0");
MODULE_INFO(machinekit, "pin:d2:float:None:io:2nd-delayed denominator coef:0.0");
MODULE_INFO(machinekit, "pin:n0:float:None:io:non-delayed numerator coef:1.0");
MODULE_INFO(machinekit, "pin:n1:float:None:io:1st-delayed numerator coef:0.0");
MODULE_INFO(machinekit, "pin:n2:float:None:io:2nd-delayed numerator coef:0.0");
MODULE_INFO(machinekit, "pin:s1:float:None:io::0.0");
MODULE_INFO(machinekit, "pin:s2:float:None:io::0.0");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_float_t *in;
    hal_float_t *out;
    hal_bit_t *enable;
    hal_bit_t *valid;
    hal_u32_t *type_;
    hal_float_t *f0;
    hal_float_t *Q;
    hal_float_t *d1;
    hal_float_t *d2;
    hal_float_t *n0;
    hal_float_t *n1;
    hal_float_t *n2;
    hal_float_t *s1;
    hal_float_t *s2;
    hal_bit_t lastEnable;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int biquad_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

static int extra_inst_setup(
struct inst_data* ip, const char *name, int argc,
char* const *argv);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_float_newf(HAL_IN, &(ip->in), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->enable), owner_id,
            "%s.enable", name);
    if(r != 0) return r;

    *(ip->enable) = false;
    r = hal_pin_bit_newf(HAL_OUT, &(ip->valid), owner_id,
            "%s.valid", name);
    if(r != 0) return r;

    *(ip->valid) = false;
    r = hal_pin_u32_newf(HAL_IO, &(ip->type_), owner_id,
            "%s.type", name);
    if(r != 0) return r;

    *(ip->type_) = 0;
    r = hal_pin_float_newf(HAL_IO, &(ip->f0), owner_id,
            "%s.f0", name);
    if(r != 0) return r;

    *(ip->f0) = 250.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->Q), owner_id,
            "%s.Q", name);
    if(r != 0) return r;

    *(ip->Q) = 0.7071;
    r = hal_pin_float_newf(HAL_IO, &(ip->d1), owner_id,
            "%s.d1", name);
    if(r != 0) return r;

    *(ip->d1) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->d2), owner_id,
            "%s.d2", name);
    if(r != 0) return r;

    *(ip->d2) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->n0), owner_id,
            "%s.n0", name);
    if(r != 0) return r;

    *(ip->n0) = 1.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->n1), owner_id,
            "%s.n1", name);
    if(r != 0) return r;

    *(ip->n1) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->n2), owner_id,
            "%s.n2", name);
    if(r != 0) return r;

    *(ip->n2) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->s1), owner_id,
            "%s.s1", name);
    if(r != 0) return r;

    *(ip->s1) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->s2), owner_id,
            "%s.s2", name);
    if(r != 0) return r;

    *(ip->s2) = 0.0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = biquad_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;
int k;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    // if the extra_inst_setup returns non zero will abort module creation
    k = extra_inst_setup(ip, name, argc, argv);
    if(k != 0)
        return k;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int biquad_(void *arg, const hal_funct_args_t *fa)
// if the extra_inst_setup returns non zero it will abort the module creation
#undef EXTRA_INST_SETUP
#define EXTRA_INST_SETUP() \
static int extra_inst_setup( \
struct inst_data *ip, const char *name, \
int argc, char* const *argv)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*ip->in)
#undef out
#define out (*ip->out)
#undef enable
#define enable (0+*ip->enable)
#undef valid
#define valid (*ip->valid)
#undef type_
#define type_ (*ip->type_)
#undef f0
#define f0 (*ip->f0)
#undef Q
#define Q (*ip->Q)
#undef d1
#define d1 (*ip->d1)
#undef d2
#define d2 (*ip->d2)
#undef n0
#define n0 (*ip->n0)
#undef n1
#define n1 (*ip->n1)
#undef n2
#define n2 (*ip->n2)
#undef s1
#define s1 (*ip->s1)
#undef s2
#define s2 (*ip->s2)
#undef lastEnable
#define lastEnable (ip->lastEnable)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 71 "hal/i_components/biquad.icomp"


#include <float.h>
#include <rtapi_math.h>


#define PI                      3.141592653589


void Biquad_CalcCoeffs(void *arg, unsigned long period);


typedef enum {
    TYPE_DIRECT,
    TYPE_LOW_PASS,
    TYPE_NOTCH,
} Type;


EXTRA_INST_SETUP()
{
    lastEnable = false;

    return(0);
}


FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    if(lastEnable != enable){
        lastEnable = enable;

        if(enable)
            Biquad_CalcCoeffs(arg, period);
    }

    if(!enable || !valid){
        out = in;
    }else{
        // Transposed direct form II.
        out = in * n0 + s1;
        s1 = in * n1 - out * d1 + s2;
        s2 = in * n2 - out * d2;
    }

return 0;
}


void
Biquad_CalcCoeffs(void *arg, unsigned long period)
{
struct inst_data *ip = arg;

    hal_float_t sampleRate, w0, alpha;
    hal_float_t b0, b1, b2, a0, a1, a2;

    // If not direct coefficient loading.
    if(type_ != TYPE_DIRECT){
        valid = false;

        sampleRate = (1.0 / ((hal_float_t)period * 1e-9)); 

        if((f0 > sampleRate / 2.0) || (Q > 2.0) || (Q < 0.5))
            return;

        w0 = 2.0 * PI * f0 / sampleRate;
        alpha = rtapi_sin(w0) / (2.0 * Q);

        if(type_ == TYPE_LOW_PASS){
            b0 = (1.0 - rtapi_cos(w0)) / 2.0;
            b1 = 1.0 - rtapi_cos(w0);
            b2 = (1.0 - rtapi_cos(w0)) / 2.0;
            a0 = 1.0 + alpha;
            a1 = -2.0 * rtapi_cos(w0);
            a2 = 1.0 - alpha;
        }else if(type_ == TYPE_NOTCH){
            b0 = 1.0;
            b1 = -2.0 * rtapi_cos(w0);
            b2 = 1.0;
            a0 = 1.0 + alpha;
            a1 = -2.0 * rtapi_cos(w0);
            a2 = 1.0 - alpha;
        }else{
            return;
        }

        n0 = b0 / a0;
        n1 = b1 / a0;
        n2 = b2 / a0;
        d1 = a1 / a0;
        d2 = a2 / a0;
        s1 = s2 = 0.0;
    }

    valid = true;
}


