
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:44 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "bldc_hall3";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:bldc_hall3:3-wire BLDC motor driver using Hall sensors and trapezoidal commutation.\nThe functionality of this component is now included in the generic \"bldc\"\ncomponent. This component is likely to be removed in a future release");
MODULE_INFO(machinekit, "pin:hall1:bit:None:in:Hall sensor signal 1:None");
MODULE_INFO(machinekit, "pin:hall2:bit:None:in:Hall sensor signal 2:None");
MODULE_INFO(machinekit, "pin:hall3:bit:None:in:Hall sensor signal 3:None");
MODULE_INFO(machinekit, "pin:value:float:None:in:PWM master amplitude input:None");
MODULE_INFO(machinekit, "pin:dir:bit:None:in:Forwards / reverse selection. Negative PWM amplitudes will also\nreverse the motor and there will generally be a pattern that runs the motor in\neach direction too.:None");
MODULE_INFO(machinekit, "pin:A-value:float:None:out:Output amplitude for phase A:None");
MODULE_INFO(machinekit, "pin:B-value:float:None:out:Output amplitude for phase B:None");
MODULE_INFO(machinekit, "pin:C-value:float:None:out:Output amplitude for phase C:None");
MODULE_INFO(machinekit, "pin:pattern:u32:None:io:Commutation pattern to use, from 0 to 47. Default is type 25.\nEvery plausible combination is included. The table shows the excitation pattern\nalong the top, and the pattern code on the left hand side. The table entries\nare the hall patterns in H1, H2, H3 order.\nCommon patterns are:\n0 (30 degree commutation) and 26, its reverse.\n17 (120 degree).\n18 (alternate 60 degree).\n21 (300 degree, Bodine).\n22 (240 degree).\n25 (60 degree commutation).\n\nNote that a number of incorrect commutations will have non-zero net torque\nwhich might look as if they work, but don't really.\n\nIf your motor lacks documentation it might be worth trying every pattern.\n\n.ie '\\*[.T]'html' \\{\\\n.HTML \\\n<STYLE> \\\n#pattern TD { text-align: center; padding-left: .5ex; padding-right: .5ex } \\\n#pattern TH { text-align: center; padding-left: .5ex; padding-right: .5ex } \\\n#pattern TD.W { text-align: right; } \\\n</STYLE> \\\n<TABLE ID=\"pattern\" STYLE=\"border: 1px solid black; border-collapse: collapse\"> \\\n<COL SPAN=7 STYLE=\"margin: .2ex\"><COL SPAN=1 STYLE=\"border-left: 1px solid black\"> \\\n<TR><TD>&nbsp;<TH COLSPAN=6 CLASS=W>Phases, Source - Sink \\\n<TR><TH CLASS=W>pat<TH CLASS=W>B-A<TH CLASS=W>C-A<TH CLASS=W>C-B<TH CLASS=W>A-B<TH CLASS=W>A-C<TH CLASS=W>B-C \\\n<TR><TH>0<TD>000<TD>001<TD>011<TD>111<TD>110<TD>100 \\\n<TR><TH>1<TD>001<TD>000<TD>010<TD>110<TD>111<TD>101 \\\n<TR><TH>2<TD>000<TD>010<TD>011<TD>111<TD>101<TD>100 \\\n<TR><TH>3<TD>001<TD>011<TD>010<TD>110<TD>100<TD>101 \\\n<TR><TH>4<TD>010<TD>011<TD>001<TD>101<TD>100<TD>110 \\\n<TR><TH>5<TD>011<TD>010<TD>000<TD>100<TD>101<TD>111 \\\n<TR><TH>6<TD>010<TD>000<TD>001<TD>101<TD>111<TD>110 \\\n<TR><TH>7<TD>011<TD>001<TD>000<TD>100<TD>110<TD>111 \\\n<TR><TH>8<TD>000<TD>001<TD>101<TD>111<TD>110<TD>010 \\\n<TR><TH>9<TD>001<TD>000<TD>100<TD>110<TD>111<TD>011 \\\n<TR><TH>10<TD>000<TD>010<TD>110<TD>111<TD>101<TD>001 \\\n<TR><TH>11<TD>001<TD>011<TD>111<TD>110<TD>100<TD>000 \\\n<TR><TH>12<TD>010<TD>011<TD>111<TD>101<TD>100<TD>000 \\\n<TR><TH>13<TD>011<TD>010<TD>110<TD>100<TD>101<TD>001 \\\n<TR><TH>14<TD>010<TD>000<TD>100<TD>101<TD>111<TD>011 \\\n<TR><TH>15<TD>011<TD>001<TD>101<TD>100<TD>110<TD>010 \\\n<TR><TH>16<TD>000<TD>100<TD>101<TD>111<TD>011<TD>010 \\\n<TR><TH>17<TD>001<TD>101<TD>100<TD>110<TD>010<TD>011 \\\n<TR><TH>18<TD>000<TD>100<TD>110<TD>111<TD>011<TD>001 \\\n<TR><TH>19<TD>001<TD>101<TD>111<TD>110<TD>010<TD>000 \\\n<TR><TH>20<TD>010<TD>110<TD>111<TD>101<TD>001<TD>000 \\\n<TR><TH>21<TD>011<TD>111<TD>110<TD>100<TD>000<TD>001 \\\n<TR><TH>22<TD>010<TD>110<TD>100<TD>101<TD>001<TD>011 \\\n<TR><TH>23<TD>011<TD>111<TD>101<TD>100<TD>000<TD>010 \\\n<TR><TH>24<TD>100<TD>101<TD>111<TD>011<TD>010<TD>000 \\\n<TR><TH>25<TD>101<TD>100<TD>110<TD>010<TD>011<TD>001 \\\n<TR><TH>26<TD>100<TD>110<TD>111<TD>011<TD>001<TD>000 \\\n<TR><TH>27<TD>101<TD>111<TD>110<TD>010<TD>000<TD>001 \\\n<TR><TH>28<TD>110<TD>111<TD>101<TD>001<TD>000<TD>010 \\\n<TR><TH>29<TD>111<TD>110<TD>100<TD>000<TD>001<TD>011 \\\n<TR><TH>30<TD>110<TD>100<TD>101<TD>001<TD>011<TD>010 \\\n<TR><TH>31<TD>111<TD>101<TD>100<TD>000<TD>010<TD>011 \\\n<TR><TH>32<TD>100<TD>101<TD>001<TD>011<TD>010<TD>110 \\\n<TR><TH>33<TD>101<TD>100<TD>000<TD>010<TD>011<TD>111 \\\n<TR><TH>34<TD>100<TD>110<TD>010<TD>011<TD>001<TD>101 \\\n<TR><TH>35<TD>101<TD>111<TD>011<TD>010<TD>000<TD>100 \\\n<TR><TH>36<TD>110<TD>111<TD>011<TD>001<TD>000<TD>100 \\\n<TR><TH>37<TD>111<TD>110<TD>010<TD>000<TD>001<TD>101 \\\n<TR><TH>38<TD>110<TD>100<TD>000<TD>001<TD>011<TD>111 \\\n<TR><TH>39<TD>111<TD>101<TD>001<TD>000<TD>010<TD>110 \\\n<TR><TH>40<TD>100<TD>000<TD>001<TD>011<TD>111<TD>110 \\\n<TR><TH>41<TD>101<TD>001<TD>000<TD>010<TD>110<TD>111 \\\n<TR><TH>42<TD>100<TD>000<TD>010<TD>011<TD>111<TD>101 \\\n<TR><TH>43<TD>101<TD>001<TD>011<TD>010<TD>110<TD>100 \\\n<TR><TH>44<TD>110<TD>010<TD>011<TD>001<TD>101<TD>100 \\\n<TR><TH>45<TD>111<TD>011<TD>010<TD>000<TD>100<TD>101 \\\n<TR><TH>46<TD>110<TD>010<TD>000<TD>001<TD>101<TD>111 \\\n<TR><TH>47<TD>111<TD>011<TD>001<TD>000<TD>100<TD>110 \\\n</TABLE>\n\\}\n.el \\{\\\n\n.TS\nbox tab(;);\ncb s s s s s s\ncb|cb cb cb cb cb cb\nc | c  c  c  c c r.\nPhases, Source - Sink\n_\npat;B-A;C-A;C-B;A-B;A-C;B-C\n_\n0;000;001;011;111;110;100\n1;001;000;010;110;111;101\n2;000;010;011;111;101;100\n3;001;011;010;110;100;101\n4;010;011;001;101;100;110\n5;011;010;000;100;101;111\n6;010;000;001;101;111;110\n7;011;001;000;100;110;111\n8;000;001;101;111;110;010\n9;001;000;100;110;111;011\n10;000;010;110;111;101;001\n11;001;011;111;110;100;000\n12;010;011;111;101;100;000\n13;011;010;110;100;101;001\n14;010;000;100;101;111;011\n15;011;001;101;100;110;010\n16;000;100;101;111;011;010\n17;001;101;100;110;010;011\n18;000;100;110;111;011;001\n19;001;101;111;110;010;000\n20;010;110;111;101;001;000\n21;011;111;110;100;000;001\n22;010;110;100;101;001;011\n23;011;111;101;100;000;010\n24;100;101;111;011;010;000\n25;101;100;110;010;011;001\n26;100;110;111;011;001;000\n27;101;111;110;010;000;001\n28;110;111;101;001;000;010\n29;111;110;100;000;001;011\n30;110;100;101;001;011;010\n31;111;101;100;000;010;011\n32;100;101;001;011;010;110\n33;101;100;000;010;011;111\n34;100;110;010;011;001;101\n35;101;111;011;010;000;100\n36;110;111;011;001;000;100\n37;111;110;010;000;001;101\n38;110;100;000;001;011;111\n39;111;101;001;000;010;110\n40;100;000;001;011;111;110\n41;101;001;000;010;110;111\n42;100;000;010;011;111;101\n43;101;001;011;010;110;100\n44;110;010;011;001;101;100\n45;111;011;010;000;100;101\n46;110;010;000;001;101;111\n47;111;011;001;000;100;110\n.TE\n\\}\n:25");
MODULE_INFO(machinekit, "descr:\nThis component produces a 3-wire bipolar output. This suits upstream drivers\nthat interpret a negative input as a low-side drive and positive as a high-side\ndrive. This includes the Hostmot2 3pwmgen function, which is likely to be the\nmost common application of this component.\n");
MODULE_INFO(machinekit, "see_also:\nbldc_hall6 6-wire unipolar driver for BLDC motors.\n");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "author:Andy Pugh");
MODULE_INFO(machinekit, "funct:_:1:Interpret Hall sensor patterns and set 3-phase amplitudes");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_bit_t *hall1;
    hal_bit_t *hall2;
    hal_bit_t *hall3;
    hal_float_t *value;
    hal_bit_t *dir;
    hal_float_t *A_value;
    hal_float_t *B_value;
    hal_float_t *C_value;
    hal_u32_t *pattern;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int bldc_hall3_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->hall1), owner_id,
            "%s.hall1", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->hall2), owner_id,
            "%s.hall2", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->hall3), owner_id,
            "%s.hall3", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IN, &(ip->value), owner_id,
            "%s.value", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->dir), owner_id,
            "%s.dir", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->A_value), owner_id,
            "%s.A-value", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->B_value), owner_id,
            "%s.B-value", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->C_value), owner_id,
            "%s.C-value", name);
    if(r != 0) return r;

    r = hal_pin_u32_newf(HAL_IO, &(ip->pattern), owner_id,
            "%s.pattern", name);
    if(r != 0) return r;

    *(ip->pattern) = 25;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = bldc_hall3_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int bldc_hall3_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef hall1
#define hall1 (0+*ip->hall1)
#undef hall2
#define hall2 (0+*ip->hall2)
#undef hall3
#define hall3 (0+*ip->hall3)
#undef value
#define value (0+*ip->value)
#undef dir
#define dir (0+*ip->dir)
#undef A_value
#define A_value (*ip->A_value)
#undef B_value
#define B_value (*ip->B_value)
#undef C_value
#define C_value (*ip->C_value)
#undef pattern
#define pattern (*ip->pattern)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 179 "hal/i_components/bldc_hall3.icomp"

/*dir H1 H2 H3 pattern
000  001  010  011  100  101  110  111 */
static hal_u32_t P[]={
024, 014, 000, 012, 021, 000, 041, 042,
014, 024, 012, 000, 000, 021, 042, 041,
024, 000, 014, 012, 021, 041, 000, 042,
000, 024, 012, 014, 041, 021, 042, 000,
000, 012, 024, 014, 041, 042, 021, 000,
012, 000, 014, 024, 042, 041, 000, 021,
014, 012, 024, 000, 000, 042, 021, 041,
012, 014, 000, 024, 042, 000, 041, 021,
024, 014, 021, 000, 000, 012, 041, 042,
014, 024, 000, 021, 012, 000, 042, 041,
024, 021, 014, 000, 000, 041, 012, 042,
021, 024, 000, 014, 041, 000, 042, 012,
021, 000, 024, 014, 041, 042, 000, 012,
000, 021, 014, 024, 042, 041, 012, 000,
014, 000, 024, 021, 012, 042, 000, 041,
000, 014, 021, 024, 042, 012, 041, 000,
024, 000, 021, 041, 014, 012, 000, 042,
000, 024, 041, 021, 012, 014, 042, 000,
024, 021, 000, 041, 014, 000, 012, 042,
021, 024, 041, 000, 000, 014, 042, 012,
021, 041, 024, 000, 000, 042, 014, 012,
041, 021, 000, 024, 042, 000, 012, 014,
000, 041, 024, 021, 012, 042, 014, 000,
041, 000, 021, 024, 042, 012, 000, 014,
021, 000, 041, 042, 024, 014, 000, 012,
000, 021, 042, 041, 014, 024, 012, 000,
021, 041, 000, 042, 024, 000, 014, 012,
041, 021, 042, 000, 000, 024, 012, 014,
041, 042, 021, 000, 000, 012, 024, 014,
042, 041, 000, 021, 012, 000, 014, 024,
000, 042, 021, 041, 014, 012, 024, 000,
042, 000, 041, 021, 012, 014, 000, 024,
000, 012, 041, 042, 024, 014, 021, 000,
012, 000, 042, 041, 014, 024, 000, 021,
000, 041, 012, 042, 024, 021, 014, 000,
041, 000, 042, 012, 021, 024, 000, 014,
041, 042, 000, 012, 021, 000, 024, 014,
042, 041, 012, 000, 000, 021, 014, 024,
012, 042, 000, 041, 014, 000, 024, 021,
042, 012, 041, 000, 000, 014, 021, 024,
014, 012, 000, 042, 024, 000, 021, 041,
012, 014, 042, 000, 000, 024, 041, 021,
014, 000, 012, 042, 024, 021, 000, 041,
000, 014, 042, 012, 021, 024, 041, 000,
000, 042, 014, 012, 021, 041, 024, 000,
042, 000, 012, 014, 041, 021, 000, 024,
012, 042, 014, 000, 000, 041, 024, 021,
042, 012, 000, 014, 041, 000, 021, 024};

FUNCTION(_){
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_u32_t i;
    hal_float_t V;
    if (pattern > 47){
        rtapi_print_msg(RTAPI_MSG_ERR,
        "Only step patterns 0-47 are allowed, you have requested pattern %i\n",
        pattern);
        pattern = 0;
        return 0;
    }

    i  = (pattern << 3) + (hall1 << 2) + (hall2 << 1) + hall3;

    if (dir) V = -value;
    else V = value;

    if (P[i] & 040) A_value =V;
    else if (P[i] & 004) A_value = -V;
    else A_value = 0;

    if (P[i] & 020) B_value = V;
    else if (P[i] & 002) B_value = -V;
    else B_value = 0;

    if (P[i] & 010) C_value = V;
    else if (P[i] & 001) C_value = -V;
    else C_value = 0;

return 0;
}


