
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:44 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "charge_pumpv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:charge_pumpv2:Create a square-wave for the 'charge pump' input of some controller boards");
MODULE_INFO(machinekit, "pin_ptr:out:bit:None:out:Square wave if 'enable' is TRUE or unconnected, low if 'enable' is FALSE:None");
MODULE_INFO(machinekit, "pin_ptr:out-2:bit:None:out:Square wave at half the frequency of 'out':None");
MODULE_INFO(machinekit, "pin_ptr:out-4:bit:None:out:Square wave at a quarter of the frequency of 'out':None");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:If FALSE, forces all 'out' pins to be low:true");
MODULE_INFO(machinekit, "funct:_:0:Toggle the output bit (if enabled)");
MODULE_INFO(machinekit, "descr:\nThe 'Charge Pump' should be added to the base thread function.\nWhen enabled the output is on for one period and off for one period. To calculate the\nfrequency of the output 1/(period time in seconds x 2) = hz. For example if you\nhave a base period of 100,000ns that is 0.0001 seconds and the formula would be\n1/(0.0001 x 2) = 5,000 hz or 5 Khz. Two additional outputs are provided that run\na factor of 2 and 4 slower for hardware that requires a lower frequency.");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr out;
    bit_pin_ptr out_2;
    bit_pin_ptr out_4;
    bit_pin_ptr enable;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int charge_pumpv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (bit_pin_null(ip->out))
            return _halerrno;


    ip->out_2 = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.out-2", name);
    if (bit_pin_null(ip->out_2))
            return _halerrno;


    ip->out_4 = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.out-4", name);
    if (bit_pin_null(ip->out_4))
            return _halerrno;


    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;

    set_bit_pin(ip->enable, true);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = charge_pumpv2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int charge_pumpv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef out
#define out (ip->out)
#undef out_2
#define out_2 (ip->out_2)
#undef out_4
#define out_4 (ip->out_4)
#undef enable
#define enable (ip->enable)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 23 "hal/i_components/charge_pumpv2.icomp"

FUNCTION(_) 
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

static hal_u32_t acc;

    if ( gb(enable) ) 
        {
        acc++;
        sb(out, (acc & 0x1));
        sb(out_2, (acc & 0x2));
        sb(out_4, (acc & 0x4));
        } 
    else 
        {
        sb(out, 0);
        sb(out_2, 0);
        sb(out_4, 0);
        }
    return 0;
}


