
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:44 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "clarke3v2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:clarke3v2:Clarke (3 phase to cartesian) transform");
MODULE_INFO(machinekit, "descr:The Clarke transform can be used to translate a vector\nquantity from a three phase system (three components 120 degrees\napart) to a two phase Cartesian system (plus a homopolar component\nif the three phases don't sum to zero).\n.P\n\\fBclarke3\\fR implements\nthe general case of the transform, using all three phases.  If the\nthree phases are known to sum to zero, see \\fBclarke2\\fR for a\nsimpler version.");
MODULE_INFO(machinekit, "see_also:\\fBclarke2\\fR for the 'a+b+c=0' case, \\fBclarkeinv\\fR for\nthe inverse transform.");
MODULE_INFO(machinekit, "pin_ptr:a:float:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:b:float:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:c:float:None:in:three phase input vector:None");
MODULE_INFO(machinekit, "pin_ptr:x:float:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:y:float:None:out:cartesian components of output:None");
MODULE_INFO(machinekit, "pin_ptr:h:float:None:out:homopolar component of output:None");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    float_pin_ptr a;
    float_pin_ptr b;
    float_pin_ptr c;
    float_pin_ptr x;
    float_pin_ptr y;
    float_pin_ptr h;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int clarke3v2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->a = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.a", name);
    if (float_pin_null(ip->a))
            return _halerrno;


    ip->b = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.b", name);
    if (float_pin_null(ip->b))
            return _halerrno;


    ip->c = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.c", name);
    if (float_pin_null(ip->c))
            return _halerrno;


    ip->x = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.x", name);
    if (float_pin_null(ip->x))
            return _halerrno;


    ip->y = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.y", name);
    if (float_pin_null(ip->y))
            return _halerrno;


    ip->h = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.h", name);
    if (float_pin_null(ip->h))
            return _halerrno;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = clarke3v2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int clarke3v2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef a
#define a (ip->a)
#undef b
#define b (ip->b)
#undef c
#define c (ip->c)
#undef x
#define x (ip->x)
#undef y
#define y (ip->y)
#undef h
#define h (ip->h)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 20 "hal/i_components/clarke3v2.icomp"

/* for the details, google "clarke transform", or see section 3 of
   http://focus.ti.com/lit/an/bpra048/bpra048.pdf and/or appendix B of
   http://www.esat.kuleuven.be/electa/publications/fulltexts/pub_1610.pdf
*/

#define K1 (0.666666666666667)  /* 2/3       */
#define K2 (0.333333333333333)  /* 1/3       */
#define K3 (0.577350269189626)  /* 1/sqrt(3) */
#define K4 (0.471404520791032)  /* sqrt(2)/3 */

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    sf(x, K1*gf(a) - K2*(gf(b) + gf(c)));
    sf(y, K3*(gf(b) - gf(c)));
    sf(h, K4*(gf(a) + gf(b) +gf(c)));
return 0;
}


#if 0
#define K1 (2.0/3.0)
#define K2 (1.0/3.0)
#define K3 1.154700538  /* 2/sqrt(3) */

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    x = K1 * a - K2 * (b - c);
    y = K3 * (b - c);
    h = K1 * (a + b + c);
return 0;
}
#endif


