
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:44 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "clarkeinvv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:clarkeinvv2:Inverse Clarke transform");
MODULE_INFO(machinekit, "descr:The inverse Clarke transform can be used rotate a\nvector quantity and then translate it from Cartesian coordinate\nsystem to a three phase system (three components 120 degrees apart).");
MODULE_INFO(machinekit, "see_also:\\fBclarke2\\fR and \\fBclarke3\\fR for the forward transform.");
MODULE_INFO(machinekit, "pin_ptr:x:float:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:y:float:None:in:cartesian components of input:None");
MODULE_INFO(machinekit, "pin_ptr:h:float:None:in:homopolar component of input (usually zero):None");
MODULE_INFO(machinekit, "pin_ptr:theta:float:None:in:rotation angle: 0.00 to 1.00 = 0 to 360 degrees:None");
MODULE_INFO(machinekit, "pin_ptr:a:float:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:b:float:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:c:float:None:out:three phase output vector:None");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    float_pin_ptr x;
    float_pin_ptr y;
    float_pin_ptr h;
    float_pin_ptr theta;
    float_pin_ptr a;
    float_pin_ptr b;
    float_pin_ptr c;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int clarkeinvv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->x = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.x", name);
    if (float_pin_null(ip->x))
            return _halerrno;


    ip->y = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.y", name);
    if (float_pin_null(ip->y))
            return _halerrno;


    ip->h = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.h", name);
    if (float_pin_null(ip->h))
            return _halerrno;


    ip->theta = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.theta", name);
    if (float_pin_null(ip->theta))
            return _halerrno;


    ip->a = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.a", name);
    if (float_pin_null(ip->a))
            return _halerrno;


    ip->b = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.b", name);
    if (float_pin_null(ip->b))
            return _halerrno;


    ip->c = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.c", name);
    if (float_pin_null(ip->c))
            return _halerrno;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = clarkeinvv2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int clarkeinvv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef x
#define x (ip->x)
#undef y
#define y (ip->y)
#undef h
#define h (ip->h)
#undef theta
#define theta (ip->theta)
#undef a
#define a (ip->a)
#undef b
#define b (ip->b)
#undef c
#define c (ip->c)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 16 "hal/i_components/clarkeinvv2.icomp"
#include "rtapi_math.h"

/* for the details, google "clarke transform", or see section 3 of
   http://focus.ti.com/lit/an/bpra048/bpra048.pdf and/or appendix B of
   http://www.esat.kuleuven.be/electa/publications/fulltexts/pub_1610.pdf
*/

#define K1 (0.500000000000000)  /* 1/2       */
#define K2 (0.866025403784439)  /* sqrt(3)/2 */
#define K3 (0.707106781186547)  /* 1/sqrt(2) */
#define rev2rad (6.283185308)   /* 2 * pi */

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_float_t xr, yr, rads, costheta, sintheta;

    // rotate it
    rads = gf(theta) * rev2rad;
    costheta = rtapi_cos(rads);
    sintheta = rtapi_sin(rads);
    xr = gf(x) * costheta - gf(y) * sintheta;
    yr = gf(x) * sintheta + gf(y) * costheta;

    /* transform to three phase */
    sf(a,  xr +  K3*gf(h));
    sf(b, -K1*xr + K2*yr + K3*gf(h));
    sf(c, -K1*xr - K2*yr + K3*gf(h));

	return 0;
}


