
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:45 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "conv_u64_u32";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:conv_u64_u32:Convert a value from u64 to u32");
MODULE_INFO(machinekit, "pin:in_:u64:None:in::None");
MODULE_INFO(machinekit, "pin:out:u32:None:out::None");
MODULE_INFO(machinekit, "pin:out_of_range:bit:None:out:TRUE when 'in' is not in the range of u32:None");
MODULE_INFO(machinekit, "pin:clamp:bit:None:io:If TRUE, then clamp to the range of u32.  If FALSE, then allow the value to \"wrap around\".:None");
MODULE_INFO(machinekit, "funct:_:0:Update 'out' based on 'in'");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_u64_t *in_;
    hal_u32_t *out;
    hal_bit_t *out_of_range;
    hal_bit_t *clamp;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int conv_u64_u32_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_u64_newf(HAL_IN, &(ip->in_), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_u32_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->out_of_range), owner_id,
            "%s.out-of-range", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IO, &(ip->clamp), owner_id,
            "%s.clamp", name);
    if(r != 0) return r;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = conv_u64_u32_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int conv_u64_u32_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in_
#define in_ (0+*ip->in_)
#undef out
#define out (*ip->out)
#undef out_of_range
#define out_of_range (*ip->out_of_range)
#undef clamp
#define clamp (*ip->clamp)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 10 "hal/i_components/conv_u64_u32.icomp"
FUNCTION(_) {
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_u64_t in = in_;
    if(clamp) {
#if 4294967295UL != 0
	if(in > 4294967295UL) { out = 4294967295UL; out_of_range = 1; return 0; }
#endif
#if 0 != -1
	if(in < 0) { out = 0; out_of_range = 1; return 0; }
#endif
	out = in; out_of_range = 0;
    } else {
	out = in;
	if(out != in) out_of_range = 1;
    }
    return 0;
}


