
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:45 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "edge";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:edge:Edge detector");
MODULE_INFO(machinekit, "pin:in:bit:None:in::None");
MODULE_INFO(machinekit, "pin:out:bit:None:out:Goes high when the desired edge is seen on 'in':None");
MODULE_INFO(machinekit, "pin:out_invert:bit:None:out:Goes low when the desired edge is seen on 'in':None");
MODULE_INFO(machinekit, "pin:both:bit:None:io:If true, selects both edges.  Otherwise, selects one edge according to in-edge:false");
MODULE_INFO(machinekit, "pin:in_edge:bit:None:io:If both is false, selects the one desired edge: true means falling, false means rising:true");
MODULE_INFO(machinekit, "pin:out_width_ns:s32:None:io:Time in nanoseconds of the output pulse:0");
MODULE_INFO(machinekit, "pin:time_left_ns:s32:None:out:Time left in this output pulse:None");
MODULE_INFO(machinekit, "pin:last_in:bit:None:out:Previous input value:None");
MODULE_INFO(machinekit, "funct:_:0:Produce output pulses from input edges");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_bit_t *in;
    hal_bit_t *out;
    hal_bit_t *out_invert;
    hal_bit_t *both;
    hal_bit_t *in_edge;
    hal_s32_t *out_width_ns;
    hal_s32_t *time_left_ns;
    hal_bit_t *last_in;
    hal_bit_t first;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int edge_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->in), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->out_invert), owner_id,
            "%s.out-invert", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IO, &(ip->both), owner_id,
            "%s.both", name);
    if(r != 0) return r;

    *(ip->both) = false;
    r = hal_pin_bit_newf(HAL_IO, &(ip->in_edge), owner_id,
            "%s.in-edge", name);
    if(r != 0) return r;

    *(ip->in_edge) = true;
    r = hal_pin_s32_newf(HAL_IO, &(ip->out_width_ns), owner_id,
            "%s.out-width-ns", name);
    if(r != 0) return r;

    *(ip->out_width_ns) = 0;
    r = hal_pin_s32_newf(HAL_OUT, &(ip->time_left_ns), owner_id,
            "%s.time-left-ns", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->last_in), owner_id,
            "%s.last-in", name);
    if(r != 0) return r;

    ip->first = true;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = edge_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int edge_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*ip->in)
#undef out
#define out (*ip->out)
#undef out_invert
#define out_invert (*ip->out_invert)
#undef both
#define both (*ip->both)
#undef in_edge
#define in_edge (*ip->in_edge)
#undef out_width_ns
#define out_width_ns (*ip->out_width_ns)
#undef time_left_ns
#define time_left_ns (*ip->time_left_ns)
#undef last_in
#define last_in (*ip->last_in)
#undef first
#define first (ip->first)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 34 "hal/i_components/edge.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_bit_t new_in = in;
    if (time_left_ns > 0)
        {
        time_left_ns -= period;
        }
    if ( !first )
        {
        hal_bit_t rise = new_in && !last_in;
        hal_bit_t fall = !new_in && last_in;
        hal_bit_t desired_edge =
            both ? rise || fall
                    : in_edge ? fall : rise;
        if(desired_edge)
            {
            time_left_ns = out_width_ns;
            out = 1;
            }
        else if(time_left_ns > 0)
            {
            out = true;
            }
        else
            {
            time_left_ns = 0;
            out = false;
            }
        }
    else
        {
        first = false;
        }
    last_in = new_in;
    out_invert = !out;

return 0;
}


