
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:45 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "estop_latch";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:estop_latch:ESTOP latch which sets ok-out true and fault-out false only if ok-in is true, fault-in is false, and a rising edge is seen on reset.  While ok-out is true, watchdog toggles, and can be used for chargepumps or similar needs.");
MODULE_INFO(machinekit, "pin:ok_in:bit:None:in::None");
MODULE_INFO(machinekit, "pin:fault_in:bit:None:in::None");
MODULE_INFO(machinekit, "pin:reset:bit:None:in::None");
MODULE_INFO(machinekit, "pin:ok_out:bit:None:out::None");
MODULE_INFO(machinekit, "pin:fault_out:bit:None:out::None");
MODULE_INFO(machinekit, "pin:watchdog:bit:None:out::None");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_bit_t *ok_in;
    hal_bit_t *fault_in;
    hal_bit_t *reset;
    hal_bit_t *ok_out;
    hal_bit_t *fault_out;
    hal_bit_t *watchdog;
    hal_bit_t old_reset;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int estop_latch_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->ok_in), owner_id,
            "%s.ok-in", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->fault_in), owner_id,
            "%s.fault-in", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->reset), owner_id,
            "%s.reset", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->ok_out), owner_id,
            "%s.ok-out", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->fault_out), owner_id,
            "%s.fault-out", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->watchdog), owner_id,
            "%s.watchdog", name);
    if(r != 0) return r;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = estop_latch_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int estop_latch_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef ok_in
#define ok_in (0+*ip->ok_in)
#undef fault_in
#define fault_in (0+*ip->fault_in)
#undef reset
#define reset (0+*ip->reset)
#undef ok_out
#define ok_out (*ip->ok_out)
#undef fault_out
#define fault_out (*ip->fault_out)
#undef watchdog
#define watchdog (*ip->watchdog)
#undef old_reset
#define old_reset (ip->old_reset)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 13 "hal/i_components/estop_latch.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    /* check inputs */
    if ( ok_in && !fault_in)
        {
	/* no fault conditions, check for reset edge */
	    if ( reset && !old_reset )
	        {
	    /* got a rising edge, indicate "OK" on outputs */
	        ok_out = true;
	        fault_out = false;
	        }
	    if( ok_out )
	        {
	    /* toggle watchdog */
	        watchdog = !watchdog;
	        }
        }
    else
        {
	/* fault condition exists, trip */
	    ok_out = false;
	    fault_out = true;
        }
    /* store state of reset input for next pass (for edge detect) */
    old_reset = reset;

	return 0;
}


