
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:45 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "gantryv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:gantryv2:Machinekit HAL component for driving multiple joints from a single axis");
MODULE_INFO(machinekit, "pin_ptr:joint.##.pos-cmd:float:pincount:out:Per-joint commanded position:None");
MODULE_INFO(machinekit, "pin_ptr:joint.##.pos-fb:float:pincount:in:Per-joint position feedback:None");
MODULE_INFO(machinekit, "pin_ptr:joint.##.home:bit:pincount:in:Per-joint home switch:None");
MODULE_INFO(machinekit, "pin_ptr:joint.##.offset:float:pincount:out:(debugging) Per-joint offset value, updated when homing:None");
MODULE_INFO(machinekit, "pin_ptr:position-cmd:float:None:in:Commanded position from motion:None");
MODULE_INFO(machinekit, "pin_ptr:position-fb:float:None:out:Position feedback to motion:None");
MODULE_INFO(machinekit, "pin_ptr:home:bit:None:out:Combined home signal, true if all joint home inputs are true:None");
MODULE_INFO(machinekit, "pin_ptr:limit:bit:None:out:Combined limit signal, true if any joint home input is true:None");
MODULE_INFO(machinekit, "pin_ptr:search-vel:float:None:in:HOME_SEARCH_VEL from ini file:None");
MODULE_INFO(machinekit, "funct:read:1:Update position-fb and home/limit outputs based on joint values");
MODULE_INFO(machinekit, "funct:write:1:Update joint pos-cmd outputs based on position-cmd in");
MODULE_INFO(machinekit, "instanceparam:pincount:int::7");
MODULE_INFO(machinekit, "descr:\nDrives multiple physical motors (joints) from a single axis input\n.LP\nThe `pincount' value is the number of joints to control.  Two is typical, but\nup to seven is supported (a three joint setup has been tested with hardware).\n.LP\nAll controlled joints track the commanded position (with a per-joint offset)\nunless in the process of homing.  Homing is when the commanded position is\nmoving towards the homing switches (as determined by the sign of search-vel)\nand the joint home switches are not all in the same state.  When the system is\nhoming and a joint home switch activates, the command value sent to that joint\nis \"frozen\" and the joint offset value is updated instead.  Once all home\nswitches are active, there are no more adjustments made to the offset values\nand all joints run in lock-step once more.\n.LP\nFor best results, set HOME_SEARCH_VEL and HOME_LATCH_VEL to the same direction\nand as slow as practical.  When a joint home switch trips, the commanded\nvelocity will drop immediately from HOME_SEARCH_VEL to zero, with no limit on\naccleration.\n");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

#define MAXCOUNT 7
#define DEFAULTCOUNT 7

static int pincount = 7;
RTAPI_IP_INT(pincount, "");

struct inst_data
    {
    float_pin_ptr joint_pos_cmd[7];
    float_pin_ptr joint_pos_fb[7];
    bit_pin_ptr joint_home[7];
    float_pin_ptr joint_offset[7];
    float_pin_ptr position_cmd;
    float_pin_ptr position_fb;
    bit_pin_ptr home;
    bit_pin_ptr limit;
    float_pin_ptr search_vel;
    hal_float_t offset[7];
    hal_float_t prev_cmd;
    hal_s32_t fb_joint;
    hal_bit_t latching;
    int local_argc;
    char **local_argv;
    int local_pincount;
    };

static int maxpins __attribute__((unused)) = 7;
static int read(void *arg, const hal_funct_args_t *fa);

static int write(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->joint_pos_cmd[j] = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.joint.%02d.pos-cmd", name, j);
        if (float_pin_null(ip->joint_pos_cmd[j]))
            return _halerrno;
        }

    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->joint_pos_fb[j] = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.joint.%02d.pos-fb", name, j);
        if (float_pin_null(ip->joint_pos_fb[j]))
            return _halerrno;
        }

    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->joint_home[j] = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.joint.%02d.home", name, j);
        if (bit_pin_null(ip->joint_home[j]))
            return _halerrno;
        }

    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->joint_offset[j] = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.joint.%02d.offset", name, j);
        if (float_pin_null(ip->joint_offset[j]))
            return _halerrno;
        }


    ip->position_cmd = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.position-cmd", name);
    if (float_pin_null(ip->position_cmd))
            return _halerrno;


    ip->position_fb = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.position-fb", name);
    if (float_pin_null(ip->position_fb))
            return _halerrno;


    ip->home = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.home", name);
    if (bit_pin_null(ip->home))
            return _halerrno;


    ip->limit = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.limit", name);
    if (bit_pin_null(ip->limit))
            return _halerrno;


    ip->search_vel = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.search-vel", name);
    if (float_pin_null(ip->search_vel))
            return _halerrno;

    z = 7;
    for(j=0; j < z; j++)
       {
        ip->offset[j] = 0.0;
        }

    ip->prev_cmd = 0.0;
    ip->fb_joint = 0;
    ip->latching = false;

// if not set by instantiate() set to default
    if(! ip->local_pincount || ip->local_pincount == -1)
         ip->local_pincount = DEFAULTCOUNT;

    hal_print_msg(RTAPI_MSG_DBG,"export_halobjs() ip->local_pincount set to %d", ip->local_pincount);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t read_xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = read,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.read", name);
    r = hal_export_xfunctf(&read_xf, buf, name);
    if(r != 0)
        return r;

    // exporting an extended thread function:
    hal_export_xfunct_args_t write_xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = write,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.write", name);
    r = hal_export_xfunctf(&write_xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values
    hal_print_msg(RTAPI_MSG_DBG,"%s: int instance param: %s=%d",__FUNCTION__,"pincount", pincount);
//  if pincount=NN is passed, set local variable here, if not set to default
    int pin_param_value = pincount;
    if((pin_param_value == -1) || (pin_param_value == 0))
        pin_param_value = DEFAULTCOUNT;
    else if((pin_param_value > 0) && (pin_param_value > MAXCOUNT))
        pin_param_value = MAXCOUNT;
    ip->local_pincount = pincount = pin_param_value;
    hal_print_msg(RTAPI_MSG_DBG,"ip->local_pincount set to %d", pin_param_value);

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
//reset pincount to -1 so that instantiation without it will result in DEFAULTCOUNT
    pincount = -1;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int name(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef joint_pos_cmd
#define joint_pos_cmd(i) (ip->joint_pos_cmd[i])
#undef joint_pos_fb
#define joint_pos_fb(i) (ip->joint_pos_fb[i])
#undef joint_home
#define joint_home(i) (ip->joint_home[i])
#undef joint_offset
#define joint_offset(i) (ip->joint_offset[i])
#undef position_cmd
#define position_cmd (ip->position_cmd)
#undef position_fb
#define position_fb (ip->position_fb)
#undef home
#define home (ip->home)
#undef limit
#define limit (ip->limit)
#undef search_vel
#define search_vel (ip->search_vel)
#undef offset
#define offset(i) (ip->offset[i])
#undef prev_cmd
#define prev_cmd (ip->prev_cmd)
#undef fb_joint
#define fb_joint (ip->fb_joint)
#undef latching
#define latching (ip->latching)
#undef local_pincount
#define local_pincount (ip->local_pincount)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 88 "hal/i_components/gantryv2.icomp"


FUNCTION(read) {
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t i=1;

    // First (or only) joint
    sb(home, gb(joint_home(0)));
    sb(limit, gb(joint_home(0)));

    // All other joints, if configured
    while (i < local_pincount) {
        // Check to see if machine is in latching state
        if(!latching)
        {
            // Don't assert home until all joints hit their gb(home) switches
            sb(home, gb(home) & gb(joint_home(i)));
        }
        else
        {
            // Don't release home until all joints have backed off their
            // home switches
            sb(home, gb(home) | gb(joint_home(i)));
        }

        // Remember the home state for next time
        latching=gb(home);

        // Limit is always asserted if any home switch is asserted
        sb(limit, gb(limit) | gb(joint_home(i)));
        i++;
    }

    // Joint used for feedback is 'sticky', but we have to switch to
    // track active joints or motion gets upset with the sudden
    // stop.  If all joints are not homed, but the current joint used
    // for feedback is, find a joint that's still active
    if ((gb(joint_home(fb_joint)) ) && (gb(home) == 0)) {
        for (i=0; i < local_pincount; i++) {
            if (!gb(joint_home(i))) {
                sf(position_fb, gf(joint_pos_fb(i)) + offset(i));
                fb_joint = i;
                break;
            }
        }
    } else {
        sf(position_fb, gf(joint_pos_fb(fb_joint)) + offset(fb_joint));
    }

	return 0;
}

FUNCTION(write) {
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t i;
    hal_float_t delta;

    // Determine if we're moving in the same direction as home search

    // First calculate the direction we're moving now
    delta = gf(position_cmd) - prev_cmd;

    // Stash current commanded position for next time
    prev_cmd = gf(position_cmd);

    // Then multiply our delta value by the search velocity
    // If the signs match and neither is zero, the result will be positive
    // indicate we are moving towards home.  Otherwise, the result will be
    // zero or negative.
    //
    // If we're moving towards home and all home switches are not closed
    if ( ((delta * gf(search_vel)) > 0) && (gb(home)==0) ) {
        // Check each joint to see if it's home switch is active
        for (i=0; i < local_pincount; i++) {
            // If home switch is active, update offset, not pos_cmd
            // so the other joints can catch up
            if (gb(joint_home(i))) {
                offset(i) += delta;
            }
        }
    }

    // Update each joint's commanded position
    for (i=0; i < local_pincount; i++) {
        sf(joint_pos_cmd(i), gf(position_cmd) - offset(i));
        sf(joint_offset(i), offset(i));
    }

	return 0;
}


