
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:45 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "gearchange";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:gearchange:Select from one two speed ranges\nThe output will be a value scaled for the selected gear, and clamped to\nthe min/max values for that gear.\nThe scale of gear 1 is assumed to be 1, so the output device scale\nshould be chosen accordingly.\nThe scale of gear 2 is relative to gear 1, so if gear 2 runs the spindle\n2.5 times as fast as gear 1, scale2 should be set to 2.5.");
MODULE_INFO(machinekit, "pin:sel:bit:None:in:Gear selection input:None");
MODULE_INFO(machinekit, "pin:speed_in:float:None:in:Speed command input:None");
MODULE_INFO(machinekit, "pin:speed_out:float:None:out:Speed command to DAC/PWM:None");
MODULE_INFO(machinekit, "pin:dir_in:bit:None:in:Direction command input:None");
MODULE_INFO(machinekit, "pin:dir_out:bit:None:out:Direction output - possibly inverted for second gear:None");
MODULE_INFO(machinekit, "pin:min1:float:None:io:Minimum allowed speed in gear range 1:0.0");
MODULE_INFO(machinekit, "pin:max1:float:None:io:Maximum allowed speed in gear range 1:100000");
MODULE_INFO(machinekit, "pin:min2:float:None:io:Minimum allowed speed in gear range 2:0.0");
MODULE_INFO(machinekit, "pin:max2:float:None:io:Maximum allowed speed in gear range 2:100000");
MODULE_INFO(machinekit, "pin:scale2:float:None:io:Relative scale of gear 2 vs. gear 1\nSince it is assumed that gear 2 is \"high gear\", \\fBscale2\\fR must be\ngreater than 1, and will be reset to 1 if set lower.:1.0");
MODULE_INFO(machinekit, "pin:reverse:bit:None:io:Set to 1 to reverse the spindle in second gear:0.0");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_bit_t *sel;
    hal_float_t *speed_in;
    hal_float_t *speed_out;
    hal_bit_t *dir_in;
    hal_bit_t *dir_out;
    hal_float_t *min1;
    hal_float_t *max1;
    hal_float_t *min2;
    hal_float_t *max2;
    hal_float_t *scale2;
    hal_bit_t *reverse;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int gearchange_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->sel), owner_id,
            "%s.sel", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IN, &(ip->speed_in), owner_id,
            "%s.speed-in", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->speed_out), owner_id,
            "%s.speed-out", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->dir_in), owner_id,
            "%s.dir-in", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->dir_out), owner_id,
            "%s.dir-out", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IO, &(ip->min1), owner_id,
            "%s.min1", name);
    if(r != 0) return r;

    *(ip->min1) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->max1), owner_id,
            "%s.max1", name);
    if(r != 0) return r;

    *(ip->max1) = 100000;
    r = hal_pin_float_newf(HAL_IO, &(ip->min2), owner_id,
            "%s.min2", name);
    if(r != 0) return r;

    *(ip->min2) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->max2), owner_id,
            "%s.max2", name);
    if(r != 0) return r;

    *(ip->max2) = 100000;
    r = hal_pin_float_newf(HAL_IO, &(ip->scale2), owner_id,
            "%s.scale2", name);
    if(r != 0) return r;

    *(ip->scale2) = 1.0;
    r = hal_pin_bit_newf(HAL_IO, &(ip->reverse), owner_id,
            "%s.reverse", name);
    if(r != 0) return r;

    *(ip->reverse) = 0.0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = gearchange_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int gearchange_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef sel
#define sel (0+*ip->sel)
#undef speed_in
#define speed_in (0+*ip->speed_in)
#undef speed_out
#define speed_out (*ip->speed_out)
#undef dir_in
#define dir_in (0+*ip->dir_in)
#undef dir_out
#define dir_out (*ip->dir_out)
#undef min1
#define min1 (*ip->min1)
#undef max1
#define max1 (*ip->max1)
#undef min2
#define min2 (*ip->min2)
#undef max2
#define max2 (*ip->max2)
#undef scale2
#define scale2 (*ip->scale2)
#undef reverse
#define reverse (*ip->reverse)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 25 "hal/i_components/gearchange.icomp"
FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_float_t temp_in = speed_in;
    hal_float_t sign=1.0;
    /* Assume that the output device is scaled so that gear 1 is "Pass-through" */
    /* the other gear(s) need to be scaled by the relative scale for that gear */
    if (scale2 < 1.0) scale2 = 1.0;
    if (temp_in < 0.0) {
	sign = -1.0;
	temp_in = -temp_in;
    }
    if(sel) {		/* gear 2 */
	if (temp_in < min2) temp_in = min2;
	else if (temp_in > max2) temp_in = max2;
	temp_in /= scale2;		/* scale up to second gear output range */
	dir_out = dir_in ^ reverse;
    } else {
	if (temp_in < min1) temp_in = min1;
	else if (temp_in > max1) temp_in = max1;
	dir_out = dir_in;
    }
    speed_out = sign*temp_in;

return 0;
}


