
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "hbridgev2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:hbridgev2:generate driving signals for 2 PWM generators to drive an H-Bridge");
MODULE_INFO(machinekit, "descr:\nTogether with 2 PWM's, this comp can be used to drive a DC motor through an H-bridge.\nIf the H-bridge needs a PWM signal at full speed (e.g. for charge pumps), limit the\noutput value by setting maxout.\nSee also: http://en.wikipedia.org/wiki/H_bridge .\n\nTwo output pins, up and down. For positive inputs, the PWM/PDM driving signal appears on up, while down is low. For negative inputs, the driving signal on down, while up is low. Suitable for driving the two sides of an H-bridge to generate a bipolar output.\n\n");
MODULE_INFO(machinekit, "pin_ptr:command:float:None:in:target speed, < 0: reverse, > 0: forward:None");
MODULE_INFO(machinekit, "pin_ptr:down:float:None:out:driving value for PWM1, 0..maxout:None");
MODULE_INFO(machinekit, "pin_ptr:up:float:None:out:driving value for PWM2, 0..maxout:None");
MODULE_INFO(machinekit, "pin_ptr:enable-out:bit:None:out:output to enable both half-bridges:None");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:let motor free run if false:None");
MODULE_INFO(machinekit, "pin_ptr:brake:bit:None:in:brake motor if true; needs enable to be true:None");
MODULE_INFO(machinekit, "pin_ptr:maxout:float:None:io:limit for the up and down pins:1.0");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL v2");
MODULE_LICENSE("GPL v2");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    float_pin_ptr command;
    float_pin_ptr down;
    float_pin_ptr up;
    bit_pin_ptr enable_out;
    bit_pin_ptr enable;
    bit_pin_ptr brake;
    float_pin_ptr maxout;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int hbridgev2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->command = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.command", name);
    if (float_pin_null(ip->command))
            return _halerrno;


    ip->down = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.down", name);
    if (float_pin_null(ip->down))
            return _halerrno;


    ip->up = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.up", name);
    if (float_pin_null(ip->up))
            return _halerrno;


    ip->enable_out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.enable-out", name);
    if (bit_pin_null(ip->enable_out))
            return _halerrno;


    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;


    ip->brake = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.brake", name);
    if (bit_pin_null(ip->brake))
            return _halerrno;


    ip->maxout = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.maxout", name);
    if (float_pin_null(ip->maxout))
            return _halerrno;

    set_float_pin(ip->maxout, 1.0);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = hbridgev2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int hbridgev2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef command
#define command (ip->command)
#undef down
#define down (ip->down)
#undef up
#define up (ip->up)
#undef enable_out
#define enable_out (ip->enable_out)
#undef enable
#define enable (ip->enable)
#undef brake
#define brake (ip->brake)
#undef maxout
#define maxout (ip->maxout)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 24 "hal/i_components/hbridgev2.icomp"
#define MINIMUM(x, y) (((x) > (y))?(y):(x))

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_float_t negcmd;

    if (gb(enable)) {
        if (gb(brake)) 
            {
            // motor DC brake
            sf(up, 0.0);
            sf(down, 0.0);
            sb(enable_out, true);
            } 
        else {
            // normal forward/reverse operation
            negcmd = gf(command) * - 1.0;
            if (gf(command) < 0.0) {
                sf(up, 0.0);
                sf(down, (hal_float_t)MINIMUM(negcmd, gf(maxout)));
                } 
            else {
                sf(up, (hal_float_t)MINIMUM(gf(command), (double)gf(maxout)));
                sf(down, 0.0);
                }
            sb(enable_out, true);
            }
        } 
    else {
        // let motor run freely
        sf(up, 0.0);
        sf(down, 0.0);
        sb(enable_out, false);
    }

    return 0;
}


