
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "ilowpass";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:ilowpass:Low-pass filter with integer inputs and outputs");
MODULE_INFO(machinekit, "descr:While it may find other applications, this component was written\nto create smoother motion while jogging with an MPG.\n\nIn a machine with high acceleration, a short jog can behave almost like a step\nfunction.  By putting the \\fBilowpass\\fR component between the MPG\nencoder \\fBcounts\\fR output and the axis \\fRjog-counts\\fR input,\nthis can be smoothed.\n\nChoose \\fBscale\\fR conservatively so that during a single session\nthere will never be more than about 2e9/\\fBscale\\fR pulses seen\non the MPG.  Choose \\fBgain\\fR according to the smoothing level\ndesired.  Divide the \\fRaxis.\\fIN\\fR.jog-scale\\fR values by\n\\fBscale\\fR.");
MODULE_INFO(machinekit, "pin:in:s32:None:in::None");
MODULE_INFO(machinekit, "pin:out:s32:None:out:\\fBout\\fR tracks \\fBin\\fR*\\fBscale\\fR through a low-pass\nfilter of \\fBgain\\fR per period.:None");
MODULE_INFO(machinekit, "pin:scale:float:None:io:A scale factor applied to the output\nvalue of the low-pass filter.:1024.0");
MODULE_INFO(machinekit, "pin:gain:float:None:io:Together with the period, sets the rate at\nwhich the output changes.  Useful range is between 0 and 1, with higher\nvalues causing the input value to be tracked more quickly.  For\ninstance, a setting of 0.9 causes the output value to go 90% of the way\ntowards the input value in each period:0.5");
MODULE_INFO(machinekit, "funct:_:1:Update the output based on the input and parameters");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "author:Jeff Epler <jepler@unpythonic.net>");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_s32_t *in;
    hal_s32_t *out;
    hal_float_t *scale;
    hal_float_t *gain;
    hal_float_t value;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int ilowpass_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_s32_newf(HAL_IN, &(ip->in), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IO, &(ip->scale), owner_id,
            "%s.scale", name);
    if(r != 0) return r;

    *(ip->scale) = 1024.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->gain), owner_id,
            "%s.gain", name);
    if(r != 0) return r;

    *(ip->gain) = 0.5;
    ip->value = 0.0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = ilowpass_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int ilowpass_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*ip->in)
#undef out
#define out (*ip->out)
#undef scale
#define scale (*ip->scale)
#undef gain
#define gain (*ip->gain)
#undef value
#define value (ip->value)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

#line 37 "hal/i_components/ilowpass.icomp"
value += ((hal_float_t)in - value) * gain;
out = (hal_s32_t)(__s64)(value * scale);

return 0;

}

