
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "indextablev2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:indextablev2:\nDriving an index (table) by means of specifying the desired position.\nAn index switch detects the correct signal to stop.\n");
MODULE_INFO(machinekit, "descr:\nThis component can be connected to a Frequency Inverter for use with\nfor example an indexing table.\n\nInternally there is a small state machine with the following states:\n0 = disabled\n1 = inactive\n2 = start index table\n3 = moving\n4 = home indextable\n\nThe state is disabled by default, and setting the `enable` pin will\nput the state machine tin the `inactive` state.\n\nFrom the inactive state we can start moving the table by setting the\ntarget position with the `index-cmd` pin. After setting the target\nthe component needs a high edge of the `start` pin. With this the\ncomponent moves to the `start index table` state.\n\nAlso increasing/decreasing one position with `pulse-inc` and `pulse-dec`\nand setting the current position `index-fb` to the target value of\n`index-cmd` by means of `home` can be done from the inactive state.\n\nWhen there is a combination of `pulse=inc`, `pulse-dec`, `home` and\n`start` the order of precedence is as follows:\n1 : start\n2 : home\n3 : pulse-dec\n4 : pulse-inc\n");
MODULE_INFO(machinekit, "pin_ptr:index_cmd:s32:None:in:Desired position of the indexing device:0");
MODULE_INFO(machinekit, "pin_ptr:index_switch:bit:None:in:Switch rising edge counts up/down:false");
MODULE_INFO(machinekit, "pin_ptr:start:bit:None:in:Start movement of indextable on rising edge:false");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:Enabling output drive-run, when disabled then drive-run is off and drive-brake is on:false");
MODULE_INFO(machinekit, "pin_ptr:set_home:bit:None:in:From inactive state one can set the current index to the value of index-cmd:false");
MODULE_INFO(machinekit, "pin_ptr:index_fb:s32:None:out:Current index of the table:false");
MODULE_INFO(machinekit, "pin_ptr:pulse_inc:bit:None:in:Pulse for moving indextable to next lower position:false");
MODULE_INFO(machinekit, "pin_ptr:pulse_dec:bit:None:in:Pulse for moving indextable to next higher position:false");
MODULE_INFO(machinekit, "pin_ptr:drive_on:bit:None:out:Needs to be connected to a drive:false");
MODULE_INFO(machinekit, "pin_ptr:drive_dir:bit:None:out:Needs to be connected to a drive:false");
MODULE_INFO(machinekit, "pin_ptr:drive_brake:bit:None:out:Needs to be connected to a drive:false");
MODULE_INFO(machinekit, "pin_ptr:active:bit:None:out:When the component is active (driving) then this pin is high:false");
MODULE_INFO(machinekit, "pin_ptr:component_state:u32:None:out:Mirror of internal state machine.:None");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "author:Bas de Bruijn");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    s32_pin_ptr index_cmd;
    bit_pin_ptr index_switch;
    bit_pin_ptr start;
    bit_pin_ptr enable;
    bit_pin_ptr set_home;
    s32_pin_ptr index_fb;
    bit_pin_ptr pulse_inc;
    bit_pin_ptr pulse_dec;
    bit_pin_ptr drive_on;
    bit_pin_ptr drive_dir;
    bit_pin_ptr drive_brake;
    bit_pin_ptr active;
    u32_pin_ptr component_state;
    hal_s32_t index_curr;
    hal_s32_t index_target;
    hal_bit_t indextable_active;
    hal_bit_t prev_start;
    hal_bit_t prev_set_home;
    hal_bit_t prev_index_switch;
    hal_bit_t prev_pulse_inc;
    hal_bit_t prev_pulse_dec;
    hal_bit_t direction;
    hal_u32_t state;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int indextablev2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->index_cmd = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.index-cmd", name);
    if (s32_pin_null(ip->index_cmd))
            return _halerrno;

    set_s32_pin(ip->index_cmd, 0);


    ip->index_switch = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.index-switch", name);
    if (bit_pin_null(ip->index_switch))
            return _halerrno;

    set_bit_pin(ip->index_switch, false);


    ip->start = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.start", name);
    if (bit_pin_null(ip->start))
            return _halerrno;

    set_bit_pin(ip->start, false);


    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;

    set_bit_pin(ip->enable, false);


    ip->set_home = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.set-home", name);
    if (bit_pin_null(ip->set_home))
            return _halerrno;

    set_bit_pin(ip->set_home, false);


    ip->index_fb = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.index-fb", name);
    if (s32_pin_null(ip->index_fb))
            return _halerrno;

    set_s32_pin(ip->index_fb, false);


    ip->pulse_inc = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.pulse-inc", name);
    if (bit_pin_null(ip->pulse_inc))
            return _halerrno;

    set_bit_pin(ip->pulse_inc, false);


    ip->pulse_dec = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.pulse-dec", name);
    if (bit_pin_null(ip->pulse_dec))
            return _halerrno;

    set_bit_pin(ip->pulse_dec, false);


    ip->drive_on = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.drive-on", name);
    if (bit_pin_null(ip->drive_on))
            return _halerrno;

    set_bit_pin(ip->drive_on, false);


    ip->drive_dir = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.drive-dir", name);
    if (bit_pin_null(ip->drive_dir))
            return _halerrno;

    set_bit_pin(ip->drive_dir, false);


    ip->drive_brake = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.drive-brake", name);
    if (bit_pin_null(ip->drive_brake))
            return _halerrno;

    set_bit_pin(ip->drive_brake, false);


    ip->active = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.active", name);
    if (bit_pin_null(ip->active))
            return _halerrno;

    set_bit_pin(ip->active, false);


    ip->component_state = halx_pin_u32_newf(HAL_OUT, owner_id,
            "%s.component-state", name);
    if (u32_pin_null(ip->component_state))
            return _halerrno;

    ip->index_curr = 0;
    ip->index_target = 0;
    ip->indextable_active = false;
    ip->prev_start = false;
    ip->prev_set_home = false;
    ip->prev_index_switch = false;
    ip->prev_pulse_inc = false;
    ip->prev_pulse_dec = false;
    ip->direction = 0;
    ip->state = 0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = indextablev2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int indextablev2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef index_cmd
#define index_cmd (ip->index_cmd)
#undef index_switch
#define index_switch (ip->index_switch)
#undef start
#define start (ip->start)
#undef enable
#define enable (ip->enable)
#undef set_home
#define set_home (ip->set_home)
#undef index_fb
#define index_fb (ip->index_fb)
#undef pulse_inc
#define pulse_inc (ip->pulse_inc)
#undef pulse_dec
#define pulse_dec (ip->pulse_dec)
#undef drive_on
#define drive_on (ip->drive_on)
#undef drive_dir
#define drive_dir (ip->drive_dir)
#undef drive_brake
#define drive_brake (ip->drive_brake)
#undef active
#define active (ip->active)
#undef component_state
#define component_state (ip->component_state)
#undef index_curr
#define index_curr (ip->index_curr)
#undef index_target
#define index_target (ip->index_target)
#undef indextable_active
#define indextable_active (ip->indextable_active)
#undef prev_start
#define prev_start (ip->prev_start)
#undef prev_set_home
#define prev_set_home (ip->prev_set_home)
#undef prev_index_switch
#define prev_index_switch (ip->prev_index_switch)
#undef prev_pulse_inc
#define prev_pulse_inc (ip->prev_pulse_inc)
#undef prev_pulse_dec
#define prev_pulse_dec (ip->prev_pulse_dec)
#undef direction
#define direction (ip->direction)
#undef state
#define state (ip->state)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 69 "hal/i_components/indextablev2.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t pos_difference;
    // check inputs
    if (gb(enable) == 0) {
        // set pins for drive, direction, brake and active low
        // direct stop
        sb(drive_on, false);
        sb(drive_brake, true);
        indextable_active = false;
        sb(active, indextable_active);
        state = 0;
    }
    else {
        switch (state){
            case 0: // disabled
                if (gb(enable) == 1) state = 1; // go to enable state
                break;
            case 1: // inactive state
                // detect rising edge pulse-inc pin, increase current target and start moving
                if ((gb(pulse_inc) && !prev_pulse_inc) && (gb(pulse_inc) == 1)) {
                    index_target = index_curr + 1;
                    state = 2;
                }
                // detect rising edge pulse-dec pin, decrease current target and start moving
                if ((gb(pulse_dec) && !prev_pulse_dec) && (gb(pulse_dec) == 1)) {
                    index_target = index_curr - 1;
                    state = 2;
                }
                // detect home pin rising edge
                if ((gb(set_home) && !prev_set_home) && (gb(set_home) == 1)) {
                    state = 4;
                }
                // detect rising edge start pin, save target and start moving
                if ((gb(start) && !prev_start) && (gb(start) == 1)) {
                    index_target = gs(index_cmd);
                    state = 2;
                }
                break;
            case 2: // start moving index table
                // if desired position not equals current position, then move
                pos_difference = (index_target - index_curr);
                if (pos_difference == 0) {
                    // do nothing, return to previous state
                    state = 1;
                } else {
                    if (pos_difference > 0) {   // clockwise direction
                        direction = 1;
                    }
                    else {                      // counter clockwise direction
                        direction = 0;
                    }
                    sb(drive_dir, direction);
                    sb(drive_brake, false);
                    sb(drive_on, true);
                    indextable_active = true;
                    state = 3;
                }
                break;
            case 3: // index table is moving
                // detect rising edge index_switch
                if ((gb(index_switch) && !prev_index_switch) && (gb(index_switch) == 1)) {
                    if (direction == 1) {
                        index_curr ++;
                    }
                    else {
                        index_curr --;
                    }
                    if (index_curr == index_target) {
                        // position has been reached
                        // stop and go to next state
                        sb(drive_on, false);
                        sb(drive_brake, true);
                        indextable_active = false;
                        state = 1;
                    }
                }
                break;
            case 4: // set index table current position to commanded position w/o moving
                index_curr = gs(index_cmd);
                state = 1;
                break;
            default: 
                break;
        }
    }
    // store state of start and home input for edge detection
    prev_start = gb(start);
    prev_pulse_inc = gb(pulse_inc);
    prev_pulse_dec = gb(pulse_dec);
    prev_set_home = gb(set_home);
    prev_index_switch = gb(index_switch);
    // output current index to index-fb
    ss(index_fb, index_curr);
    // set state pin
    su(component_state, state);
    sb(active, indextable_active);
    return 0;
}


