
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "joyhandle";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:joyhandle:sets nonlinear joypad movements, deadbands and scales");
MODULE_INFO(machinekit, "pin:in:float:None:in::None");
MODULE_INFO(machinekit, "pin:out:float:None:out::None");
MODULE_INFO(machinekit, "pin:power:float:None:io::2.0");
MODULE_INFO(machinekit, "pin:deadband:float:None:io::0.0");
MODULE_INFO(machinekit, "pin:scale:float:None:io::1.0");
MODULE_INFO(machinekit, "pin:offset:float:None:io::0.0");
MODULE_INFO(machinekit, "pin:inverse:bit:None:io::false");
MODULE_INFO(machinekit, "descr:\nThe component \\fBjoyhandle\\fR uses the following formula for a non linear joypad movements:\n\n\\fBy = (scale * (a*x^power + b*x)) + offset\\fR\n\nThe parameters a and b are adjusted in such a way, that the function starts at (deadband,offset) and ends at (1,scale+offset).\n\nNegative values will be treated point symetrically to origin. Values -deadband < x < +deadband will be set to zero.\n\nValues x > 1 and x < -1 will be skipped to \\(+-(scale+offset). Invert transforms the function to a progressive movement.\n\nWith power one can adjust the nonlinearity (default = 2). Default for deadband is 0.\n\nValid values are: power >= 1.0 (reasonable values are 1.x .. 4-5, take higher power-values for higher deadbands (>0.5), if you want to start with a nearly horizontal slope), 0 <= deadband < 0.99 (reasonable 0.1).\n\nAn additional offset component can be set in special cases (default = 0).\n\nAll values can be adjusted for each instance separately.\n");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_float_t *in;
    hal_float_t *out;
    hal_float_t *power;
    hal_float_t *deadband;
    hal_float_t *scale;
    hal_float_t *offset;
    hal_bit_t *inverse;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int joyhandle_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_float_newf(HAL_IN, &(ip->in), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IO, &(ip->power), owner_id,
            "%s.power", name);
    if(r != 0) return r;

    *(ip->power) = 2.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->deadband), owner_id,
            "%s.deadband", name);
    if(r != 0) return r;

    *(ip->deadband) = 0.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->scale), owner_id,
            "%s.scale", name);
    if(r != 0) return r;

    *(ip->scale) = 1.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->offset), owner_id,
            "%s.offset", name);
    if(r != 0) return r;

    *(ip->offset) = 0.0;
    r = hal_pin_bit_newf(HAL_IO, &(ip->inverse), owner_id,
            "%s.inverse", name);
    if(r != 0) return r;

    *(ip->inverse) = false;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = joyhandle_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int joyhandle_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*ip->in)
#undef out
#define out (*ip->out)
#undef power
#define power (*ip->power)
#undef deadband
#define deadband (*ip->deadband)
#undef scale
#define scale (*ip->scale)
#undef offset
#define offset (*ip->offset)
#undef inverse
#define inverse (*ip->inverse)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 49 "hal/i_components/joyhandle.icomp"
#include <rtapi_math.h>

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_float_t p,a,b,alin,clin,xm,ym,xinv,yinv;

if (power < 1.0) power =1.0;

if (deadband >= 0.99) deadband = 0.99;
else if (deadband <= 0.0) deadband = 0.0;

p = power - 1.0;
a = -1.0/(rtapi_pow(deadband,p)-1.0);
b = 1.0 - a;
alin = -scale/(deadband-1.0);
clin = 1.0 *(scale+offset-alin);

if (in >= 1.0) out = scale + offset;
else if ((in <= deadband) && (in >= (-1.0 *deadband))) out = 0.0;
else if (in <= -1.0) out = -scale - offset;
else if ((in > deadband) && (in < 1.0))
    {
	if (power == 1.0) out=alin*in + clin;
	else {
		if (inverse == 0) out = scale*(a*rtapi_pow(in,power) + b*in) + offset;
		else {
			xm = (deadband+1.0) / 2.0;
			ym = alin*xm + clin;
			xinv = 2.0 * xm-in;
			yinv = scale*(a*rtapi_pow(xinv,power) + b*xinv) + offset;
			out = 2.0 * ym-yinv;
		     }
	     }
     }
else if ((in < (-1.0 *deadband)) && (in > -1.0))
    {
	if (power == 1.0) out=-1.0*(alin*-1.0*in + clin);
	else {
		if (inverse == 0) out = -1.0 *(scale*(a*rtapi_pow((-1.0*in),power) - b*in) + offset);
		else {
			xm = (deadband+1.0)/2.0;
			ym = alin*xm + clin;
			xinv = 2.0 * xm+in;
			yinv = scale*(a*rtapi_pow(xinv,power) + b*xinv) + offset;
			out =-2.0 *ym-yinv;
		     }
	     }
     }
else out = 0.0;

return 0;


// out = scale*(a*rtapi_pow(in,power) + b*in) + offset;
}


