
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "joyhandlev2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:joyhandlev2:sets nonlinear joypad movements, deadbands and scales");
MODULE_INFO(machinekit, "pin_ptr:in:float:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:out:float:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:power:float:None:io::2.0");
MODULE_INFO(machinekit, "pin_ptr:deadband:float:None:io::0.0");
MODULE_INFO(machinekit, "pin_ptr:scale:float:None:io::1.0");
MODULE_INFO(machinekit, "pin_ptr:offset:float:None:io::0.0");
MODULE_INFO(machinekit, "pin_ptr:inverse:bit:None:io::false");
MODULE_INFO(machinekit, "descr:\nThe component \\fBjoyhandle\\fR uses the following formula for a non linear joypad movements:\n\n\\fBy = (scale * (a*x^power + b*x)) + offset\\fR\n\nThe parameters a and b are adjusted in such a way, that the function starts at (deadband,offset) and ends at (1,scale+offset).\n\nNegative values will be treated point symetrically to origin. Values -deadband < x < +deadband will be set to zero.\n\nValues x > 1 and x < -1 will be skipped to \\(+-(scale+offset). Invert transforms the function to a progressive movement.\n\nWith power one can adjust the nonlinearity (default = 2). Default for deadband is 0.\n\nValid values are: power >= 1.0 (reasonable values are 1.x .. 4-5, take higher power-values for higher deadbands (>0.5), if you want to start with a nearly horizontal slope), 0 <= deadband < 0.99 (reasonable 0.1).\n\nAn additional offset component can be set in special cases (default = 0).\n\nAll values can be adjusted for each instance separately.\n");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    float_pin_ptr in;
    float_pin_ptr out;
    float_pin_ptr power;
    float_pin_ptr deadband;
    float_pin_ptr scale;
    float_pin_ptr offset;
    bit_pin_ptr inverse;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int joyhandlev2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->in = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.in", name);
    if (float_pin_null(ip->in))
            return _halerrno;


    ip->out = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (float_pin_null(ip->out))
            return _halerrno;


    ip->power = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.power", name);
    if (float_pin_null(ip->power))
            return _halerrno;

    set_float_pin(ip->power, 2.0);


    ip->deadband = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.deadband", name);
    if (float_pin_null(ip->deadband))
            return _halerrno;

    set_float_pin(ip->deadband, 0.0);


    ip->scale = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.scale", name);
    if (float_pin_null(ip->scale))
            return _halerrno;

    set_float_pin(ip->scale, 1.0);


    ip->offset = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.offset", name);
    if (float_pin_null(ip->offset))
            return _halerrno;

    set_float_pin(ip->offset, 0.0);


    ip->inverse = halx_pin_bit_newf(HAL_IO, owner_id,
            "%s.inverse", name);
    if (bit_pin_null(ip->inverse))
            return _halerrno;

    set_bit_pin(ip->inverse, false);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = joyhandlev2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int joyhandlev2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (ip->in)
#undef out
#define out (ip->out)
#undef power
#define power (ip->power)
#undef deadband
#define deadband (ip->deadband)
#undef scale
#define scale (ip->scale)
#undef offset
#define offset (ip->offset)
#undef inverse
#define inverse (ip->inverse)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 49 "hal/i_components/joyhandlev2.icomp"
#include <rtapi_math.h>

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_float_t p, a, b, alin, clin, xm, ym, xinv, yinv;

    if (gf(power) < 1.0) 
        sf(power, 1.0);

    if (gf(deadband) >= 0.99) 
        sf(deadband, 0.99);
    else if (gf(deadband) <= 0.0) 
        sf(deadband, 0.0);

    p = gf(power) - 1.0;
    a = -1.0/(rtapi_pow(gf(deadband),p)-1.0);
    b = 1.0 - a;
    alin = -gf(scale)/(gf(deadband)-1.0);
    clin = 1.0 *(gf(scale)+gf(offset)-alin);

    if (gf(in) >= 1.0) 
        sf(out, gf(scale) + gf(offset));
    else if ((gf(in) <= gf(deadband)) && (gf(in) >= (-1.0 *gf(deadband)))) 
        sf(out, 0.0);
    else if (gf(in) <= -1.0) 
        sf(out, -gf(scale) - gf(offset));
    else if ((gf(in) > gf(deadband)) && (gf(in) < 1.0))
        {
        if (gf(power) == 1.0) 
            sf(out, alin * gf(in) + clin);
        else 
            {
            if (gb(inverse) == 0) 
                sf(out, gf(scale) * (a * rtapi_pow(gf(in),gf(power)) + b * gf(in)) + gf(offset));
            else 
                {
                xm = (gf(deadband)+1.0) / 2.0;
                ym = alin*xm + clin;
                xinv = 2.0 * xm-gf(in);
                yinv = gf(scale)*(a*rtapi_pow(xinv,gf(power)) + b*xinv) + gf(offset);
                sf(out, 2.0 * ym - yinv);
                }
            }
        }
    else if ((gf(in) < (-1.0 *gf(deadband))) && (gf(in) > -1.0))
        {
        if (gf(power) == 1.0) 
            sf(out, -1.0 * (alin*-1.0 * gf(in) + clin));
        else 
            {
            if (gb(inverse) == 0) 
                sf(out, -1.0 *(gf(scale) * (a * rtapi_pow((-1.0 * gf(in)),gf(power)) - b * gf(in)) + gf(offset)));
            else 
                {
                xm = (gf(deadband)+1.0)/2.0;
                ym = alin*xm + clin;
                xinv = 2.0 * xm+gf(in);
                yinv = gf(scale)*(a*rtapi_pow(xinv,gf(power)) + b*xinv) + gf(offset);
                sf(out,-2.0 * ym - yinv);
                }
            }
        }
    else 
        sf(out, 0.0);

return 0;


// out = scale*(a*rtapi_pow(in,gf(power)) + b*in) + gf(offset);
}


