
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "knob2floatv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:knob2floatv2:Convert counts (probably from an encoder) to a float value");
MODULE_INFO(machinekit, "pin_ptr:counts:s32:None:in:Counts:None");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:When TRUE, output is controlled by count, when FALSE, output is fixed:None");
MODULE_INFO(machinekit, "pin_ptr:scale:float:None:in:Amount of output change per count:None");
MODULE_INFO(machinekit, "pin_ptr:out:float:None:out:Output value:None");
MODULE_INFO(machinekit, "pin_ptr:max_out:float:None:io:Maximum output value, further increases in count will be ignored:1.0");
MODULE_INFO(machinekit, "pin_ptr:min_out:float:None:io:Minimum output value, further decreases in count will be ignored:0.0");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    s32_pin_ptr counts;
    bit_pin_ptr enable;
    float_pin_ptr scale;
    float_pin_ptr out;
    float_pin_ptr max_out;
    float_pin_ptr min_out;
    hal_s32_t old_counts;
    hal_s32_t old_out;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int knob2floatv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->counts = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.counts", name);
    if (s32_pin_null(ip->counts))
            return _halerrno;


    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;


    ip->scale = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.scale", name);
    if (float_pin_null(ip->scale))
            return _halerrno;


    ip->out = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (float_pin_null(ip->out))
            return _halerrno;


    ip->max_out = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.max-out", name);
    if (float_pin_null(ip->max_out))
            return _halerrno;

    set_float_pin(ip->max_out, 1.0);


    ip->min_out = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.min-out", name);
    if (float_pin_null(ip->min_out))
            return _halerrno;

    set_float_pin(ip->min_out, 0.0);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = knob2floatv2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int knob2floatv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef counts
#define counts (ip->counts)
#undef enable
#define enable (ip->enable)
#undef scale
#define scale (ip->scale)
#undef out
#define out (ip->out)
#undef max_out
#define max_out (ip->max_out)
#undef min_out
#define min_out (ip->min_out)
#undef old_counts
#define old_counts (ip->old_counts)
#undef old_out
#define old_out (ip->old_out)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 34 "hal/i_components/knob2floatv2.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_float_t delta_counts;
hal_float_t tmp_out;

    if ( gf(min_out) > gf(max_out) ) 
        sf(min_out, gf(max_out));
    
    delta_counts = ( (hal_float_t) gs(counts) - old_counts);
    if ( gb(enable) ) {
        tmp_out = old_out + (hal_float_t)delta_counts * gf(scale);
        if ( tmp_out > gf(max_out) ) 
            old_out = gf(max_out);
        else if ( tmp_out < gf(min_out) ) 
            old_out = gf(min_out);
        else 
            old_out = tmp_out;
        }
    sf(out, old_out);
    old_counts += delta_counts;

    return 0;
}


