
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "latencybins";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:latencybins:comp utility for scripts/latencyhistogram\n\nUsage:\n  Read availablebins pin for the number of bins available.\n  Set the maxbinnumber pin for the number of +/- bins.\n    Ensure maxbinnumber <= availablebins\n    For maxbinnumber = N, the bins are numbered:\n       -N ... 0 ... + N bins\n    (the -0 bin is not populated)\n    (total effective bins = 2*maxbinnumber +1)\n  Set nsbinsize pin for the binsize (ns)\n  Iterate:\n    Set index pin to a bin number: 0 <= index <= maxbinnumber.\n    Read check pin and verify that check pin == index pin.\n    Read pbinvalue,nbinvalue,pextra,nextra pins.\n         (pbinvalue is count for bin = +index)\n         (nbinvalue is count for bin = -index)\n         (pextra    is count for all bins > maxbinnumber)\n         (nextra    is count for all bins < maxbinnumber)\n\n   If index is out of range ( index < 0 or index > maxbinnumber)\n   then pbinvalue = nbinvalue = -1.\n   The reset pin may be used to restart.\n   The latency pin outputs the instantaneous latency.\n\nMaintainers note: hardcoded for MAXBINNUMBER==1000\n\n");
MODULE_INFO(machinekit, "pin:maxbinnumber:s32:None:in::1000");
MODULE_INFO(machinekit, "pin:index:s32:None:in::None");
MODULE_INFO(machinekit, "pin:reset:bit:None:in::None");
MODULE_INFO(machinekit, "pin:nsbinsize:s32:None:in::None");
MODULE_INFO(machinekit, "pin:check:s32:None:out::None");
MODULE_INFO(machinekit, "pin:latency:s32:None:out::None");
MODULE_INFO(machinekit, "pin:pbinvalue:s32:None:out::None");
MODULE_INFO(machinekit, "pin:nbinvalue:s32:None:out::None");
MODULE_INFO(machinekit, "pin:pextra:s32:None:out::None");
MODULE_INFO(machinekit, "pin:nextra:s32:None:out::None");
MODULE_INFO(machinekit, "pin:availablebins:s32:None:out::1000");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_s32_t *maxbinnumber;
    hal_s32_t *index;
    hal_bit_t *reset;
    hal_s32_t *nsbinsize;
    hal_s32_t *check;
    hal_s32_t *latency;
    hal_s32_t *pbinvalue;
    hal_s32_t *nbinvalue;
    hal_s32_t *pextra;
    hal_s32_t *nextra;
    hal_s32_t *availablebins;
    __s64 last_timer;
    hal_s32_t last_binmax;
    hal_s32_t first;
    hal_s32_t pbins[1001];
    hal_s32_t nbins[1001];
    hal_s32_t binmax;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int latencybins_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_s32_newf(HAL_IN, &(ip->maxbinnumber), owner_id,
            "%s.maxbinnumber", name);
    if(r != 0) return r;

    *(ip->maxbinnumber) = 1000;
    r = hal_pin_s32_newf(HAL_IN, &(ip->index), owner_id,
            "%s.index", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->reset), owner_id,
            "%s.reset", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_IN, &(ip->nsbinsize), owner_id,
            "%s.nsbinsize", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->check), owner_id,
            "%s.check", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->latency), owner_id,
            "%s.latency", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->pbinvalue), owner_id,
            "%s.pbinvalue", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->nbinvalue), owner_id,
            "%s.nbinvalue", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->pextra), owner_id,
            "%s.pextra", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->nextra), owner_id,
            "%s.nextra", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->availablebins), owner_id,
            "%s.availablebins", name);
    if(r != 0) return r;

    *(ip->availablebins) = 1000;
    ip->last_timer = 0;
    ip->last_binmax = 0;
    ip->first = 1;
    ip->binmax = 0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = latencybins_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int latencybins_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef maxbinnumber
#define maxbinnumber (0+*ip->maxbinnumber)
#undef index
#define index (0+*ip->index)
#undef reset
#define reset (0+*ip->reset)
#undef nsbinsize
#define nsbinsize (0+*ip->nsbinsize)
#undef check
#define check (*ip->check)
#undef latency
#define latency (*ip->latency)
#undef pbinvalue
#define pbinvalue (*ip->pbinvalue)
#undef nbinvalue
#define nbinvalue (*ip->nbinvalue)
#undef pextra
#define pextra (*ip->pextra)
#undef nextra
#define nextra (*ip->nextra)
#undef availablebins
#define availablebins (*ip->availablebins)
#undef last_timer
#define last_timer (ip->last_timer)
#undef last_binmax
#define last_binmax (ip->last_binmax)
#undef first
#define first (ip->first)
#undef pbins
#define pbins(i) (ip->pbins[i])
#undef nbins
#define nbins(i) (ip->nbins[i])
#undef binmax
#define binmax (ip->binmax)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

#line 56 "hal/i_components/latencybins.icomp"

__s64     now = rtapi_get_time();
hal_s32_t lat32 = (__s32)(now - last_timer - period);
                //(2^31-1)*1nS = 2.147 seconds max

hal_s32_t i;

last_timer = now;

binmax =  maxbinnumber;
if (binmax > availablebins) binmax = availablebins;
last_binmax = binmax;

if (reset) {first = 1;}

if (   first
     || binmax != last_binmax
     || nsbinsize == 0  // important to avoid divide by zero
  ) {
  first = 0;
  latency = 0;
  pextra = 0; nextra = 0;
  for (i = 0; i <= binmax; i++) {
    pbins(i) = 0; nbins(i) = 0;
  }
} else {
  latency = lat32;
  i = lat32/nsbinsize;
  if (i >= 0) {
     if (i > binmax) {
       pextra++;
     } else {
       pbins(i)++;
     }
  } else {
     i = -i;
     if (i > binmax) {
       nextra++;
     } else {
       nbins(i)++;
     }
  }
}

check = index; // user should verify check==index for reading values
// -1 value indicates illegal index
if (index < 0) {
  pbinvalue = -1;
  nbinvalue = -1;
} else if (index <=binmax) {
  pbinvalue = pbins(index);
  nbinvalue = nbins(index);
} else {
  pbinvalue = -1;
  nbinvalue = -1;
}

return 0;

}

