
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "latencybinsv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:latencybinsv2:comp utility for scripts/latencyhistogram\n\nUsage:\n  Read availablebins pin for the number of bins available.\n  Set the maxbinnumber pin for the number of +/- bins.\n    Ensure maxbinnumber <= availablebins\n    For maxbinnumber = N, the bins are numbered:\n       -N ... 0 ... + N bins\n    (the -0 bin is not populated)\n    (total effective bins = 2*maxbinnumber +1)\n  Set nsbinsize pin for the binsize (ns)\n  Iterate:\n    Set index pin to a bin number: 0 <= index <= maxbinnumber.\n    Read check pin and verify that check pin == index pin.\n    Read pbinvalue,nbinvalue,pextra,nextra pins.\n         (pbinvalue is count for bin = +index)\n         (nbinvalue is count for bin = -index)\n         (pextra    is count for all bins > maxbinnumber)\n         (nextra    is count for all bins < maxbinnumber)\n\n   If index is out of range ( index < 0 or index > maxbinnumber)\n   then pbinvalue = nbinvalue = -1.\n   The reset pin may be used to restart.\n   The latency pin outputs the instantaneous latency.\n\nMaintainers note: hardcoded for MAXBINNUMBER==1000\n\n");
MODULE_INFO(machinekit, "pin_ptr:maxbinnumber:s32:None:in::1000");
MODULE_INFO(machinekit, "pin_ptr:index:s32:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:reset:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:nsbinsize:s32:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:check:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:latency:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:pbinvalue:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:nbinvalue:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:pextra:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:nextra:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:availablebins:s32:None:out::1000");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    s32_pin_ptr maxbinnumber;
    s32_pin_ptr index;
    bit_pin_ptr reset;
    s32_pin_ptr nsbinsize;
    s32_pin_ptr check;
    s32_pin_ptr latency;
    s32_pin_ptr pbinvalue;
    s32_pin_ptr nbinvalue;
    s32_pin_ptr pextra;
    s32_pin_ptr nextra;
    s32_pin_ptr availablebins;
    __s64 last_timer;
    hal_s32_t last_binmax;
    hal_s32_t first;
    hal_s32_t pbins[1001];
    hal_s32_t nbins[1001];
    hal_s32_t binmax;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int latencybinsv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->maxbinnumber = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.maxbinnumber", name);
    if (s32_pin_null(ip->maxbinnumber))
            return _halerrno;

    set_s32_pin(ip->maxbinnumber, 1000);


    ip->index = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.index", name);
    if (s32_pin_null(ip->index))
            return _halerrno;


    ip->reset = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.reset", name);
    if (bit_pin_null(ip->reset))
            return _halerrno;


    ip->nsbinsize = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.nsbinsize", name);
    if (s32_pin_null(ip->nsbinsize))
            return _halerrno;


    ip->check = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.check", name);
    if (s32_pin_null(ip->check))
            return _halerrno;


    ip->latency = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.latency", name);
    if (s32_pin_null(ip->latency))
            return _halerrno;


    ip->pbinvalue = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.pbinvalue", name);
    if (s32_pin_null(ip->pbinvalue))
            return _halerrno;


    ip->nbinvalue = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.nbinvalue", name);
    if (s32_pin_null(ip->nbinvalue))
            return _halerrno;


    ip->pextra = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.pextra", name);
    if (s32_pin_null(ip->pextra))
            return _halerrno;


    ip->nextra = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.nextra", name);
    if (s32_pin_null(ip->nextra))
            return _halerrno;


    ip->availablebins = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.availablebins", name);
    if (s32_pin_null(ip->availablebins))
            return _halerrno;

    set_s32_pin(ip->availablebins, 1000);

    ip->last_timer = 0;
    ip->last_binmax = 0;
    ip->first = 1;
    ip->binmax = 0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = latencybinsv2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int latencybinsv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef maxbinnumber
#define maxbinnumber (ip->maxbinnumber)
#undef index
#define index (ip->index)
#undef reset
#define reset (ip->reset)
#undef nsbinsize
#define nsbinsize (ip->nsbinsize)
#undef check
#define check (ip->check)
#undef latency
#define latency (ip->latency)
#undef pbinvalue
#define pbinvalue (ip->pbinvalue)
#undef nbinvalue
#define nbinvalue (ip->nbinvalue)
#undef pextra
#define pextra (ip->pextra)
#undef nextra
#define nextra (ip->nextra)
#undef availablebins
#define availablebins (ip->availablebins)
#undef last_timer
#define last_timer (ip->last_timer)
#undef last_binmax
#define last_binmax (ip->last_binmax)
#undef first
#define first (ip->first)
#undef pbins
#define pbins(i) (ip->pbins[i])
#undef nbins
#define nbins(i) (ip->nbins[i])
#undef binmax
#define binmax (ip->binmax)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 57 "hal/i_components/latencybinsv2.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

__s64     now = rtapi_get_time();
hal_s32_t lat32 = (__s32)(now - last_timer - period);
                //(2^31-1)*1nS = 2.147 seconds max
hal_s32_t i;

    last_timer = now;

    binmax =  gs(maxbinnumber);
    if (binmax > gs(availablebins)) 
        binmax = gs(availablebins);
    last_binmax = binmax;

    if (gb(reset)) 
        first = 1;

    if (first || binmax != last_binmax  || gs(nsbinsize) == 0 )
    // important to avoid divide by zero
        {
        first = 0;
        ss(latency, 0);
        ss(pextra, 0); 
        ss(nextra, 0);
        for (i = 0; i <= binmax; i++) 
            {
            pbins(i) = 0; 
            nbins(i) = 0;
            }
        } 
    else 
        {
        ss(latency, lat32);
        i = lat32 / gs(nsbinsize);
        if (i >= 0) 
            {
            if (i > binmax) 
                incs(pextra);
            else 
                pbins(i)++;
            } 
        else 
            {
            i = -i;
            if (i > binmax) 
                incs(nextra);
            else 
                nbins(i)++;
            }
        }

    ss(check, gs(index)); // user should verify check==index for reading values
    // -1 value indicates illegal index
    if (gs(index) < 0) 
        {
        ss(pbinvalue, -1);
        ss(nbinvalue, -1);
        } 
    else if (gs(index) <= binmax) 
        {
        ss(pbinvalue, pbins(gs(index)));
        ss(nbinvalue, nbins(gs(index)));
        } 
    else 
        {
        ss(pbinvalue, -1);
        ss(nbinvalue, -1);
        }

return 0;
}


