
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "limit3";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:limit3:Follow input signal while obeying limits\nLimit the output signal to fall between min and max, limit its slew\nrate to less than maxv per second, and limit its second derivative to\nless than maxa per second squared.  When the signal is a position,\nthis means that the position, velocity, and acceleration are limited.");
MODULE_INFO(machinekit, "pin:in:float:None:in::None");
MODULE_INFO(machinekit, "pin:out:float:None:out::None");
MODULE_INFO(machinekit, "pin:out_vel:float:None:out::None");
MODULE_INFO(machinekit, "pin:stopped:bit:None:out::None");
MODULE_INFO(machinekit, "pin:out_acc:float:None:out::None");
MODULE_INFO(machinekit, "pin:load:bit:None:in:When TRUE, immediately set \\fBout\\fB to \\fBin\\fR, ignoring maxv\nand maxa:0");
MODULE_INFO(machinekit, "pin:start:bit:None:in:When FALSE, stop, reducing velocity to zero as quickly as possible,\nrespecting acceleration limits and ignoring input (overidden by \\fBload\\fR\npin):1");
MODULE_INFO(machinekit, "pin:min_:float:None:in::-1e20");
MODULE_INFO(machinekit, "pin:max_:float:None:in::1e20");
MODULE_INFO(machinekit, "pin:maxv:float:None:in::1e20");
MODULE_INFO(machinekit, "pin:maxa:float:None:in::1e20");
MODULE_INFO(machinekit, "pin:smooth_steps:u32:None:in:Smooth out acceleration this many periods before reaching input or\nmax/min limit.  Higher values avoid oscillation, but will accelerate\nslightly more slowly.:2");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_float_t *in;
    hal_float_t *out;
    hal_float_t *out_vel;
    hal_bit_t *stopped;
    hal_float_t *out_acc;
    hal_bit_t *load;
    hal_bit_t *start;
    hal_float_t *min_;
    hal_float_t *max_;
    hal_float_t *maxv;
    hal_float_t *maxa;
    hal_u32_t *smooth_steps;
    double in_pos_old;
    double out_old;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int limit3_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_float_newf(HAL_IN, &(ip->in), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->out_vel), owner_id,
            "%s.out-vel", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->stopped), owner_id,
            "%s.stopped", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->out_acc), owner_id,
            "%s.out-acc", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IN, &(ip->load), owner_id,
            "%s.load", name);
    if(r != 0) return r;

    *(ip->load) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->start), owner_id,
            "%s.start", name);
    if(r != 0) return r;

    *(ip->start) = 1;
    r = hal_pin_float_newf(HAL_IN, &(ip->min_), owner_id,
            "%s.min", name);
    if(r != 0) return r;

    *(ip->min_) = -1e20;
    r = hal_pin_float_newf(HAL_IN, &(ip->max_), owner_id,
            "%s.max", name);
    if(r != 0) return r;

    *(ip->max_) = 1e20;
    r = hal_pin_float_newf(HAL_IN, &(ip->maxv), owner_id,
            "%s.maxv", name);
    if(r != 0) return r;

    *(ip->maxv) = 1e20;
    r = hal_pin_float_newf(HAL_IN, &(ip->maxa), owner_id,
            "%s.maxa", name);
    if(r != 0) return r;

    *(ip->maxa) = 1e20;
    r = hal_pin_u32_newf(HAL_IN, &(ip->smooth_steps), owner_id,
            "%s.smooth-steps", name);
    if(r != 0) return r;

    *(ip->smooth_steps) = 2;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = limit3_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int limit3_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*ip->in)
#undef out
#define out (*ip->out)
#undef out_vel
#define out_vel (*ip->out_vel)
#undef stopped
#define stopped (*ip->stopped)
#undef out_acc
#define out_acc (*ip->out_acc)
#undef load
#define load (0+*ip->load)
#undef start
#define start (0+*ip->start)
#undef min_
#define min_ (0+*ip->min_)
#undef max_
#define max_ (0+*ip->max_)
#undef maxv
#define maxv (0+*ip->maxv)
#undef maxa
#define maxa (0+*ip->maxa)
#undef smooth_steps
#define smooth_steps (0+*ip->smooth_steps)
#undef in_pos_old
#define in_pos_old (ip->in_pos_old)
#undef out_old
#define out_old (ip->out_old)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 31 "hal/i_components/limit3.icomp"

#include "rtapi_math.h"

#define SET_NEXT_STATE(_out, _in)			\
    do {						\
        out_acc = ((_out-out)/fperiod-out_vel)/fperiod; \
        out_vel = (_out-out)/fperiod;                   \
        stopped = (rtapi_fabs(out_vel) < EPSILON);      \
	out_old = out;					\
	out = _out;					\
	in_pos_old = _in;				\
	return 0;					\
    } while (0)

#define VALID_NEXT(pos) ((pos) <= max_pos && (pos) >= min_pos)

// Distance = avg. velocity * time
#define S_GIVEN_VI_VF_T(vi,vf,t) (((vf) + (vi))/2 * (t))
// Time = chg. velocity / acceleration
#define T_GIVEN_VI_VF_A(vi,vf,a) (((vf) - (vi)) / (a))
// Final velocity = initial velocity + acceleration * time
#define VF_GIVEN_VI_A_T(vi,a,t) ((vi) + (a)*(t))
// A fudge amount for division errors
#define EPSILON 1e-9

FUNCTION(_) {
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    double in_pos_lim, in_vel;
    double min_vel, max_vel, min_pos, max_pos;
    double stop_pos_max, stop_pos_min;
    double stop_time_max, stop_time_min;
    double in_vel_time_max, in_vel_time_min;
    double out_pos_max, out_pos_min, in_pos_max, in_pos_min;
    double ach_pos_min, ach_pos_max;

    double goal_pos_min, goal_pos_max, goal_pos_cur;
    double pos_diff, vel_diff, goal_pos_prev;
    double t, ti, a, v, s;

    if (load) {
	// Apply first order limit
	in_pos_lim = rtapi_fmin(max_, rtapi_fmax(min_, in));
	SET_NEXT_STATE(in_pos_lim, in_pos_lim);
	return 0;
    }

    // Principal of operation:
    //
    // 1. Calculate shortest distance (at max acceleration) to
    //    stop (i.e. reach vel=0) and to match the input velocity
    // 2. Compare our projected positions and choose whether to worry
    //    about the max/min limits or to follow the input signal
    // 3. Adjust acceleration according to decision and return

    // 1.  Calculate distances and times to stop and match input velocity
    //
    // Input velocity
    in_vel = (in - in_pos_old) / fperiod;
    //
    // Most negative/positive velocity reachable in one period
    min_vel = rtapi_fmax(VF_GIVEN_VI_A_T(out_vel, -maxa, fperiod), -maxv);
    max_vel = rtapi_fmin(VF_GIVEN_VI_A_T(out_vel,  maxa, fperiod),  maxv);
    // Most negative/positive position reachable in one period
    // - cur. pos + (distance to reach min/max vel in one period)
    min_pos = out + min_vel * fperiod;
    max_pos = out + max_vel * fperiod;
    //
    // Shortest possible distance to stop
    // - time to decel to 0; start from previous period
    stop_time_max = rtapi_fabs(T_GIVEN_VI_VF_A(max_vel, 0.0, maxa)) + fperiod;
    stop_time_min = rtapi_fabs(T_GIVEN_VI_VF_A(min_vel, 0.0, maxa)) + fperiod;
    // - distance to stop from max_pos/min_pos
    stop_pos_max = out + S_GIVEN_VI_VF_T(max_vel, 0.0, stop_time_max);
    stop_pos_min = out + S_GIVEN_VI_VF_T(min_vel, 0.0, stop_time_min);
    //
    // Shortest possible distance to match input velocity
    // - time to match input velocity from this period; out runs 1 period behind
    in_vel_time_max = rtapi_fabs(T_GIVEN_VI_VF_A(max_vel, in_vel, maxa)) - fperiod;
    in_vel_time_min = rtapi_fabs(T_GIVEN_VI_VF_A(min_vel, in_vel, maxa)) - fperiod;
    // - output position after velocity match
    out_pos_max = max_pos + S_GIVEN_VI_VF_T(max_vel, in_vel, in_vel_time_max);
    out_pos_min = min_pos + S_GIVEN_VI_VF_T(min_vel, in_vel, in_vel_time_min);
    // - input position after velocity match
    in_pos_max = in + in_vel * in_vel_time_max;
    in_pos_min = in + in_vel * in_vel_time_min;

    // 2. Choose the current goal:  stop, input signal, max limit or min limit
    //
    // Min/Max limits, stop:
    // - assume we're stopping by default
    vel_diff = -out_vel;
    ach_pos_min = stop_pos_min;
    ach_pos_max = stop_pos_max;
    // - is the start pin cleared?
    if (!start)
        if (out > stop_pos_min && out < stop_pos_max)
            goal_pos_min = goal_pos_max = goal_pos_cur = goal_pos_prev = out;
        else if (stop_time_max < stop_time_min)
            goal_pos_min = goal_pos_max = goal_pos_cur = goal_pos_prev =
                stop_pos_max;
        else
            goal_pos_min = goal_pos_max = goal_pos_cur = goal_pos_prev =
                stop_pos_min;
    // - are we headed to crash into a min/max limit?
    else if (stop_pos_max > max_ + EPSILON && !VALID_NEXT(max_))
	goal_pos_min = goal_pos_max = goal_pos_cur = goal_pos_prev = max_;
    else if (stop_pos_min < min_ - EPSILON && !VALID_NEXT(min_))
	goal_pos_min = goal_pos_max = goal_pos_cur = goal_pos_prev = min_;
    // - if input is outside min/max limit but heading back in, is
    //   there time to keep heading toward the limit before we need to
    //   start running to meet the input signal?
    else if (in >= max_ && in_pos_max > out_pos_max)
	goal_pos_min = goal_pos_max = goal_pos_cur = goal_pos_prev = max_;
    else if (in <= min_ && in_pos_min < out_pos_min)
	goal_pos_min = goal_pos_max = goal_pos_cur = goal_pos_prev = min_;
    //
    // Input signal:
    // - no min/max constraints; chase the input signal
    else {
	goal_pos_min = in_pos_min;
	goal_pos_max = in_pos_max;
	goal_pos_cur = in;
	goal_pos_prev = in_pos_old;
	vel_diff = out_vel - in_vel;
	ach_pos_min = out_pos_min;
	ach_pos_max = out_pos_max;
    }

    // 3.  Adjust acceleration
    //
    // - Difference in position, last cycle
    pos_diff = out - goal_pos_prev;
    // - Time to reach goal position and velocity with uniform acceleration
    if (rtapi_fabs(vel_diff) < EPSILON)
	t = 0;
    else
	t = pos_diff / ((vel_diff + 0) / 2); // t = dp / (avg dv)

    // - If current position and velocity are close enough to reach
    //   goal position in this period, and maintaining goal velocity
    //   in the next period doesn't violate acceleration constraints,
    //   pass the input straight to the output
    if (VALID_NEXT(goal_pos_cur) && rtapi_fabs(t) <= fperiod)
	    SET_NEXT_STATE(goal_pos_cur, in);

    // - If no danger of overshoot, accel at max in direction of goal
    if (ach_pos_max < goal_pos_max + EPSILON)
	// Max pos. accel toward goal will still fall short
	SET_NEXT_STATE(max_pos, in);
    if (ach_pos_min > goal_pos_min - EPSILON)
	// Max neg. accel toward goal will still fall short
	SET_NEXT_STATE(min_pos, in);

    // - If close to reaching goal, try to grease a landing; always
    //   using max acceleration can result in oscillating around the
    //   goal but never quite getting things right to 'lock' onto it
    if (rtapi_fabs(t) < fperiod * smooth_steps) {
	// - Round up the magnitude of time to an integral number of periods
#       define SIGN(n) (((n)>=0) ? 1 : -1)
	ti = (int)((t - EPSILON*SIGN(t)) / fperiod + SIGN(t)) * fperiod;
	// - Uniform acceleration to reach goal in time `ti`
	a = (vel_diff - 0) / ti;
	v = out_vel + a * fperiod;
	s = v * fperiod;
	// - Effect new position, within limits
	SET_NEXT_STATE(rtapi_fmin(max_pos, rtapi_fmax(min_pos, out + s)), in);
    }

    // - If moving toward goal and in danger of overshoot, accelerate
    //   at max in opposite direction of goal
    if (goal_pos_max + EPSILON < ach_pos_max && goal_pos_prev > out)
    	// Heading up from below
	SET_NEXT_STATE(min_pos, in);
    if (goal_pos_min - EPSILON > ach_pos_min && goal_pos_prev < out)
    	// Heading down from above
	SET_NEXT_STATE(max_pos, in);

    // - Shouldn't get here; coast
    SET_NEXT_STATE((min_pos+max_pos)/2, in);
}


