
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "lincurve";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:lincurve:one-dimensional lookup table");
MODULE_INFO(machinekit, "descr:Performs a 1-dimensional lookup and interpolation. The x-val\nparameters must be monotonic, though identical adjacent values are allowed.\n(for example 0,0,0,10) for a 4-element curve.\n\nFor input values less than the x-val-00 breakpoint the y-val-00 is returned.\nFor x greater than the largest x-val-NN the yval corresponding to x-max is\nreturned (ie, no extrapolation is performed.)\n\nSample usage: loadrt lincurve-inst\n              newinst lincurve newone pincount=4 iprefix=lincurve4\nfor a 4-element curve.\n\nThe axis breakpoints should be set in the lincurve.x-val-NN parameters using\n\"setp\", as should the corresponding y values.\n");
MODULE_INFO(machinekit, "pin:x-val-##:float:pincount:io:axis breakpoints:None");
MODULE_INFO(machinekit, "pin:y-val-##:float:pincount:io:output values to be interpolated:None");
MODULE_INFO(machinekit, "pin:in_:float:None:in:The input value:None");
MODULE_INFO(machinekit, "pin:out_:float:None:out:The output value:None");
MODULE_INFO(machinekit, "pin:out-io:float:None:io:The output value, compatible with PID gains:None");
MODULE_INFO(machinekit, "instanceparam:pincount:int::4");
MODULE_INFO(machinekit, "author:Andy Pugh");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


#define MAXCOUNT 16
#define DEFAULTCOUNT 4

static int pincount = 4;
RTAPI_IP_INT(pincount, "");

struct inst_data
    {
    hal_float_t *x_val[16];
    hal_float_t *y_val[16];
    hal_float_t *in_;
    hal_float_t *out_;
    hal_float_t *out_io;
    hal_u32_t i;
    int local_argc;
    char **local_argv;
    int local_pincount;
    };

static int maxpins __attribute__((unused)) = 16;
static int lincurve_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

static int extra_inst_setup(
struct inst_data* ip, const char *name, int argc,
char* const *argv);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    z = pincount;
    if(z > maxpins)
       z = maxpins;
    for(j=0; j < z; j++)
        {
        r = hal_pin_float_newf(HAL_IO, &(ip->x_val[j]), owner_id,
            "%s.x-val-%02d", name, j);
        if(r != 0) return r;
        }

    z = pincount;
    if(z > maxpins)
       z = maxpins;
    for(j=0; j < z; j++)
        {
        r = hal_pin_float_newf(HAL_IO, &(ip->y_val[j]), owner_id,
            "%s.y-val-%02d", name, j);
        if(r != 0) return r;
        }

    r = hal_pin_float_newf(HAL_IN, &(ip->in_), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_OUT, &(ip->out_), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IO, &(ip->out_io), owner_id,
            "%s.out-io", name);
    if(r != 0) return r;

    ip->i = 0;

// if not set by instantiate() set to default
    if(! ip->local_pincount || ip->local_pincount == -1)
         ip->local_pincount = DEFAULTCOUNT;

    hal_print_msg(RTAPI_MSG_DBG,"export_halobjs() ip->local_pincount set to %d", ip->local_pincount);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = lincurve_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;
int k;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values
    hal_print_msg(RTAPI_MSG_DBG,"%s: int instance param: %s=%d",__FUNCTION__,"pincount", pincount);
//  if pincount=NN is passed, set local variable here, if not set to default
    int pin_param_value = pincount;
    if((pin_param_value == -1) || (pin_param_value == 0))
        pin_param_value = DEFAULTCOUNT;
    else if((pin_param_value > 0) && (pin_param_value > MAXCOUNT))
        pin_param_value = MAXCOUNT;
    ip->local_pincount = pincount = pin_param_value;
    hal_print_msg(RTAPI_MSG_DBG,"ip->local_pincount set to %d", pin_param_value);

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    // if the extra_inst_setup returns non zero will abort module creation
    k = extra_inst_setup(ip, name, argc, argv);
    if(k != 0)
        return k;

//reset pincount to -1 so that instantiation without it will result in DEFAULTCOUNT
    pincount = -1;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int lincurve_(void *arg, const hal_funct_args_t *fa)
// if the extra_inst_setup returns non zero it will abort the module creation
#undef EXTRA_INST_SETUP
#define EXTRA_INST_SETUP() \
static int extra_inst_setup( \
struct inst_data *ip, const char *name, \
int argc, char* const *argv)
#undef fperiod
#define fperiod (period * 1e-9)
#undef x_val
#define x_val(i) (*(ip->x_val[i]))
#undef y_val
#define y_val(i) (*(ip->y_val[i]))
#undef in_
#define in_ (0+*ip->in_)
#undef out_
#define out_ (*ip->out_)
#undef out_io
#define out_io (*ip->out_io)
#undef i
#define i (ip->i)
#undef local_pincount
#define local_pincount (ip->local_pincount)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 41 "hal/i_components/lincurve.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_float_t f, x;
    x = in_;
    if (x >= x_val(local_pincount-1)) {
        out_ = y_val(local_pincount-1);
        out_io = out_;
        return 0;
    }
    if (x <= x_val(0)) {
        out_ = y_val(0);
        out_io = out_;
        return 0;
    }
    while (x > x_val(i+1)) { i++;}
    while (x < (x_val(i))) { i--;}

    f = (x - x_val(i)) / ( x_val(i+1) - x_val(i) ) ;
    out_ = y_val(i) + f * (y_val(i+1) - y_val(i) ) ;
    out_io = out_;

return 0;
}

EXTRA_INST_SETUP(){
//	if (local_pincount > 16) local_pincount = 16;
	if (local_pincount < 2) local_pincount = 2;
	return 0;
}


