
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:46 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "lut5v2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:lut5v2:Arbitrary 5-input logic function based on a look-up table");
MODULE_INFO(machinekit, "pin_ptr:in_0:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:in_1:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:in_2:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:in_3:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:in_4:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:out:bit:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:function:u32:None:io::None");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "descr:\n.B lut5\nconstructs a logic function with up to 5 inputs using a\n\\fBl\\fRook-\\fBu\\fRp \\fBt\\fRable. The value for \\fBfunction\\fR can be\ndetermined by writing the truth table, and computing the sum of \\fBall\\fR\nthe \\fBweights\\fR for which the output value would be \\fRtrue\\fR.\nThe weights are hexadecimal not decimal so hexadecimal math must be used to\nsum the weights. A wiki page has a calculator to assist in computing the proper\nvalue for function.\n.PP\nhttp://wiki.linuxcnc.org/cgi-bin/wiki.pl?Lut5\n.PP\nNote that LUT5 will generate any of the 4,294,967,296\nlogical functions of 5 inputs so \\fBAND\\fR, \\fBOR\\fR, \\fBNAND\\fR,\n\\fBNOR\\fR, \\fBXOR\\fR and every other combinatorial function is possible.\n.PP\n.SS Example Functions\nA 5-input\n\\fIand\\fR function is true only when all the inputs are true, so the correct\nvalue for \\fBfunction\\fR is \\fB0x80000000\\fR.\n.PP\nA 2-input \\fIor\\fR function would be the sum of \\fB0x2\\fR + \\fB0x4\\fR +\n\\fB0x8\\fR, so the correct value for \\fBfunction\\fR is \\fB0xe\\fR.\n.PP\nA 5-input \\fIor\\fR\nfunction is true whenever any of the inputs are true, so the correct value for\n\\fBfunction\\fR is \\fB0xfffffffe\\fR. Because every weight except \\fB0x1\\fR\nis true the function is the sum of every line except the first one.\n.PP\nA 2-input \\fIxor\\fR function is\ntrue whenever exactly one of the inputs is true, so the correct value for\n\\fBfunction\\fR is \\fB0x6\\fR.  Only \\fBin-0\\fR and \\fBin-1\\fR should be\nconnected to signals, because if any other bit is \\fBtrue\\fR then the output\nwill be \\fBfalse\\fR.\n.PP\n.ie '\\*[.T]'html' \\{\\\n.HTML \\\n<STYLE> \\\n#weight TD { text-align: center; padding-left: .5ex; padding-right: .5ex } \\\n#weight TH { text-align: center; padding-left: .5ex; padding-right: .5ex } \\\n#weight TD.W { text-align: right; } \\\n</STYLE> \\\n<TABLE ID=\"weight\" STYLE=\"border: 1px solid black; border-collapse: collapse\"> \\\n    <COL SPAN=5 STYLE=\"margin: .2ex\"><COL SPAN=1 STYLE=\"border-left: 1px solid black\"> \\\n<TR STYLE=\"border-bottom: 1px solid black\"> \\\n    <TH COLSPAN=6>Weights for each line of truth table \\\n<TR STYLE=\"border-bottom: 1px solid black\"> \\\n    <TH>Bit 4<TH>Bit 3<TH>Bit 2<TH>Bit 1<TH>Bit 0<TH> Weight \\\n<TR><TD>0<TD>0<TD>0<TD>0<TD>0<TD CLASS=\"w\">0x1 \\\n<TR><TD>0<TD>0<TD>0<TD>0<TD>1<TD CLASS=\"w\">0x2 \\\n<TR><TD>0<TD>0<TD>0<TD>1<TD>0<TD CLASS=\"w\">0x4 \\\n<TR><TD>0<TD>0<TD>0<TD>1<TD>1<TD CLASS=\"w\">0x8 \\\n<TR><TD>0<TD>0<TD>1<TD>0<TD>0<TD CLASS=\"w\">0x10 \\\n<TR><TD>0<TD>0<TD>1<TD>0<TD>1<TD CLASS=\"w\">0x20 \\\n<TR><TD>0<TD>0<TD>1<TD>1<TD>0<TD CLASS=\"w\">0x40 \\\n<TR><TD>0<TD>0<TD>1<TD>1<TD>1<TD CLASS=\"w\">0x80 \\\n<TR><TD>0<TD>1<TD>0<TD>0<TD>0<TD CLASS=\"w\">0x100 \\\n<TR><TD>0<TD>1<TD>0<TD>0<TD>1<TD CLASS=\"w\">0x200 \\\n<TR><TD>0<TD>1<TD>0<TD>1<TD>0<TD CLASS=\"w\">0x400 \\\n<TR><TD>0<TD>1<TD>0<TD>1<TD>1<TD CLASS=\"w\">0x800 \\\n<TR><TD>0<TD>1<TD>1<TD>0<TD>0<TD CLASS=\"w\">0x1000 \\\n<TR><TD>0<TD>1<TD>1<TD>0<TD>1<TD CLASS=\"w\">0x2000 \\\n<TR><TD>0<TD>1<TD>1<TD>1<TD>0<TD CLASS=\"w\">0x4000 \\\n<TR><TD>0<TD>1<TD>1<TD>1<TD>1<TD CLASS=\"w\">0x8000 \\\n<TR><TD>1<TD>0<TD>0<TD>0<TD>0<TD CLASS=\"w\">0x10000 \\\n<TR><TD>1<TD>0<TD>0<TD>0<TD>1<TD CLASS=\"w\">0x20000 \\\n<TR><TD>1<TD>0<TD>0<TD>1<TD>0<TD CLASS=\"w\">0x40000 \\\n<TR><TD>1<TD>0<TD>0<TD>1<TD>1<TD CLASS=\"w\">0x80000 \\\n<TR><TD>1<TD>0<TD>1<TD>0<TD>0<TD CLASS=\"w\">0x100000 \\\n<TR><TD>1<TD>0<TD>1<TD>0<TD>1<TD CLASS=\"w\">0x200000 \\\n<TR><TD>1<TD>0<TD>1<TD>1<TD>0<TD CLASS=\"w\">0x400000 \\\n<TR><TD>1<TD>0<TD>1<TD>1<TD>1<TD CLASS=\"w\">0x800000 \\\n<TR><TD>1<TD>1<TD>0<TD>0<TD>0<TD CLASS=\"w\">0x1000000 \\\n<TR><TD>1<TD>1<TD>0<TD>0<TD>1<TD CLASS=\"w\">0x2000000 \\\n<TR><TD>1<TD>1<TD>0<TD>1<TD>0<TD CLASS=\"w\">0x4000000 \\\n<TR><TD>1<TD>1<TD>0<TD>1<TD>1<TD CLASS=\"w\">0x8000000 \\\n<TR><TD>1<TD>1<TD>1<TD>0<TD>0<TD CLASS=\"w\">0x10000000 \\\n<TR><TD>1<TD>1<TD>1<TD>0<TD>1<TD CLASS=\"w\">0x20000000 \\\n<TR><TD>1<TD>1<TD>1<TD>1<TD>0<TD CLASS=\"w\">0x40000000 \\\n<TR><TD>1<TD>1<TD>1<TD>1<TD>1<TD CLASS=\"w\">0x80000000 \\\n</TABLE>\n\\}\n.el \\{\\\n.TS\nbox tab(;);\ncb s s s s s\ncb cb cb cb cb | cb\nc  c  c  c  c  | r.\nWeights for each line of truth table\n_\nBit 4;Bit 3;Bit 2;Bit 1;Bit 0; Weight\n_\n0;0;0;0;0;0x1\n0;0;0;0;1;0x2\n0;0;0;1;0;0x4\n0;0;0;1;1;0x8\n0;0;1;0;0;0x10\n0;0;1;0;1;0x20\n0;0;1;1;0;0x40\n0;0;1;1;1;0x80\n0;1;0;0;0;0x100\n0;1;0;0;1;0x200\n0;1;0;1;0;0x400\n0;1;0;1;1;0x800\n0;1;1;0;0;0x1000\n0;1;1;0;1;0x2000\n0;1;1;1;0;0x4000\n0;1;1;1;1;0x8000\n1;0;0;0;0;0x10000\n1;0;0;0;1;0x20000\n1;0;0;1;0;0x40000\n1;0;0;1;1;0x80000\n1;0;1;0;0;0x100000\n1;0;1;0;1;0x200000\n1;0;1;1;0;0x400000\n1;0;1;1;1;0x800000\n1;1;0;0;0;0x1000000\n1;1;0;0;1;0x2000000\n1;1;0;1;0;0x4000000\n1;1;0;1;1;0x8000000\n1;1;1;0;0;0x10000000\n1;1;1;0;1;0x20000000\n1;1;1;1;0;0x40000000\n1;1;1;1;1;0x80000000\n.TE\n\\}\n");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr in_0;
    bit_pin_ptr in_1;
    bit_pin_ptr in_2;
    bit_pin_ptr in_3;
    bit_pin_ptr in_4;
    bit_pin_ptr out;
    u32_pin_ptr function;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int lut5v2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->in_0 = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.in-0", name);
    if (bit_pin_null(ip->in_0))
            return _halerrno;


    ip->in_1 = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.in-1", name);
    if (bit_pin_null(ip->in_1))
            return _halerrno;


    ip->in_2 = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.in-2", name);
    if (bit_pin_null(ip->in_2))
            return _halerrno;


    ip->in_3 = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.in-3", name);
    if (bit_pin_null(ip->in_3))
            return _halerrno;


    ip->in_4 = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.in-4", name);
    if (bit_pin_null(ip->in_4))
            return _halerrno;


    ip->out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (bit_pin_null(ip->out))
            return _halerrno;


    ip->function = halx_pin_u32_newf(HAL_IO, owner_id,
            "%s.function", name);
    if (u32_pin_null(ip->function))
            return _halerrno;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = lut5v2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int lut5v2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in_0
#define in_0 (ip->in_0)
#undef in_1
#define in_1 (ip->in_1)
#undef in_2
#define in_2 (ip->in_2)
#undef in_3
#define in_3 (ip->in_3)
#undef in_4
#define in_4 (ip->in_4)
#undef out
#define out (ip->out)
#undef function
#define function (ip->function)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 139 "hal/i_components/lut5v2.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t shift = 0;
    if(gb(in_0)) shift += 1;
    if(gb(in_1)) shift += 2;
    if(gb(in_2)) shift += 4;
    if(gb(in_3)) shift += 8;
    if(gb(in_4)) shift += 16;

    sb(out, (gu(function) & (1<<shift)) != 0);

return 0;
}


