
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:47 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "message";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:message:Display a message");
MODULE_INFO(machinekit, "descr:Allows HAL pins to trigger a message.");
MODULE_INFO(machinekit, "pin:trigger:bit:None:in:signal that triggers the message:false");
MODULE_INFO(machinekit, "pin:force:bit:None:in:FALSE->TRUE transition forces message redisplay:false");
MODULE_INFO(machinekit, "pin:edge:bit:None:io:Selects desired edge: TRUE = falling, FALSE = rising:true");
MODULE_INFO(machinekit, "pin:message_num:s32:None:in:Required message number:0");
MODULE_INFO(machinekit, "funct:_:0:Display a message when triggered");
MODULE_INFO(machinekit, "license:GPL v2");
MODULE_LICENSE("GPL v2");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_bit_t *trigger;
    hal_bit_t *force;
    hal_bit_t *edge;
    hal_s32_t *message_num;
    hal_bit_t prev_trigger;
    hal_bit_t prev_force;
    hal_bit_t prev_edge;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int message_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

static int extra_inst_setup(
struct inst_data* ip, const char *name, int argc,
char* const *argv);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->trigger), owner_id,
            "%s.trigger", name);
    if(r != 0) return r;

    *(ip->trigger) = false;
    r = hal_pin_bit_newf(HAL_IN, &(ip->force), owner_id,
            "%s.force", name);
    if(r != 0) return r;

    *(ip->force) = false;
    r = hal_pin_bit_newf(HAL_IO, &(ip->edge), owner_id,
            "%s.edge", name);
    if(r != 0) return r;

    *(ip->edge) = true;
    r = hal_pin_s32_newf(HAL_IN, &(ip->message_num), owner_id,
            "%s.message-num", name);
    if(r != 0) return r;

    *(ip->message_num) = 0;
    ip->prev_trigger = false;
    ip->prev_force = true;
    ip->prev_edge = true;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = message_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;
int k;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    // if the extra_inst_setup returns non zero will abort module creation
    k = extra_inst_setup(ip, name, argc, argv);
    if(k != 0)
        return k;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int message_(void *arg, const hal_funct_args_t *fa)
// if the extra_inst_setup returns non zero it will abort the module creation
#undef EXTRA_INST_SETUP
#define EXTRA_INST_SETUP() \
static int extra_inst_setup( \
struct inst_data *ip, const char *name, \
int argc, char* const *argv)
#undef fperiod
#define fperiod (period * 1e-9)
#undef trigger
#define trigger (0+*ip->trigger)
#undef force
#define force (0+*ip->force)
#undef edge
#define edge (*ip->edge)
#undef message_num
#define message_num (0+*ip->message_num)
#undef prev_trigger
#define prev_trigger (ip->prev_trigger)
#undef prev_force
#define prev_force (ip->prev_force)
#undef prev_edge
#define prev_edge (ip->prev_edge)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 38 "hal/i_components/message.icomp"
 
 
FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_bit_t show = false;
    
    if(prev_edge != edge) // edge type has changed 
        {
        prev_edge = edge;
        prev_trigger = !edge;
        }
    if(force != prev_force) // force type has changed 
        {
        prev_force = force;
        if(force && (trigger == edge))
            show = true;
        }
       
    if(trigger != prev_trigger) // trigger has changed 
        {
        prev_trigger = trigger;
        if(trigger == edge)
            show = true;
        }
    if(show && message_num < local_argc)
        {
        rtapi_print_msg(RTAPI_MSG_ERR, "%s", local_argv(message_num));
        }
        
    return 0;
}

EXTRA_INST_SETUP()
{
hal_s32_t i;
    
    // demonstrate that both argv and local_argv hold same
    
    for(i = 0; i < local_argc; i++)
        rtapi_print_msg(RTAPI_MSG_ERR, "%s", argv[i]);
       
    for(i = 0; i < local_argc; i++)
        rtapi_print_msg(RTAPI_MSG_ERR, "%s", local_argv(i));

    return 0;
}


