
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:47 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "multiclick";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:multiclick:Single-, double-, triple-, and quadruple-click detector");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "pin:in:bit:None:in:The input line, this is where we look for clicks.:None");
MODULE_INFO(machinekit, "pin:single_click:bit:None:out:Goes high briefly when a single-click is detected on the 'in' pin.:None");
MODULE_INFO(machinekit, "pin:single_click_only:bit:None:out:Goes high briefly when a single-click is detected on the 'in' pin\nand no second click followed it.:None");
MODULE_INFO(machinekit, "pin:double_click:bit:None:out:Goes high briefly when a double-click is detected on the 'in' pin.:None");
MODULE_INFO(machinekit, "pin:double_click_only:bit:None:out:Goes high briefly when a double-click is detected on the 'in' pin\nand no third click followed it.:None");
MODULE_INFO(machinekit, "pin:triple_click:bit:None:out:Goes high briefly when a triple-click is detected on the 'in' pin.:None");
MODULE_INFO(machinekit, "pin:triple_click_only:bit:None:out:Goes high briefly when a triple-click is detected on the 'in' pin\nand no fourth click followed it.:None");
MODULE_INFO(machinekit, "pin:quadruple_click:bit:None:out:Goes high briefly when a quadruple-click is detected on the 'in' pin.:None");
MODULE_INFO(machinekit, "pin:quadruple_click_only:bit:None:out:Goes high briefly when a quadruple-click is detected on the 'in'\npin and no fifth click followed it.:None");
MODULE_INFO(machinekit, "pin:state:s32:None:out::None");
MODULE_INFO(machinekit, "pin:invert_input:bit:None:io:If false (the default), clicks start with rising edges.  If true,\nclicks start with falling edges.:false");
MODULE_INFO(machinekit, "pin:max_hold_ns:u32:None:io:If the input is held down longer than this, it's not part of a\nmulti-click.  (Default 250,000,000 ns, 250 ms.):250000000");
MODULE_INFO(machinekit, "pin:max_space_ns:u32:None:io:If the input is released longer than this, it's not part of a\nmulti-click.  (Default 250,000,000 ns, 250 ms.):250000000");
MODULE_INFO(machinekit, "pin:output_hold_ns:u32:None:io:Positive pulses on the output pins last this long.  (Default\n100,000,000 ns, 100 ms.):100000000");
MODULE_INFO(machinekit, "descr:A click is defined as a rising edge on the 'in' pin,\nfollowed by the 'in' pin being True for at most 'max-hold-ns' nanoseconds,\nfollowed by a falling edge.\n\nA double-click is defined as two clicks, separated by at\nmost 'max-space-ns' nanoseconds with the 'in' pin in the False state.\n\nI bet you can guess the definition of triple- and quadruple-click.\n\nYou probably want to run the input signal through a debounce component\nbefore feeding it to the multiclick detector, if the input is at all\nnoisy.\n\nThe '*-click' pins go high as soon as the input detects the correct\nnumber of clicks.\n\nThe '*-click-only' pins go high a short while after the click, after\nthe click separator space timeout has expired to show that no further\nclick is coming.  This is useful for triggering halui MDI commands.");
MODULE_INFO(machinekit, "funct:_:0:Detect single-, double-, triple-, and quadruple-clicks");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_bit_t *in;
    hal_bit_t *single_click;
    hal_bit_t *single_click_only;
    hal_bit_t *double_click;
    hal_bit_t *double_click_only;
    hal_bit_t *triple_click;
    hal_bit_t *triple_click_only;
    hal_bit_t *quadruple_click;
    hal_bit_t *quadruple_click_only;
    hal_s32_t *state;
    hal_bit_t *invert_input;
    hal_u32_t *max_hold_ns;
    hal_u32_t *max_space_ns;
    hal_u32_t *output_hold_ns;
    hal_s32_t click_state;
    hal_u32_t timer;
    hal_u32_t timeout;
    hal_u32_t single_click_hold_timer;
    hal_u32_t single_click_only_hold_timer;
    hal_u32_t double_click_hold_timer;
    hal_u32_t double_click_only_hold_timer;
    hal_u32_t triple_click_hold_timer;
    hal_u32_t triple_click_only_hold_timer;
    hal_u32_t quadruple_click_hold_timer;
    hal_u32_t quadruple_click_only_hold_timer;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int multiclick_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->in), owner_id,
            "%s.in", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->single_click), owner_id,
            "%s.single-click", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->single_click_only), owner_id,
            "%s.single-click-only", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->double_click), owner_id,
            "%s.double-click", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->double_click_only), owner_id,
            "%s.double-click-only", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->triple_click), owner_id,
            "%s.triple-click", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->triple_click_only), owner_id,
            "%s.triple-click-only", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->quadruple_click), owner_id,
            "%s.quadruple-click", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->quadruple_click_only), owner_id,
            "%s.quadruple-click-only", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->state), owner_id,
            "%s.state", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_IO, &(ip->invert_input), owner_id,
            "%s.invert-input", name);
    if(r != 0) return r;

    *(ip->invert_input) = false;
    r = hal_pin_u32_newf(HAL_IO, &(ip->max_hold_ns), owner_id,
            "%s.max-hold-ns", name);
    if(r != 0) return r;

    *(ip->max_hold_ns) = 250000000;
    r = hal_pin_u32_newf(HAL_IO, &(ip->max_space_ns), owner_id,
            "%s.max-space-ns", name);
    if(r != 0) return r;

    *(ip->max_space_ns) = 250000000;
    r = hal_pin_u32_newf(HAL_IO, &(ip->output_hold_ns), owner_id,
            "%s.output-hold-ns", name);
    if(r != 0) return r;

    *(ip->output_hold_ns) = 100000000;
    ip->click_state = 0;
    ip->timer = 0;
    ip->timeout = 0;
    ip->single_click_hold_timer = 0;
    ip->single_click_only_hold_timer = 0;
    ip->double_click_hold_timer = 0;
    ip->double_click_only_hold_timer = 0;
    ip->triple_click_hold_timer = 0;
    ip->triple_click_only_hold_timer = 0;
    ip->quadruple_click_hold_timer = 0;
    ip->quadruple_click_only_hold_timer = 0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = multiclick_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int multiclick_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (0+*ip->in)
#undef single_click
#define single_click (*ip->single_click)
#undef single_click_only
#define single_click_only (*ip->single_click_only)
#undef double_click
#define double_click (*ip->double_click)
#undef double_click_only
#define double_click_only (*ip->double_click_only)
#undef triple_click
#define triple_click (*ip->triple_click)
#undef triple_click_only
#define triple_click_only (*ip->triple_click_only)
#undef quadruple_click
#define quadruple_click (*ip->quadruple_click)
#undef quadruple_click_only
#define quadruple_click_only (*ip->quadruple_click_only)
#undef state
#define state (*ip->state)
#undef invert_input
#define invert_input (*ip->invert_input)
#undef max_hold_ns
#define max_hold_ns (*ip->max_hold_ns)
#undef max_space_ns
#define max_space_ns (*ip->max_space_ns)
#undef output_hold_ns
#define output_hold_ns (*ip->output_hold_ns)
#undef click_state
#define click_state (ip->click_state)
#undef timer
#define timer (ip->timer)
#undef timeout
#define timeout (ip->timeout)
#undef single_click_hold_timer
#define single_click_hold_timer (ip->single_click_hold_timer)
#undef single_click_only_hold_timer
#define single_click_only_hold_timer (ip->single_click_only_hold_timer)
#undef double_click_hold_timer
#define double_click_hold_timer (ip->double_click_hold_timer)
#undef double_click_only_hold_timer
#define double_click_only_hold_timer (ip->double_click_only_hold_timer)
#undef triple_click_hold_timer
#define triple_click_hold_timer (ip->triple_click_hold_timer)
#undef triple_click_only_hold_timer
#define triple_click_only_hold_timer (ip->triple_click_only_hold_timer)
#undef quadruple_click_hold_timer
#define quadruple_click_hold_timer (ip->quadruple_click_hold_timer)
#undef quadruple_click_only_hold_timer
#define quadruple_click_only_hold_timer (ip->quadruple_click_only_hold_timer)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 141 "hal/i_components/multiclick.icomp"

typedef enum {
    IDLE = 0,
    SAW_FIRST_RISING_EDGE,
    SAW_FIRST_CLICK,
    SAW_SECOND_RISING_EDGE,
    SAW_SECOND_CLICK,
    SAW_THIRD_RISING_EDGE,
    SAW_THIRD_CLICK,
    SAW_FOURTH_RISING_EDGE,
    SAW_FOURTH_CLICK,
    HELD_TOO_LONG
} state_t;

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_bit_t new_in = in;

    if (invert_input) {
        new_in = !new_in;
    }

    if (click_state != IDLE) {
        timer += period;
    }


    //
    // update the output pins
    //

    if (single_click_hold_timer > 0) {
        if (single_click_hold_timer > period) {
            single_click_hold_timer -= period;
        } else {
            single_click_hold_timer = 0;
            single_click = false;
        }
    }

    if (single_click_only_hold_timer > 0) {
        if (single_click_only_hold_timer > period) {
            single_click_only_hold_timer -= period;
        } else {
            single_click_only_hold_timer = 0;
            single_click_only = false;
        }
    }

    if (double_click_hold_timer > 0) {
        if (double_click_hold_timer > period) {
            double_click_hold_timer -= period;
        } else {
            double_click_hold_timer = 0;
            double_click = false;
        }
    }

    if (double_click_only_hold_timer > 0) {
        if (double_click_only_hold_timer > period) {
            double_click_only_hold_timer -= period;
        } else {
            double_click_only_hold_timer = 0;
            double_click_only = false;
        }
    }

    if (triple_click_hold_timer > 0) {
        if (triple_click_hold_timer > period) {
            triple_click_hold_timer -= period;
        } else {
            triple_click_hold_timer = 0;
            triple_click = false;
        }
    }

    if (triple_click_only_hold_timer > 0) {
        if (triple_click_only_hold_timer > period) {
            triple_click_only_hold_timer -= period;
        } else {
            triple_click_only_hold_timer = 0;
            triple_click_only = false;
        }
    }

    if (quadruple_click_hold_timer > 0) {
        if (quadruple_click_hold_timer > period) {
            quadruple_click_hold_timer -= period;
        } else {
            quadruple_click_hold_timer = 0;
            quadruple_click = false;
        }
    }

    if (quadruple_click_only_hold_timer > 0) {
        if (quadruple_click_only_hold_timer > period) {
            quadruple_click_only_hold_timer -= period;
        } else {
            quadruple_click_only_hold_timer = 0;
            quadruple_click_only = false;
        }
    }


    //
    // update state, if needed
    //

    switch (click_state) {
        case IDLE: {
            if (new_in) {
                click_state = SAW_FIRST_RISING_EDGE;
                timer = 0;
                timeout = max_hold_ns;
            }
            break;
        }

        case SAW_FIRST_RISING_EDGE: {
            if (!new_in) {
                click_state = SAW_FIRST_CLICK;
                timer = 0;
                timeout = max_space_ns;
                single_click = true;
                single_click_hold_timer = output_hold_ns;
            }
            break;
        }

        case SAW_FIRST_CLICK: {
            if (new_in) {
                click_state = SAW_SECOND_RISING_EDGE;
                timer = 0;
                timeout = max_hold_ns;
            }
            break;
        }

        case SAW_SECOND_RISING_EDGE: {
            if (!new_in) {
                click_state = SAW_SECOND_CLICK;
                timer = 0;
                timeout = max_space_ns;
                double_click = true;
                double_click_hold_timer = output_hold_ns;
            }
            break;
        }

        case SAW_SECOND_CLICK: {
            if (new_in) {
                click_state = SAW_THIRD_RISING_EDGE;
                timer = 0;
                timeout = max_hold_ns;
            }
            break;
        }

        case SAW_THIRD_RISING_EDGE: {
            if (!new_in) {
                click_state = SAW_THIRD_CLICK;
                timer = 0;
                timeout = max_space_ns;
                triple_click = true;
                triple_click_hold_timer = output_hold_ns;
            }
            break;
        }

        case SAW_THIRD_CLICK: {
            if (new_in) {
                click_state = SAW_FOURTH_RISING_EDGE;
                timer = 0;
                timeout = max_hold_ns;
            }
            break;
        }

        case SAW_FOURTH_RISING_EDGE: {
            if (!new_in) {
                // four clicks is the most we look for, and we just saw it,
                // so we're done now
                click_state = SAW_FOURTH_CLICK;
                timer = 0;
                timeout = max_space_ns;
                quadruple_click = true;
                quadruple_click_hold_timer = output_hold_ns;
            }
            break;
        }

        case SAW_FOURTH_CLICK: {
            if (new_in) {
                click_state = HELD_TOO_LONG;
            }
            break;
        }

        case HELD_TOO_LONG: {
            if (!new_in) {
                click_state = IDLE;
            }
            break;
        }

        default: {
            // invalid click_state!
            click_state = IDLE;
        }
    }

    if ((click_state != IDLE) && (click_state != HELD_TOO_LONG) && (timer > timeout)) {
        if (new_in) {
            click_state = HELD_TOO_LONG;
        } else {
            // timeout after some activity on the input line, trigger one
            // of the "only" outputs if appropriate
            switch (click_state) {
                case SAW_FIRST_CLICK: {
                    single_click_only = true;
                    single_click_only_hold_timer = output_hold_ns;
                    break;
                }
                case SAW_SECOND_CLICK: {
                    double_click_only = true;
                    double_click_only_hold_timer = output_hold_ns;
                    break;
                }
                case SAW_THIRD_CLICK: {
                    triple_click_only = true;
                    triple_click_only_hold_timer = output_hold_ns;
                    break;
                }
                case SAW_FOURTH_CLICK: {
                    quadruple_click_only = true;
                    quadruple_click_only_hold_timer = output_hold_ns;
                    break;
                }
            }
            click_state = IDLE;
        }
    }

    state = click_state;

return 0;
}


