
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:47 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "multiswitchv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:multiswitchv2:This component toggles between a specified number of output bits");
MODULE_INFO(machinekit, "pin_ptr:up:bit:None:in:Receives signal to toggle up:false");
MODULE_INFO(machinekit, "pin_ptr:down:bit:None:in:Receives signal to toggle down:false");
MODULE_INFO(machinekit, "pin_ptr:top-position:u32:None:io:Number of positions:None");
MODULE_INFO(machinekit, "pin_ptr:position:s32:None:io:Current state (may be set in the HAL):None");
MODULE_INFO(machinekit, "pin_ptr:bit-##:bit:pincount:out:Output bits:false");
MODULE_INFO(machinekit, "instanceparam:pincount:int::6");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "author:ArcEye arceye@mgware.co.uk / Andy Pugh andy@bodgesoc.org");
MODULE_INFO(machinekit, "license:GPL2");
MODULE_LICENSE("GPL2");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

#define MAXCOUNT 32
#define DEFAULTCOUNT 6

static int pincount = 6;
RTAPI_IP_INT(pincount, "");

struct inst_data
    {
    bit_pin_ptr up;
    bit_pin_ptr down;
    u32_pin_ptr top_position;
    s32_pin_ptr position;
    bit_pin_ptr bit[32];
    hal_s32_t old_up;
    hal_s32_t old_down;
    int local_argc;
    char **local_argv;
    int local_pincount;
    };

static int maxpins __attribute__((unused)) = 32;
static int multiswitchv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

static int extra_inst_setup(
struct inst_data* ip, const char *name, int argc,
char* const *argv);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->up = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.up", name);
    if (bit_pin_null(ip->up))
            return _halerrno;

    set_bit_pin(ip->up, false);


    ip->down = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.down", name);
    if (bit_pin_null(ip->down))
            return _halerrno;

    set_bit_pin(ip->down, false);


    ip->top_position = halx_pin_u32_newf(HAL_IO, owner_id,
            "%s.top-position", name);
    if (u32_pin_null(ip->top_position))
            return _halerrno;


    ip->position = halx_pin_s32_newf(HAL_IO, owner_id,
            "%s.position", name);
    if (s32_pin_null(ip->position))
            return _halerrno;

    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->bit[j] = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.bit-%02d", name, j);
        if (bit_pin_null(ip->bit[j]))
            return _halerrno;
        set_bit_pin(ip->bit[j], false);
        }

    ip->old_up = 0;
    ip->old_down = 0;

// if not set by instantiate() set to default
    if(! ip->local_pincount || ip->local_pincount == -1)
         ip->local_pincount = DEFAULTCOUNT;

    hal_print_msg(RTAPI_MSG_DBG,"export_halobjs() ip->local_pincount set to %d", ip->local_pincount);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = multiswitchv2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;
int k;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values
    hal_print_msg(RTAPI_MSG_DBG,"%s: int instance param: %s=%d",__FUNCTION__,"pincount", pincount);
//  if pincount=NN is passed, set local variable here, if not set to default
    int pin_param_value = pincount;
    if((pin_param_value == -1) || (pin_param_value == 0))
        pin_param_value = DEFAULTCOUNT;
    else if((pin_param_value > 0) && (pin_param_value > MAXCOUNT))
        pin_param_value = MAXCOUNT;
    ip->local_pincount = pincount = pin_param_value;
    hal_print_msg(RTAPI_MSG_DBG,"ip->local_pincount set to %d", pin_param_value);

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    // if the extra_inst_setup returns non zero will abort module creation
    k = extra_inst_setup(ip, name, argc, argv);
    if(k != 0)
        return k;

//reset pincount to -1 so that instantiation without it will result in DEFAULTCOUNT
    pincount = -1;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int multiswitchv2_(void *arg, const hal_funct_args_t *fa)
// if the extra_inst_setup returns non zero it will abort the module creation
#undef EXTRA_INST_SETUP
#define EXTRA_INST_SETUP() \
static int extra_inst_setup( \
struct inst_data *ip, const char *name, \
int argc, char* const *argv)
#undef fperiod
#define fperiod (period * 1e-9)
#undef up
#define up (ip->up)
#undef down
#define down (ip->down)
#undef top_position
#define top_position (ip->top_position)
#undef position
#define position (ip->position)
#undef bit
#define bit(i) (ip->bit[i])
#undef old_up
#define old_up (ip->old_up)
#undef old_down
#define old_down (ip->old_down)
#undef local_pincount
#define local_pincount (ip->local_pincount)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 47 "hal/i_components/multiswitchv2.icomp"


FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t i;

    // debounce
    if (gb(up) && !old_up) 
        incs(position); 
    if (gb(down) && !old_down) 
        decs(position);
    old_up = gb(up);
    old_down = gb(down);

    if (gs(position) < 0) 
        ss(position, gu(top_position));
    if (gs(position) > gu(top_position)) 
        ss(position, 0);

    for (i = 0 ; i < local_pincount; i++)
        {
        sb(bit(i), (i == gs(position)));
        }

return 0;

}

EXTRA_INST_SETUP()
{
    su(top_position, local_pincount - 1);
    return 0;
}


