
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:47 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "mux16v2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:mux16v2:Select from one of sixteen input values");
MODULE_INFO(machinekit, "descr:pin_ptr in bit use_graycode\nThis signifies the input will use Gray code instead of binary.\nGray code is a good choice when using physical switches because\nfor each increment only one select input changes at a time.\n\npin_ptr in bit suppress_no_input\nThis suppresses changing the output if all select lines are false.\nThis stops unwanted jumps in output between transitions of input.\nbut make in00 unavaliable.\n\npin_ptr in float debounce_time\nsets debouce time in seconds.  eg. .10 = a tenth of a second\ninput must be stable this long before outputs changes. This\nhelps to ignore 'noisy' switches.\n\npin_ptr in bit sel#[4]\nTogether, these determine which \\fBin\\fIN\\fR value is copied to \\fBout\\fR.\n\npin_ptr out float out_f\npin_ptr out s32 out_s\nFollows the value of one of the \\fBin\\fIN\\fR values according to the four \\fBsel\\fR values\nand whether use-graycode is active.\n\nThe s32 value will be trunuated and limited to the max and min values of signed values.\n.RS\n.TP\n\\fBsel3=false\\fR, \\fBsel2=false\\fR, \\fBsel1=false\\fR, \\fBsel0=false\\fR\n\\fBout\\fR follows \\fBin0\\fR\n.TP\n\\fBsel3=false\\fR, \\fBsel2=false\\fR, \\fBsel1=false\\fR, \\fBsel0=true\\fR\n\\fBout\\fR follows \\fBin1\\fR\n.TP\netc.\n.RE\n");
MODULE_INFO(machinekit, "pin_ptr:use_graycode:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:suppress_no_input:bit:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:debounce_time:float:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:sel#:bit:4:in::None");
MODULE_INFO(machinekit, "pin_ptr:out_f:float:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:out_s:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:elapsed:float:None:out:Current value of the internal debounce timer\n for debugging.:None");
MODULE_INFO(machinekit, "pin_ptr:selected:s32:None:out:Current value of the internal selection variable after conversion\n for debugging:None");
MODULE_INFO(machinekit, "pin_ptr:in##:float:16:in:array of selectable outputs:None");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr use_graycode;
    bit_pin_ptr suppress_no_input;
    float_pin_ptr debounce_time;
    bit_pin_ptr sel[16];
    float_pin_ptr out_f;
    s32_pin_ptr out_s;
    float_pin_ptr elapsed;
    s32_pin_ptr selected;
    float_pin_ptr in[16];
    hal_float_t delaytime;
    hal_s32_t lastnum;
    hal_bit_t running;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 16;
static int mux16v2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->use_graycode = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.use-graycode", name);
    if (bit_pin_null(ip->use_graycode))
            return _halerrno;


    ip->suppress_no_input = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.suppress-no-input", name);
    if (bit_pin_null(ip->suppress_no_input))
            return _halerrno;


    ip->debounce_time = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.debounce-time", name);
    if (float_pin_null(ip->debounce_time))
            return _halerrno;

    z = 4;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->sel[j] = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.sel%01d", name, j);
        if (bit_pin_null(ip->sel[j]))
            return _halerrno;
        }


    ip->out_f = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.out-f", name);
    if (float_pin_null(ip->out_f))
            return _halerrno;


    ip->out_s = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.out-s", name);
    if (s32_pin_null(ip->out_s))
            return _halerrno;


    ip->elapsed = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.elapsed", name);
    if (float_pin_null(ip->elapsed))
            return _halerrno;


    ip->selected = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.selected", name);
    if (s32_pin_null(ip->selected))
            return _halerrno;

    z = 16;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->in[j] = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.in%02d", name, j);
        if (float_pin_null(ip->in[j]))
            return _halerrno;
        }


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = mux16v2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int mux16v2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef use_graycode
#define use_graycode (ip->use_graycode)
#undef suppress_no_input
#define suppress_no_input (ip->suppress_no_input)
#undef debounce_time
#define debounce_time (ip->debounce_time)
#undef sel
#define sel(i) (ip->sel[i])
#undef out_f
#define out_f (ip->out_f)
#undef out_s
#define out_s (ip->out_s)
#undef elapsed
#define elapsed (ip->elapsed)
#undef selected
#define selected (ip->selected)
#undef in
#define in(i) (ip->in[i])
#undef delaytime
#define delaytime (ip->delaytime)
#undef lastnum
#define lastnum (ip->lastnum)
#undef running
#define running (ip->running)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 57 "hal/i_components/mux16v2.icomp"
FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t i,num = 0;
    hal_bit_t internal[4];

    if(gb(suppress_no_input)) 
        {
        if (gb(sel(0)) + gb(sel(1)) + gb(sel(2)) + gb(sel(3)) == false) 
            return 0;
        }
    
    if (gb(use_graycode)) 
        {
        internal[0] = gb(sel(3));
        internal[1] = gb(sel(2));
        internal[2] = gb(sel(1));
        internal[3] = gb(sel(0));
        
        for(i = 1; i < 4; i++)
            internal[i] = internal[i] ^ internal[i - 1];
        
        ss(selected, num = internal[3]+(internal[2]*2) + (internal[1]*4) + (internal[0]*8));
        }
    else
        ss(selected, num = (gb(sel(0)))+(gb(sel(1))*2) + (gb(sel(2))*4) + (gb(sel(3))*8));
    
    if(gf(debounce_time)) 
        {
        if (num != lastnum) 
            {
            if (!running) 
                {
                running = true;
                delaytime = 0.0;
                }
            if (delaytime < gf(debounce_time)) 
                {
                delaytime += fperiod;
                sf(elapsed, delaytime);
                return 0;
                }
            else
                {
                running = false;
                lastnum = num;
                sf(out_f, gf(in(num)));
                ss(out_s, gf(out_f) );
                return 0;
                }
            }
        }
    /* select the output */
    sf(out_f, gf(in(num)));
    ss(out_s, gf(out_f) );

return 0;

}


