
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:47 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "near";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:near:Determine whether two values are roughly equal.");
MODULE_INFO(machinekit, "pin:in1_:float:None:in::None");
MODULE_INFO(machinekit, "pin:in2_:float:None:in::None");
MODULE_INFO(machinekit, "pin:scale:float:None:io::1.0");
MODULE_INFO(machinekit, "pin:difference:float:None:io::0.0");
MODULE_INFO(machinekit, "pin:out:bit:None:out:\n\\fBout\\fR is true if \\fBin1\\fR and \\fBin2\\fR are within a factor of\n\\fBscale\\fR (i.e., for in1 positive, in1/scale <= in2 <= in1*scale), OR\nif their absolute difference is no greater than \\fBdifference\\fR (i.e.,\n|in1-in2| <= difference).  \\fBout\\fR is false otherwise.:None");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_float_t *in1_;
    hal_float_t *in2_;
    hal_float_t *scale;
    hal_float_t *difference;
    hal_bit_t *out;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int near_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_float_newf(HAL_IN, &(ip->in1_), owner_id,
            "%s.in1", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IN, &(ip->in2_), owner_id,
            "%s.in2", name);
    if(r != 0) return r;

    r = hal_pin_float_newf(HAL_IO, &(ip->scale), owner_id,
            "%s.scale", name);
    if(r != 0) return r;

    *(ip->scale) = 1.0;
    r = hal_pin_float_newf(HAL_IO, &(ip->difference), owner_id,
            "%s.difference", name);
    if(r != 0) return r;

    *(ip->difference) = 0.0;
    r = hal_pin_bit_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = near_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int near_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in1_
#define in1_ (0+*ip->in1_)
#undef in2_
#define in2_ (0+*ip->in2_)
#undef scale
#define scale (*ip->scale)
#undef difference
#define difference (*ip->difference)
#undef out
#define out (*ip->out)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 14 "hal/i_components/near.icomp"
#include "rtapi_math.h"
FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

	hal_float_t in1 = in1_, in2 = in2_;
	if(in1 < 0.0) {
		in1 = -in1;
		in2 = -in2;
	}
	if((scale > 1 && in1/scale <= in2 && in2 <= in1*scale) || rtapi_fabs(in1-in2) <= difference)
		out = true;
	else
		out = false;

return 0;
}


