
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:47 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "oneshotv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:oneshotv2:one-shot pulse generator");
MODULE_INFO(machinekit, "descr:creates a variable-length output pulse when the input changes\nstate. This function needs to run in a thread which supports floating point\n(typically the servo thread). This means that the pulse length has to be a\nmultiple of that thread period, typically 1mS.\nFor a similar function that can run in the base thread, and which offers higher\nresolution, see \"edge\".");
MODULE_INFO(machinekit, "pin_ptr:in:bit:None:in:Trigger input:None");
MODULE_INFO(machinekit, "pin_ptr:out:bit:None:out:Active high pulse:None");
MODULE_INFO(machinekit, "pin_ptr:out_not:bit:None:out:Active low pulse:None");
MODULE_INFO(machinekit, "pin_ptr:width:float:None:in:Pulse width in seconds:0");
MODULE_INFO(machinekit, "pin_ptr:time_left:float:None:out:Time left in current output pulse:None");
MODULE_INFO(machinekit, "pin_ptr:retriggerable:bit:None:in:Allow additional edges to extend pulse:true");
MODULE_INFO(machinekit, "pin_ptr:rising:bit:None:in:Trigger on rising edge:true");
MODULE_INFO(machinekit, "pin_ptr:falling:bit:None:in:Trigger on falling edge:false");
MODULE_INFO(machinekit, "funct:_:1:Produce output pulses from input edges");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr in;
    bit_pin_ptr out;
    bit_pin_ptr out_not;
    float_pin_ptr width;
    float_pin_ptr time_left;
    bit_pin_ptr retriggerable;
    bit_pin_ptr rising;
    bit_pin_ptr falling;
    hal_float_t timer;
    hal_bit_t old_in;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int oneshotv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

static int extra_inst_setup(
struct inst_data* ip, const char *name, int argc,
char* const *argv);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->in = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.in", name);
    if (bit_pin_null(ip->in))
            return _halerrno;


    ip->out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (bit_pin_null(ip->out))
            return _halerrno;


    ip->out_not = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.out-not", name);
    if (bit_pin_null(ip->out_not))
            return _halerrno;


    ip->width = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.width", name);
    if (float_pin_null(ip->width))
            return _halerrno;

    set_float_pin(ip->width, 0);


    ip->time_left = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.time-left", name);
    if (float_pin_null(ip->time_left))
            return _halerrno;


    ip->retriggerable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.retriggerable", name);
    if (bit_pin_null(ip->retriggerable))
            return _halerrno;

    set_bit_pin(ip->retriggerable, true);


    ip->rising = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.rising", name);
    if (bit_pin_null(ip->rising))
            return _halerrno;

    set_bit_pin(ip->rising, true);


    ip->falling = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.falling", name);
    if (bit_pin_null(ip->falling))
            return _halerrno;

    set_bit_pin(ip->falling, false);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = oneshotv2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;
int k;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    // if the extra_inst_setup returns non zero will abort module creation
    k = extra_inst_setup(ip, name, argc, argv);
    if(k != 0)
        return k;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int oneshotv2_(void *arg, const hal_funct_args_t *fa)
// if the extra_inst_setup returns non zero it will abort the module creation
#undef EXTRA_INST_SETUP
#define EXTRA_INST_SETUP() \
static int extra_inst_setup( \
struct inst_data *ip, const char *name, \
int argc, char* const *argv)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (ip->in)
#undef out
#define out (ip->out)
#undef out_not
#define out_not (ip->out_not)
#undef width
#define width (ip->width)
#undef time_left
#define time_left (ip->time_left)
#undef retriggerable
#define retriggerable (ip->retriggerable)
#undef rising
#define rising (ip->rising)
#undef falling
#define falling (ip->falling)
#undef timer
#define timer (ip->timer)
#undef old_in
#define old_in (ip->old_in)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 45 "hal/i_components/oneshotv2.icomp"

EXTRA_INST_SETUP()
{
    timer = 0.0;
    old_in = false;
    return 0;
}

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_bit_t new, trigger, old;

    new = gb(in);
    old = old_in;
    trigger = false;
    /* detect edges */
    if ( new && (!old) && gb(rising) ) trigger = 1;
    if ( old && (!new) && gb(falling) ) trigger = 1;
    old_in = new;
    /* is a pulse already running? */
    if ( timer > 0.0 ) {
    if ( ! gb(retriggerable) ) {
        /* ignore edges during pulse */
        trigger = false;
    }
    /* decrement timer */
    timer -= (hal_float_t) ( period * 0.000000001 );
    if ( timer < 0.0 ) timer = 0.0;
    }
    if ( trigger ) {
    /* (re)start pulse */
        timer = gf(width);
    }
    /* drive outputs */
    sf(time_left, timer);
    if ( timer > 0.0 ) {
        sb(out, true);
        sb(out_not, false);
    } else {
        sb(out, false);
        sb(out_not, true);
    }

return 0;
}


