
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "orientv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:orientv2:Provide a PID command input for orientation mode based on current spindle position, target angle and orient mode");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:enable angular output for orientation mode:None");
MODULE_INFO(machinekit, "pin_ptr:mode:s32:None:in:0: rotate - shortest move; 1: always rotate clockwise; 2: always rotate counterclockwise:None");
MODULE_INFO(machinekit, "pin_ptr:position:float:None:in:spindle position input, unit 1 rev:None");
MODULE_INFO(machinekit, "pin_ptr:angle:float:None:in:orient target position in degrees, 0 <= angle < 360:None");
MODULE_INFO(machinekit, "pin_ptr:command:float:None:out:target spindle position, input to PID command:None");
MODULE_INFO(machinekit, "pin_ptr:poserr:float:None:out:in degrees - aid for PID tuning:None");
MODULE_INFO(machinekit, "funct:_:1:Update \\fBcommand\\fR based on \\fBenable\\fR, \\fBposition\\fR, \\fBmode\\fR and \\fBangle\\fR.");
MODULE_INFO(machinekit, "author:Michael Haberler");
MODULE_INFO(machinekit, "descr:\nThis component is designed to support a spindle orientation PID loop by providing a\ncommand value, and fit with the motion spindle-orient support pins to support the M19 code.\n\nThe spindle is assumed to have stopped in an arbitrary position. The spindle\nencoder position is linked to the  \\fBposition\\fR pin.\nThe  current value of the position pin is sampled on a positive edge on the \\fBenable\\fR pin, and\n\\fBcommand\\fR is computed and set as follows: floor(number of\nfull spindle revolutions\nin the \\fBposition\\fR sampled on positive edge)\nplus \\fBangle\\fR/360 (the fractional revolution) +1/-1/0 depending on \\fBmode\\fR.\n\nThe \\fBmode\\fR pin is interpreted as follows:\n\n0: the spindle rotates in the direction with the lesser angle,\nwhich may be clockwise or counterclockwise.\n\n1: the spindle rotates always rotates clockwise to the new angle.\n\n2: the spindle rotates always rotates counterclockwise to the new angle.\n\n\n.SH HAL USAGE\n\nOn \\fBmotion.spindle-orient\\fR disconnect the spindle control and connect to the orient-pid\nloop:\n\nloadrt orient names=orient\n.br\nloadrt pid    names=orient-pid\n.br\nnet orient-angle  motion.spindle-orient-angle orient.angle\n.br\nnet orient-mode   motion.spindle-orient-mode  orient.mode\n.br\nnet orient-enable motion.spindle-orient       orient.enable orient-pid.enable\n.br\nnet spindle-pos    ...encoder..position orient.position orient-pid.feedback\n.br\nnet orient-command orient.command orient-pid.command\n.br\n\n");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr enable;
    s32_pin_ptr mode;
    float_pin_ptr position;
    float_pin_ptr angle;
    float_pin_ptr command;
    float_pin_ptr poserr;
    hal_bit_t last_enable;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int orientv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;


    ip->mode = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.mode", name);
    if (s32_pin_null(ip->mode))
            return _halerrno;


    ip->position = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.position", name);
    if (float_pin_null(ip->position))
            return _halerrno;


    ip->angle = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.angle", name);
    if (float_pin_null(ip->angle))
            return _halerrno;


    ip->command = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.command", name);
    if (float_pin_null(ip->command))
            return _halerrno;


    ip->poserr = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.poserr", name);
    if (float_pin_null(ip->poserr))
            return _halerrno;

    ip->last_enable = false;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = orientv2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int orientv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef enable
#define enable (ip->enable)
#undef mode
#define mode (ip->mode)
#undef position
#define position (ip->position)
#undef angle
#define angle (ip->angle)
#undef command
#define command (ip->command)
#undef poserr
#define poserr (ip->poserr)
#undef last_enable
#define last_enable (ip->last_enable)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 64 "hal/i_components/orientv2.icomp"
#include <rtapi_math.h>

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_float_t target_angle;
hal_float_t latched_position;

    if (gb(enable))
        {
	if (gb(enable) ^ last_enable)
	    {       // positive edge on enable
            latched_position = gf(position); // sample now
            target_angle =  gf(angle) / 360.0;
            switch (gs(mode))
                {
            case 0: // shortest move
                sf(command, rtapi_floor(latched_position+0.5-target_angle) + target_angle);
                break;
            case 1: // always cw
                sf(command, rtapi_ceil(latched_position-target_angle)  + target_angle);
                break;
            case 2: // always ccw
                sf(command, rtapi_floor(latched_position-target_angle) + target_angle) ;
                break;
	            }
	        }
	    sf(poserr, (gf(position) - gf(command)) * 360.0);
        }
    last_enable = gb(enable);

return 0;
}


