
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "out_to_iov2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:out_to_iov2:converts a signal driven by an out pin to a change sensitive io signal");
MODULE_INFO(machinekit, "pin_ptr:in_u32:u32:None:in::0");
MODULE_INFO(machinekit, "pin_ptr:in_s32:s32:None:in::0");
MODULE_INFO(machinekit, "pin_ptr:in_float:float:None:in::0.0");
MODULE_INFO(machinekit, "pin_ptr:in_bit:bit:None:in::false");
MODULE_INFO(machinekit, "pin_ptr:out_u32:u32:None:io::None");
MODULE_INFO(machinekit, "pin_ptr:out_s32:s32:None:io::None");
MODULE_INFO(machinekit, "pin_ptr:out_float:float:None:io::None");
MODULE_INFO(machinekit, "pin_ptr:out_bit:bit:None:io::None");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "author:Alexander Roessler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    u32_pin_ptr in_u32;
    s32_pin_ptr in_s32;
    float_pin_ptr in_float;
    bit_pin_ptr in_bit;
    u32_pin_ptr out_u32;
    s32_pin_ptr out_s32;
    float_pin_ptr out_float;
    bit_pin_ptr out_bit;
    hal_u32_t last_u32;
    hal_u32_t last_s32;
    hal_u32_t last_float;
    hal_u32_t last_bit;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int out_to_iov2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->in_u32 = halx_pin_u32_newf(HAL_IN, owner_id,
            "%s.in-u32", name);
    if (u32_pin_null(ip->in_u32))
            return _halerrno;

    set_u32_pin(ip->in_u32, 0);


    ip->in_s32 = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.in-s32", name);
    if (s32_pin_null(ip->in_s32))
            return _halerrno;

    set_s32_pin(ip->in_s32, 0);


    ip->in_float = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.in-float", name);
    if (float_pin_null(ip->in_float))
            return _halerrno;

    set_float_pin(ip->in_float, 0.0);


    ip->in_bit = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.in-bit", name);
    if (bit_pin_null(ip->in_bit))
            return _halerrno;

    set_bit_pin(ip->in_bit, false);


    ip->out_u32 = halx_pin_u32_newf(HAL_IO, owner_id,
            "%s.out-u32", name);
    if (u32_pin_null(ip->out_u32))
            return _halerrno;


    ip->out_s32 = halx_pin_s32_newf(HAL_IO, owner_id,
            "%s.out-s32", name);
    if (s32_pin_null(ip->out_s32))
            return _halerrno;


    ip->out_float = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.out-float", name);
    if (float_pin_null(ip->out_float))
            return _halerrno;


    ip->out_bit = halx_pin_bit_newf(HAL_IO, owner_id,
            "%s.out-bit", name);
    if (bit_pin_null(ip->out_bit))
            return _halerrno;

    ip->last_u32 = 1;
    ip->last_s32 = 1;
    ip->last_float = 1;
    ip->last_bit = 1;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = out_to_iov2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int out_to_iov2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in_u32
#define in_u32 (ip->in_u32)
#undef in_s32
#define in_s32 (ip->in_s32)
#undef in_float
#define in_float (ip->in_float)
#undef in_bit
#define in_bit (ip->in_bit)
#undef out_u32
#define out_u32 (ip->out_u32)
#undef out_s32
#define out_s32 (ip->out_s32)
#undef out_float
#define out_float (ip->out_float)
#undef out_bit
#define out_bit (ip->out_bit)
#undef last_u32
#define last_u32 (ip->last_u32)
#undef last_s32
#define last_s32 (ip->last_s32)
#undef last_float
#define last_float (ip->last_float)
#undef last_bit
#define last_bit (ip->last_bit)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 20 "hal/i_components/out_to_iov2.icomp"
FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    if (last_u32 != gu(in_u32)) {
        su(out_u32, gu(in_u32));
        last_u32 = gu(in_u32);
    }
    if (last_s32 != gs(in_s32)) {
        ss(out_s32, gs(in_s32));
        last_s32 = gs(in_s32);
    }
    if (last_float != gf(in_float)) {
        sf(out_float, gf(in_float));
        last_float = gf(in_float);
    }
    if (last_bit != gb(in_bit)) {
        sb(out_bit, gb(in_bit));
        last_bit = gb(in_bit);
    }
    return 0;
}


