
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "pidv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:pidv2:HAL component that provides Proportional     Integeral/Derivative control loops.  It is a realtime component.");
MODULE_INFO(machinekit, "descr:\n    HAL component that provides Proportional/\n    Integeral/Derivative control loops.  It is a realtime component.\n\n    The number of pid components is set by the module parameter 'num_chan='\n    when the component is insmod'ed.  Alternatively, use the\n    names= specifier and a list of unique names separated by commas.\n    The names= and num_chan= specifiers are mutually exclusive.\n\n    In this documentation, it is assumed that we are discussing position\n    loops.  However this component can be used to implement other loops\n    such as speed loops, torch height control, and others.\n\n    Each loop has a number of pins and parameters, whose names begin\n    with 'pid.x.', where 'x' is the channel number.  Channel numbers\n    start at zero.\n\n    The three most important pins are 'command', 'feedback', and\n    'output'.  For a position loop, 'command' and 'feedback' are\n    in position units.  For a linear axis, this could be inches,\n    mm, metres, or whatever is relavent.  Likewise, for a angular\n    axis, it could be degrees, radians, etc.  The units of the\n    'output' pin represent the change needed to make the feedback\n    match the command.  As such, for a position loop 'Output' is\n    a velocity, in inches/sec, mm/sec, degrees/sec, etc.\n\n    Each loop has several other pins as well.  'error' is equal to\n    'command' minus 'feedback'.  'enable' is a bit that enables\n    the loop.  If 'enable' is false, all integrators are reset,\n    and the output is forced to zero.  If 'enable' is true, the\n    loop operates normally.\n\n    The PID gains, limits, and other 'tunable' features of the\n    loop are implemented as parameters.  These are as follows:\n\n    Pgain\tProportional gain\n    Igain\tIntegral gain\n    Dgain\tDerivative gain\n    bias\tConstant offset on output\n    FF0\t\tZeroth order Feedforward gain\n    FF1\t\tFirst order Feedforward gain\n    FF2\t\tSecond order Feedforward gain\n    deadband\tAmount of error that will be ignored\n    maxerror\tLimit on error\n    maxerrorI\tLimit on error integrator\n    maxerrorD\tLimit on error differentiator\n    maxcmdD\tLimit on command differentiator\n    maxcmdDD\tLimit on command 2nd derivative\n    maxoutput\tLimit on output value\n\n    All of the limits (max____) are implemented such that if the\n    parameter value is zero, there is no limit.\n\n    A number of internal values which may be usefull for testing\n    and tuning are also available as parameters.  To avoid cluttering\n    the parameter list, these are only exported if \"debug=1\" is\n    specified on the insmod command line.\n\n    errorI\tIntegral of error\n    errorD\tDerivative of error\n    commandD\tDerivative of the command\n    commandDD\t2nd derivative of the command\n\n    The PID loop calculations are as follows (see the code for\n    all the nitty gritty details):\n\n    error = command - feedback\n    if ( abs(error) < deadband ) then error = 0\n    limit error to +/- maxerror\n    errorI += error * period\n    limit errorI to +/- maxerrorI\n    errorD = (error - previouserror) / period\n    limit errorD to +/- maxerrorD\n    commandD = (command - previouscommand) / period\n    limit commandD to +/- maxcmdD\n    commandDD = (commandD - previouscommandD) / period\n    limit commandDD to +/- maxcmdDD\n    output = bias + error * Pgain + errorI * Igain +\n             errorD * Dgain + command * FF0 + commandD * FF1 +\n             commandDD * FF2\n    limit output to +/- maxoutput\n\n    This component exports one function called 'pid.x.do-pid-calcs'\n    for each PID loop.  This allows loops to be included in different\n    threads and execute at different rates.\n");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:Enable/disabled the PID loop:false");
MODULE_INFO(machinekit, "pin_ptr:command:float:None:in:Commanded value:0.0");
MODULE_INFO(machinekit, "pin_ptr:command_deriv:float:None:in:Derivative command input:0.0");
MODULE_INFO(machinekit, "pin_ptr:feedback:float:None:in:Feedback input:0.0");
MODULE_INFO(machinekit, "pin_ptr:feedback_deriv:float:None:in:Derivative feedback input:0.0");
MODULE_INFO(machinekit, "pin_ptr:error:float:None:out:Current error:None");
MODULE_INFO(machinekit, "pin_ptr:output:float:None:out:Ouput value:None");
MODULE_INFO(machinekit, "pin_ptr:saturated:bit:None:out:If the PID loop is saturated:None");
MODULE_INFO(machinekit, "pin_ptr:saturated_s:float:None:out:Saturated time:None");
MODULE_INFO(machinekit, "pin_ptr:saturated_count:s32:None:out:How often the PID loop was saturated:None");
MODULE_INFO(machinekit, "pin_ptr:Pgain:float:None:in:Proportional gain:1.0");
MODULE_INFO(machinekit, "pin_ptr:Igain:float:None:in:Integral gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:Dgain:float:None:in:Derivative gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:bias:float:None:in:Constant offset on output:0.0");
MODULE_INFO(machinekit, "pin_ptr:FF0:float:None:in:Zeroth order Feedforward gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:FF1:float:None:in:First order Feedforward gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:FF2:float:None:in:Second order Feedforward gain:0.0");
MODULE_INFO(machinekit, "pin_ptr:deadband:float:None:in:Amount of error that will be ignored:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxerror:float:None:in:Limit on error:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxerrorI:float:None:in:Limit on error integrator:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxerrorD:float:None:in:Limit on error differentiator:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxcmdD:float:None:in:Limit on command differentiator:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxcmdDD:float:None:in:Limit on command 2nd derivative:0.0");
MODULE_INFO(machinekit, "pin_ptr:maxoutput:float:None:in:Limit on output value:0.0");
MODULE_INFO(machinekit, "pin_ptr:index_enable:bit:None:in:Index enable:false");
MODULE_INFO(machinekit, "pin_ptr:error_previous_target:bit:None:in:Error previous target:false");
MODULE_INFO(machinekit, "pin_ptr:errorI:float:None:out:Integral of error:None");
MODULE_INFO(machinekit, "pin_ptr:errorD:float:None:out:Derivative of error:None");
MODULE_INFO(machinekit, "pin_ptr:commandD:float:None:out:Derivative of the command:None");
MODULE_INFO(machinekit, "pin_ptr:commandDD:float:None:out:2nd derivative of the command:None");
MODULE_INFO(machinekit, "funct:do_pid_calcs:1:");
MODULE_INFO(machinekit, "license:GPL v2");
MODULE_INFO(machinekit, "author:John Kasunich");
MODULE_LICENSE("GPL v2");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr enable;
    float_pin_ptr command;
    float_pin_ptr command_deriv;
    float_pin_ptr feedback;
    float_pin_ptr feedback_deriv;
    float_pin_ptr error;
    float_pin_ptr output;
    bit_pin_ptr saturated;
    float_pin_ptr saturated_s;
    s32_pin_ptr saturated_count;
    float_pin_ptr Pgain;
    float_pin_ptr Igain;
    float_pin_ptr Dgain;
    float_pin_ptr bias;
    float_pin_ptr FF0;
    float_pin_ptr FF1;
    float_pin_ptr FF2;
    float_pin_ptr deadband;
    float_pin_ptr maxerror;
    float_pin_ptr maxerrorI;
    float_pin_ptr maxerrorD;
    float_pin_ptr maxcmdD;
    float_pin_ptr maxcmdDD;
    float_pin_ptr maxoutput;
    bit_pin_ptr index_enable;
    bit_pin_ptr error_previous_target;
    float_pin_ptr errorI;
    float_pin_ptr errorD;
    float_pin_ptr commandD;
    float_pin_ptr commandDD;
    hal_float_t prev_error;
    hal_float_t prev_cmd;
    hal_float_t prev_fb;
    hal_float_t limit_state;
    hal_bit_t prev_ie;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int do_pid_calcs(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;

    set_bit_pin(ip->enable, false);


    ip->command = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.command", name);
    if (float_pin_null(ip->command))
            return _halerrno;

    set_float_pin(ip->command, 0.0);


    ip->command_deriv = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.command-deriv", name);
    if (float_pin_null(ip->command_deriv))
            return _halerrno;

    set_float_pin(ip->command_deriv, 0.0);


    ip->feedback = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.feedback", name);
    if (float_pin_null(ip->feedback))
            return _halerrno;

    set_float_pin(ip->feedback, 0.0);


    ip->feedback_deriv = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.feedback-deriv", name);
    if (float_pin_null(ip->feedback_deriv))
            return _halerrno;

    set_float_pin(ip->feedback_deriv, 0.0);


    ip->error = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.error", name);
    if (float_pin_null(ip->error))
            return _halerrno;


    ip->output = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.output", name);
    if (float_pin_null(ip->output))
            return _halerrno;


    ip->saturated = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.saturated", name);
    if (bit_pin_null(ip->saturated))
            return _halerrno;


    ip->saturated_s = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.saturated-s", name);
    if (float_pin_null(ip->saturated_s))
            return _halerrno;


    ip->saturated_count = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.saturated-count", name);
    if (s32_pin_null(ip->saturated_count))
            return _halerrno;


    ip->Pgain = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.Pgain", name);
    if (float_pin_null(ip->Pgain))
            return _halerrno;

    set_float_pin(ip->Pgain, 1.0);


    ip->Igain = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.Igain", name);
    if (float_pin_null(ip->Igain))
            return _halerrno;

    set_float_pin(ip->Igain, 0.0);


    ip->Dgain = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.Dgain", name);
    if (float_pin_null(ip->Dgain))
            return _halerrno;

    set_float_pin(ip->Dgain, 0.0);


    ip->bias = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.bias", name);
    if (float_pin_null(ip->bias))
            return _halerrno;

    set_float_pin(ip->bias, 0.0);


    ip->FF0 = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.FF0", name);
    if (float_pin_null(ip->FF0))
            return _halerrno;

    set_float_pin(ip->FF0, 0.0);


    ip->FF1 = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.FF1", name);
    if (float_pin_null(ip->FF1))
            return _halerrno;

    set_float_pin(ip->FF1, 0.0);


    ip->FF2 = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.FF2", name);
    if (float_pin_null(ip->FF2))
            return _halerrno;

    set_float_pin(ip->FF2, 0.0);


    ip->deadband = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.deadband", name);
    if (float_pin_null(ip->deadband))
            return _halerrno;

    set_float_pin(ip->deadband, 0.0);


    ip->maxerror = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxerror", name);
    if (float_pin_null(ip->maxerror))
            return _halerrno;

    set_float_pin(ip->maxerror, 0.0);


    ip->maxerrorI = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxerrorI", name);
    if (float_pin_null(ip->maxerrorI))
            return _halerrno;

    set_float_pin(ip->maxerrorI, 0.0);


    ip->maxerrorD = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxerrorD", name);
    if (float_pin_null(ip->maxerrorD))
            return _halerrno;

    set_float_pin(ip->maxerrorD, 0.0);


    ip->maxcmdD = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxcmdD", name);
    if (float_pin_null(ip->maxcmdD))
            return _halerrno;

    set_float_pin(ip->maxcmdD, 0.0);


    ip->maxcmdDD = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxcmdDD", name);
    if (float_pin_null(ip->maxcmdDD))
            return _halerrno;

    set_float_pin(ip->maxcmdDD, 0.0);


    ip->maxoutput = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.maxoutput", name);
    if (float_pin_null(ip->maxoutput))
            return _halerrno;

    set_float_pin(ip->maxoutput, 0.0);


    ip->index_enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.index-enable", name);
    if (bit_pin_null(ip->index_enable))
            return _halerrno;

    set_bit_pin(ip->index_enable, false);


    ip->error_previous_target = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.error-previous-target", name);
    if (bit_pin_null(ip->error_previous_target))
            return _halerrno;

    set_bit_pin(ip->error_previous_target, false);


    ip->errorI = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.errorI", name);
    if (float_pin_null(ip->errorI))
            return _halerrno;


    ip->errorD = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.errorD", name);
    if (float_pin_null(ip->errorD))
            return _halerrno;


    ip->commandD = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.commandD", name);
    if (float_pin_null(ip->commandD))
            return _halerrno;


    ip->commandDD = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.commandDD", name);
    if (float_pin_null(ip->commandDD))
            return _halerrno;

    ip->prev_error = 0.0;
    ip->prev_cmd = 0.0;
    ip->prev_fb = 0.0;
    ip->limit_state = 0.0;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t do_pid_calcs_xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = do_pid_calcs,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.do-pid-calcs", name);
    r = hal_export_xfunctf(&do_pid_calcs_xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int name(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef enable
#define enable (ip->enable)
#undef command
#define command (ip->command)
#undef command_deriv
#define command_deriv (ip->command_deriv)
#undef feedback
#define feedback (ip->feedback)
#undef feedback_deriv
#define feedback_deriv (ip->feedback_deriv)
#undef error
#define error (ip->error)
#undef output
#define output (ip->output)
#undef saturated
#define saturated (ip->saturated)
#undef saturated_s
#define saturated_s (ip->saturated_s)
#undef saturated_count
#define saturated_count (ip->saturated_count)
#undef Pgain
#define Pgain (ip->Pgain)
#undef Igain
#define Igain (ip->Igain)
#undef Dgain
#define Dgain (ip->Dgain)
#undef bias
#define bias (ip->bias)
#undef FF0
#define FF0 (ip->FF0)
#undef FF1
#define FF1 (ip->FF1)
#undef FF2
#define FF2 (ip->FF2)
#undef deadband
#define deadband (ip->deadband)
#undef maxerror
#define maxerror (ip->maxerror)
#undef maxerrorI
#define maxerrorI (ip->maxerrorI)
#undef maxerrorD
#define maxerrorD (ip->maxerrorD)
#undef maxcmdD
#define maxcmdD (ip->maxcmdD)
#undef maxcmdDD
#define maxcmdDD (ip->maxcmdDD)
#undef maxoutput
#define maxoutput (ip->maxoutput)
#undef index_enable
#define index_enable (ip->index_enable)
#undef error_previous_target
#define error_previous_target (ip->error_previous_target)
#undef errorI
#define errorI (ip->errorI)
#undef errorD
#define errorD (ip->errorD)
#undef commandD
#define commandD (ip->commandD)
#undef commandDD
#define commandDD (ip->commandDD)
#undef prev_error
#define prev_error (ip->prev_error)
#undef prev_cmd
#define prev_cmd (ip->prev_cmd)
#undef prev_fb
#define prev_fb (ip->prev_fb)
#undef limit_state
#define limit_state (ip->limit_state)
#undef prev_ie
#define prev_ie (ip->prev_ie)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 148 "hal/i_components/pidv2.icomp"

FUNCTION(do_pid_calcs) {
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_float_t tmp1, tmp2;
    hal_float_t periodfp, periodrecip;

    /* precalculate some timing constants */
    periodfp = (hal_float_t)period * 0.000000001;
    periodrecip = 1.0 / periodfp;
    /* calculate the error */
    if((!(prev_ie && !gb(index_enable))) && gb(error_previous_target)) {
        // the user requests ferror against prev_cmd, and we can honor
        // that request because we haven't just had an index reset that
        // screwed it up.  Otherwise, if we did just have an index
        // reset, we will present an unwanted ferror proportional to
        // velocity for this period, but velocity is usually very small
        // during index search.
        tmp1 = prev_cmd - gf(feedback);
    } else {
        tmp1 = gf(command) - gf(feedback);
    }
    /* store error to error pin */
    sf(error, tmp1);
    /* apply error limits */
    if (gf(maxerror) != 0.0) {
        if (tmp1 > gf(maxerror)) {
            tmp1 = gf(maxerror);
        } else if (tmp1 < -gf(maxerror)) {
            tmp1 = -gf(maxerror);
        }
    }
    /* apply the deadband */
    if (tmp1 > gf(deadband)) {
        tmp1 -= gf(deadband);
    } else if (tmp1 < -gf(deadband)) {
        tmp1 += gf(deadband);
    } else {
        tmp1 = 0.0;
    }
    /* do integrator calcs only if enabled */
    if (gb(enable)) {
        /* if output is in limit, don't let integrator wind up */
        if ( ( tmp1 * limit_state ) <= 0.0 ) {
            /* compute integral term */
            sf(errorI, gf(errorI) + tmp1 * periodfp);
        }
        /* apply integrator limits */
        if (gf(maxerrorI) != 0.0) {
            if (gf(errorI) > gf(maxerrorI)) {
                sf(errorI, gf(maxerrorI));
            } else if (gf(errorI) < -gf(maxerrorI)) {
                sf(errorI, -gf(maxerrorI));
            }
        }
    } else {
        /* not enabled, reset integrator */
        sf(errorI, 0.0);
    }
#if 0
    /* DEBUG: compute command and feedback derivatives to dummysigs */
    if(!(prev_ie && !gb(index_enable))) {
        command_derivds = (gf(command) - prev_cmd) * periodrecip;
        feedback_derivds = (gf(feedback) - prev_fb) * periodrecip;
    }
#endif
    /* and calculate derivative term as difference of derivatives */
    sf(errorD, gf(command_deriv) - gf(feedback_deriv));
    prev_error = tmp1;
    /* apply derivative limits */
    if (gf(maxerrorD) != 0.0) {
        if (gf(errorD) > gf(maxerrorD)) {
            sf(errorD, gf(maxerrorD));
        } else if (gf(errorD) < -gf(maxerrorD)) {
            sf(errorD, -gf(maxerrorD));
        }
    }
    /* calculate derivative of command */
    /* save old value for 2nd derivative calc later */
    tmp2 = gf(commandD);
    if(!(prev_ie && !gb(index_enable))) {
        // not falling edge of index_enable: the normal case
        sf(commandD, (gf(command) - prev_cmd) * periodrecip);
    }
    // else: leave commandD alone and use last period's.  prev_cmd
    // shouldn't be trusted because index homing has caused us to have
    // a step in position.  Using the previous period's derivative is
    // probably a decent approximation since index search is usually a
    // slow steady speed.

    // save ie for next time
    prev_ie = gb(index_enable);

    prev_cmd = gf(command);
    prev_fb = gf(feedback);

    /* apply derivative limits */
    if (gf(maxcmdD) != 0.0) {
        if (gf(commandD) > gf(maxcmdD)) {
            sf(commandD, gf(maxcmdD));
        } else if (gf(commandD) < -gf(maxcmdD)) {
            sf(commandD, gf(maxcmdD));
        }
    }
    /* calculate 2nd derivative of command */
    sf(commandDD, (gf(commandD) - tmp2) * periodrecip);
    /* apply 2nd derivative limits */
    if (gf(maxcmdDD) != 0.0) {
        if (gf(commandDD) > gf(maxcmdDD)) {
            sf(commandDD, gf(maxcmdDD));
        } else if (gf(commandDD) < -gf(maxcmdDD)) {
            sf(commandDD, -gf(maxcmdDD));
        }
    }
    /* do output calcs only if enabled */
    if (gb(enable)) {
    /* calculate the output value */
    tmp1 =
        gf(bias) + gf(Pgain) * tmp1 + gf(Igain) * gf(errorI) + gf(Dgain) * gf(errorD);
    tmp1 += gf(command) * gf(FF0) + gf(commandD) * gf(FF1) + gf(commandDD) * gf(FF2);
    /* apply output limits */
    if (gf(maxoutput) != 0.0) {
        if (tmp1 > gf(maxoutput)) {
            tmp1 = gf(maxoutput);
            limit_state = 1.0;
        } else if (tmp1 < -gf(maxoutput)) {
            tmp1 = -gf(maxoutput);
            limit_state = -1.0;
        } else {
            limit_state = 0.0;
        }
    }
    } else {
        /* not enabled, force output to zero */
        tmp1 = 0.0;
        limit_state = 0.0;
    }
    /* write final output value to output pin */
    sf(output, tmp1);

    /* set 'saturated' outputs */
    if(limit_state) {
        sb(saturated, true);
        sf(saturated_s, gf(saturated_s) + (hal_float_t) period * 1e-9);
        if(gs(saturated_count) != 2147483647)
            incs(saturated_count);
    } else {
        sb(saturated, false);
        sf(saturated_s, 0.0);
        ss(saturated_count, 0);
    }
    /* done */
    return 0;
}



