
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "safety_latchv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:safety_latchv2:latch for error signals");
MODULE_INFO(machinekit, "descr:\nHAL component that implements a safety latch for error singnals\nwith customizable harm, healing and latching features.\n\nWhen the component is not enabled the error input value is\nforwarded to output without further modififactions.\n\nIf error-in is true the error count is increased by harm.\nIf error-in is false the error count is decreased by heal.\nWhen the error count exceeds the threscold value error-out is\nset to true. If latching is false the error-out pin will only\nreturn to false when reset is set to true.\n\nThe inputs pin min and max clamp the error count value to a\nspecified range.\n");
MODULE_INFO(machinekit, "pin_ptr:error_in:bit:None:in:Error Input:false");
MODULE_INFO(machinekit, "pin_ptr:heal:s32:None:in:Heal when ok per tick:1");
MODULE_INFO(machinekit, "pin_ptr:harm:s32:None:in:Harm when error per tick:1");
MODULE_INFO(machinekit, "pin_ptr:latching:bit:None:in:If a reset is necessary to heal an error:true");
MODULE_INFO(machinekit, "pin_ptr:reset:bit:None:in:Reset input:false");
MODULE_INFO(machinekit, "pin_ptr:threshold:s32:None:in:Error output threshold:100");
MODULE_INFO(machinekit, "pin_ptr:min:s32:None:in:Minimum count:0");
MODULE_INFO(machinekit, "pin_ptr:max:s32:None:in:Maximum count:1000");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:If not enabled the error count is passed to the output:true");
MODULE_INFO(machinekit, "pin_ptr:count:s32:None:out:Current count:0");
MODULE_INFO(machinekit, "pin_ptr:error_out:bit:None:out:Error output:false");
MODULE_INFO(machinekit, "pin_ptr:ok_out:bit:None:out:Ok output:true");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "author:Alexander Roessler");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr error_in;
    s32_pin_ptr heal;
    s32_pin_ptr harm;
    bit_pin_ptr latching;
    bit_pin_ptr reset;
    s32_pin_ptr threshold;
    s32_pin_ptr min;
    s32_pin_ptr max;
    bit_pin_ptr enable;
    s32_pin_ptr count;
    bit_pin_ptr error_out;
    bit_pin_ptr ok_out;
    hal_bit_t last_reset;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int safety_latchv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->error_in = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.error-in", name);
    if (bit_pin_null(ip->error_in))
            return _halerrno;

    set_bit_pin(ip->error_in, false);


    ip->heal = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.heal", name);
    if (s32_pin_null(ip->heal))
            return _halerrno;

    set_s32_pin(ip->heal, 1);


    ip->harm = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.harm", name);
    if (s32_pin_null(ip->harm))
            return _halerrno;

    set_s32_pin(ip->harm, 1);


    ip->latching = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.latching", name);
    if (bit_pin_null(ip->latching))
            return _halerrno;

    set_bit_pin(ip->latching, true);


    ip->reset = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.reset", name);
    if (bit_pin_null(ip->reset))
            return _halerrno;

    set_bit_pin(ip->reset, false);


    ip->threshold = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.threshold", name);
    if (s32_pin_null(ip->threshold))
            return _halerrno;

    set_s32_pin(ip->threshold, 100);


    ip->min = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.min", name);
    if (s32_pin_null(ip->min))
            return _halerrno;

    set_s32_pin(ip->min, 0);


    ip->max = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.max", name);
    if (s32_pin_null(ip->max))
            return _halerrno;

    set_s32_pin(ip->max, 1000);


    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;

    set_bit_pin(ip->enable, true);


    ip->count = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.count", name);
    if (s32_pin_null(ip->count))
            return _halerrno;

    set_s32_pin(ip->count, 0);


    ip->error_out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.error-out", name);
    if (bit_pin_null(ip->error_out))
            return _halerrno;

    set_bit_pin(ip->error_out, false);


    ip->ok_out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.ok-out", name);
    if (bit_pin_null(ip->ok_out))
            return _halerrno;

    set_bit_pin(ip->ok_out, true);

    ip->last_reset = false;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = safety_latchv2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int safety_latchv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef error_in
#define error_in (ip->error_in)
#undef heal
#define heal (ip->heal)
#undef harm
#define harm (ip->harm)
#undef latching
#define latching (ip->latching)
#undef reset
#define reset (ip->reset)
#undef threshold
#define threshold (ip->threshold)
#undef min
#define min (ip->min)
#undef max
#define max (ip->max)
#undef enable
#define enable (ip->enable)
#undef count
#define count (ip->count)
#undef error_out
#define error_out (ip->error_out)
#undef ok_out
#define ok_out (ip->ok_out)
#undef last_reset
#define last_reset (ip->last_reset)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 74 "hal/i_components/safety_latchv2.icomp"
#define MIN(x,y) (x < y ? x : y)

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    if (!gb(enable))
    {
        sb(error_out, gb(error_in));
        sb(ok_out, !gb(error_in));
        ss(count, 0);
    }
    else
    {
        if ((gb(reset) ^ last_reset) && gb(reset))
        {
            ss(count, 0);
            sb(error_out, false);
            sb(ok_out, true);
        }

        if (gb(error_in))
        {
            ss(count, gs(count) + gs(harm));
        }
        else
        {
            ss(count, gs(count) - gs(heal));
        }
        ss(count, MIN(MAX(gs(count), gs(min)), gs(max)));

        if (gs(count) >= gs(threshold))
        {
            sb(error_out, true);
            sb(ok_out, false);
        }
        else if (!gb(latching))
        {
            sb(error_out, false);
            sb(ok_out, true);        
        }
    }

    last_reset = gb(reset);

    return 0;
}


