
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "sim_spindlev2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:sim_spindlev2:Simulated spindle with index pulse");
MODULE_INFO(machinekit, "pin_ptr:velocity-cmd:float:None:in:Commanded speed:None");
MODULE_INFO(machinekit, "pin_ptr:position-fb:float:None:out:Feedback position, in revolutions:None");
MODULE_INFO(machinekit, "pin_ptr:index-enable:bit:None:io:Reset position-fb to 0 at next full rotation:None");
MODULE_INFO(machinekit, "pin_ptr:scale:float:None:io:Factor applied to velocity-cmd.:1.0");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    float_pin_ptr velocity_cmd;
    float_pin_ptr position_fb;
    bit_pin_ptr index_enable;
    float_pin_ptr scale;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int sim_spindlev2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->velocity_cmd = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.velocity-cmd", name);
    if (float_pin_null(ip->velocity_cmd))
            return _halerrno;


    ip->position_fb = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.position-fb", name);
    if (float_pin_null(ip->position_fb))
            return _halerrno;


    ip->index_enable = halx_pin_bit_newf(HAL_IO, owner_id,
            "%s.index-enable", name);
    if (bit_pin_null(ip->index_enable))
            return _halerrno;


    ip->scale = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.scale", name);
    if (float_pin_null(ip->scale))
            return _halerrno;

    set_float_pin(ip->scale, 1.0);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = sim_spindlev2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int sim_spindlev2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef velocity_cmd
#define velocity_cmd (ip->velocity_cmd)
#undef position_fb
#define position_fb (ip->position_fb)
#undef index_enable
#define index_enable (ip->index_enable)
#undef scale
#define scale (ip->scale)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 13 "hal/i_components/sim_spindlev2.icomp"
#include "rtapi_math.h"


FUNCTION(_) {
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_float_t old_position = gf(position_fb);
hal_float_t new_position = (gf(position_fb) + gf(velocity_cmd )* fperiod * gf(scale));

    if(gb(index_enable) && (rtapi_floor(old_position) != rtapi_floor(new_position)))
        {
        sb(index_enable, false);
        if(gf(velocity_cmd) < 0)
            new_position = new_position - rtapi_ceil(new_position);
        else
            new_position = new_position - rtapi_floor(new_position);
        }
    sf(position_fb, new_position);

   return 0;
}



