
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "sphereprobe";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:sphereprobe:Probe a pretend hemisphere");
MODULE_INFO(machinekit, "author:Jeff Epler");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "pin:px:s32:None:in::None");
MODULE_INFO(machinekit, "pin:py:s32:None:in::None");
MODULE_INFO(machinekit, "pin:pz:s32:None:in:\\fBrawcounts\\fR position from software encoder:None");
MODULE_INFO(machinekit, "pin:cx:s32:None:in::None");
MODULE_INFO(machinekit, "pin:cy:s32:None:in::None");
MODULE_INFO(machinekit, "pin:cz:s32:None:in:Center of sphere in counts:None");
MODULE_INFO(machinekit, "pin:r:s32:None:in:Radius of hemisphere in counts:None");
MODULE_INFO(machinekit, "pin:probe-out:bit:None:out::None");
MODULE_INFO(machinekit, "funct:_:0:update probe-out based on inputs");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_s32_t *px;
    hal_s32_t *py;
    hal_s32_t *pz;
    hal_s32_t *cx;
    hal_s32_t *cy;
    hal_s32_t *cz;
    hal_s32_t *r;
    hal_bit_t *probe_out;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int sphereprobe_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_s32_newf(HAL_IN, &(ip->px), owner_id,
            "%s.px", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_IN, &(ip->py), owner_id,
            "%s.py", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_IN, &(ip->pz), owner_id,
            "%s.pz", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_IN, &(ip->cx), owner_id,
            "%s.cx", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_IN, &(ip->cy), owner_id,
            "%s.cy", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_IN, &(ip->cz), owner_id,
            "%s.cz", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_IN, &(ip->r), owner_id,
            "%s.r", name);
    if(r != 0) return r;

    r = hal_pin_bit_newf(HAL_OUT, &(ip->probe_out), owner_id,
            "%s.probe-out", name);
    if(r != 0) return r;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = sphereprobe_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int sphereprobe_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef px
#define px (0+*ip->px)
#undef py
#define py (0+*ip->py)
#undef pz
#define pz (0+*ip->pz)
#undef cx
#define cx (0+*ip->cx)
#undef cy
#define cy (0+*ip->cy)
#undef cz
#define cz (0+*ip->cz)
#undef r
#define r (0+*ip->r)
#undef probe_out
#define probe_out (*ip->probe_out)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 18 "hal/i_components/sphereprobe.icomp"
#undef abs
int abs(int x) { if(x < 0) return -x; else return x; }

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    __u64 dx = abs(px-cx), dy=abs(py-cy), dz=abs(pz-cz);
    __u64 d2 = dx*dx + dy*dy;
    __u64 r2 = (__s64)r*(__s64)r;
    if(d2 > r2) {
        probe_out = pz < cz;
    } else {
        d2 += dz*dz;
        probe_out = d2 <= r2;
    }

return 0;
}


