
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "sphereprobev2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:sphereprobev2:Probe a pretend hemisphere");
MODULE_INFO(machinekit, "author:Jeff Epler");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "pin_ptr:px:s32:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:py:s32:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:pz:s32:None:in:\\fBrawcounts\\fR position from software encoder:None");
MODULE_INFO(machinekit, "pin_ptr:cx:s32:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:cy:s32:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:cz:s32:None:in:Center of sphere in counts:None");
MODULE_INFO(machinekit, "pin_ptr:r:s32:None:in:Radius of hemisphere in counts:None");
MODULE_INFO(machinekit, "pin_ptr:probe-out:bit:None:out::None");
MODULE_INFO(machinekit, "funct:_:0:update probe-out based on inputs");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    s32_pin_ptr px;
    s32_pin_ptr py;
    s32_pin_ptr pz;
    s32_pin_ptr cx;
    s32_pin_ptr cy;
    s32_pin_ptr cz;
    s32_pin_ptr r;
    bit_pin_ptr probe_out;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int sphereprobev2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->px = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.px", name);
    if (s32_pin_null(ip->px))
            return _halerrno;


    ip->py = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.py", name);
    if (s32_pin_null(ip->py))
            return _halerrno;


    ip->pz = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.pz", name);
    if (s32_pin_null(ip->pz))
            return _halerrno;


    ip->cx = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.cx", name);
    if (s32_pin_null(ip->cx))
            return _halerrno;


    ip->cy = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.cy", name);
    if (s32_pin_null(ip->cy))
            return _halerrno;


    ip->cz = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.cz", name);
    if (s32_pin_null(ip->cz))
            return _halerrno;


    ip->r = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.r", name);
    if (s32_pin_null(ip->r))
            return _halerrno;


    ip->probe_out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.probe-out", name);
    if (bit_pin_null(ip->probe_out))
            return _halerrno;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = sphereprobev2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int sphereprobev2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef px
#define px (ip->px)
#undef py
#define py (ip->py)
#undef pz
#define pz (ip->pz)
#undef cx
#define cx (ip->cx)
#undef cy
#define cy (ip->cy)
#undef cz
#define cz (ip->cz)
#undef r
#define r (ip->r)
#undef probe_out
#define probe_out (ip->probe_out)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 18 "hal/i_components/sphereprobev2.icomp"
#undef abs
int abs(int x) { if(x < 0) return -x; else return x; }

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    __u64 dx = abs(gs(px)-gs(cx)), dy = abs(gs(py)-gs(cy)), dz = abs(gs(pz) - gs(cz));
    __u64 d2 = dx * dx + dy*dy;
    __u64 r2 = (__s64)gs(r) * (__s64)gs(r);
    if(d2 > r2) {
        sb(probe_out, gs(pz) < gs(cz));
    } else {
        d2 += dz * dz;
        sb(probe_out, d2 <= r2);
    }

return 0;
}


