
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:48 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "sum2v2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:sum2v2:Sum of two inputs (each with a gain) and an offset");
MODULE_INFO(machinekit, "pin_ptr:in0:float:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:in1:float:None:in::None");
MODULE_INFO(machinekit, "pin_ptr:gain0:float:None:io::1.0");
MODULE_INFO(machinekit, "pin_ptr:gain1:float:None:io::1.0");
MODULE_INFO(machinekit, "pin_ptr:offset:float:None:io::None");
MODULE_INFO(machinekit, "pin_ptr:out:float:None:out:out = in0 * gain0 + in1 * gain1 + offset:None");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    float_pin_ptr in0;
    float_pin_ptr in1;
    float_pin_ptr gain0;
    float_pin_ptr gain1;
    float_pin_ptr offset;
    float_pin_ptr out;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int sum2v2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->in0 = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.in0", name);
    if (float_pin_null(ip->in0))
            return _halerrno;


    ip->in1 = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.in1", name);
    if (float_pin_null(ip->in1))
            return _halerrno;


    ip->gain0 = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.gain0", name);
    if (float_pin_null(ip->gain0))
            return _halerrno;

    set_float_pin(ip->gain0, 1.0);


    ip->gain1 = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.gain1", name);
    if (float_pin_null(ip->gain1))
            return _halerrno;

    set_float_pin(ip->gain1, 1.0);


    ip->offset = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.offset", name);
    if (float_pin_null(ip->offset))
            return _halerrno;


    ip->out = halx_pin_float_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (float_pin_null(ip->out))
            return _halerrno;


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = sum2v2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int sum2v2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in0
#define in0 (ip->in0)
#undef in1
#define in1 (ip->in1)
#undef gain0
#define gain0 (ip->gain0)
#undef gain1
#define gain1 (ip->gain1)
#undef offset
#define offset (ip->offset)
#undef out
#define out (ip->out)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 11 "hal/i_components/sum2v2.icomp"
FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    sf(out, (gf(in0) * gf(gain0) + gf(in1) * gf(gain1) + gf(offset)));

return 0;
}


