
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:49 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "timedelta";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:timedelta:\nMachinekit HAL component that measures thread scheduling timing behavior");
MODULE_INFO(machinekit, "pin:out:s32:None:out::None");
MODULE_INFO(machinekit, "pin:err:s32:None:out::0");
MODULE_INFO(machinekit, "pin:min_:s32:None:out::0");
MODULE_INFO(machinekit, "pin:max_:s32:None:out::0");
MODULE_INFO(machinekit, "pin:jitter:s32:None:out::0");
MODULE_INFO(machinekit, "pin:avgerr:s32:None:out::0");
MODULE_INFO(machinekit, "pin:reset:bit:None:in::None");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);


struct inst_data
    {
    hal_s32_t *out;
    hal_s32_t *err;
    hal_s32_t *min_;
    hal_s32_t *max_;
    hal_s32_t *jitter;
    hal_s32_t *avgerr;
    hal_bit_t *reset;
    hal_s64_t last;
    hal_s32_t first;
    hal_s32_t count;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int timedelta_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    r = hal_pin_s32_newf(HAL_OUT, &(ip->out), owner_id,
            "%s.out", name);
    if(r != 0) return r;

    r = hal_pin_s32_newf(HAL_OUT, &(ip->err), owner_id,
            "%s.err", name);
    if(r != 0) return r;

    *(ip->err) = 0;
    r = hal_pin_s32_newf(HAL_OUT, &(ip->min_), owner_id,
            "%s.min", name);
    if(r != 0) return r;

    *(ip->min_) = 0;
    r = hal_pin_s32_newf(HAL_OUT, &(ip->max_), owner_id,
            "%s.max", name);
    if(r != 0) return r;

    *(ip->max_) = 0;
    r = hal_pin_s32_newf(HAL_OUT, &(ip->jitter), owner_id,
            "%s.jitter", name);
    if(r != 0) return r;

    *(ip->jitter) = 0;
    r = hal_pin_s32_newf(HAL_OUT, &(ip->avgerr), owner_id,
            "%s.avgerr", name);
    if(r != 0) return r;

    *(ip->avgerr) = 0;
    r = hal_pin_bit_newf(HAL_IN, &(ip->reset), owner_id,
            "%s.reset", name);
    if(r != 0) return r;

    ip->last = 0;
    ip->first = 1;
    ip->count = 1;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = timedelta_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int timedelta_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef out
#define out (*ip->out)
#undef err
#define err (*ip->err)
#undef min_
#define min_ (*ip->min_)
#undef max_
#define max_ (*ip->max_)
#undef jitter
#define jitter (*ip->jitter)
#undef avgerr
#define avgerr (*ip->avgerr)
#undef reset
#define reset (0+*ip->reset)
#undef last
#define last (ip->last)
#undef first
#define first (ip->first)
#undef count
#define count (ip->count)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])


#line 19 "hal/i_components/timedelta.icomp"

#undef max
#define max(a,b) ((a)>(b)?(a):(b))

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_s64_t now = rtapi_get_time();
hal_s64_t del = (now - last);
hal_s64_t absl = del - period;
    out = del;

    if(last != 0)
        {
        // only want average of actual pos overrun errors , not neg underruns as well
        // they normally balance out which will give a meaningless figure of 0-5 ish average
        if(absl > 0L)
            err = err + absl;
        if(first)
            {
            first = 0;
            min_ = max_ = del;
            jitter = 0;
            }
        else
            {
            if(del < min_)
                min_ = del;
            if(del > max_)
                max_ = del;
            // this is a cumulative highest recorded jitter figure
            jitter = max(max_ - period, period - min_);
            }
        // if last poll did not produce an overrun, don't add to count
        // or will get false low average
        if(absl > 0L)
            count++;
        // this is an actual average of all the overruns
        avgerr = err / count;
        }

    if(reset)
        {
        first = 1;
        last = out = jitter = absl = max_ = min_ = avgerr = 0;
        }
    else
        last = now;

    return 0;
}


