
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:49 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "timedeltav2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:timedeltav2:\nMachinekit HAL component that measures thread scheduling timing behavior");
MODULE_INFO(machinekit, "pin_ptr:out:s32:None:out::None");
MODULE_INFO(machinekit, "pin_ptr:err:s32:None:out::0");
MODULE_INFO(machinekit, "pin_ptr:min_:s32:None:out::0");
MODULE_INFO(machinekit, "pin_ptr:max_:s32:None:out::0");
MODULE_INFO(machinekit, "pin_ptr:jitter:s32:None:out::0");
MODULE_INFO(machinekit, "pin_ptr:avgerr:s32:None:out::0.0");
MODULE_INFO(machinekit, "pin_ptr:reset:bit:None:in::None");
MODULE_INFO(machinekit, "funct:_:0:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    s32_pin_ptr out;
    s32_pin_ptr err;
    s32_pin_ptr min_;
    s32_pin_ptr max_;
    s32_pin_ptr jitter;
    s32_pin_ptr avgerr;
    bit_pin_ptr reset;
    hal_s64_t last;
    hal_s32_t first;
    hal_s32_t count;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int timedeltav2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->out = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (s32_pin_null(ip->out))
            return _halerrno;


    ip->err = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.err", name);
    if (s32_pin_null(ip->err))
            return _halerrno;

    set_s32_pin(ip->err, 0);


    ip->min_ = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.min", name);
    if (s32_pin_null(ip->min_))
            return _halerrno;

    set_s32_pin(ip->min_, 0);


    ip->max_ = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.max", name);
    if (s32_pin_null(ip->max_))
            return _halerrno;

    set_s32_pin(ip->max_, 0);


    ip->jitter = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.jitter", name);
    if (s32_pin_null(ip->jitter))
            return _halerrno;

    set_s32_pin(ip->jitter, 0);


    ip->avgerr = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.avgerr", name);
    if (s32_pin_null(ip->avgerr))
            return _halerrno;

    set_s32_pin(ip->avgerr, 0.0);


    ip->reset = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.reset", name);
    if (bit_pin_null(ip->reset))
            return _halerrno;

    ip->last = 0;
    ip->first = 1;
    ip->count = 1;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = timedeltav2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int timedeltav2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef out
#define out (ip->out)
#undef err
#define err (ip->err)
#undef min_
#define min_ (ip->min_)
#undef max_
#define max_ (ip->max_)
#undef jitter
#define jitter (ip->jitter)
#undef avgerr
#define avgerr (ip->avgerr)
#undef reset
#define reset (ip->reset)
#undef last
#define last (ip->last)
#undef first
#define first (ip->first)
#undef count
#define count (ip->count)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 19 "hal/i_components/timedeltav2.icomp"
#undef max
#define max(a,b) ((a)>(b)?(a):(b))

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_s64_t now = rtapi_get_time();
hal_s64_t del = (now - last);
hal_s64_t absl = del - period;

    ss(out, del);

    if(last != 0)
        {
        // only want average of actual pos overrun errors , not neg underruns as well
        // they normally balance out which will give a meaningless figure of 0-5 ish average
        if(absl > 0L)
            ss(err, gs(err) + (hal_s32_t)absl);
        if(first)
            {
            first = 0;
            ss(min_, del);
            ss(max_, del);
            ss(jitter, 0);
            }
        else
            {
            if(del < gs(min_))
                ss(min_, del);
            if(del > gs(max_))
                ss(max_,  del);
            ss(jitter, max(gs(max_) - period, period - gs(min_)));
            }
        if(absl > 0L)
            count++;
        // this is an actual average of all the overruns
        ss(avgerr, (gs(err) / count));
        }

    if(gb(reset))
        {
        first = 1;
        last = 0L;
        ss(out, 0);
        ss(jitter, 0);
        ss(max_, 0);
        ss(min_, 0);
        ss(avgerr,0);
        absl = 0;
        }
    else
        last = now;

    return 0;
}


