
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:49 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "timev2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:timev2:Time on in Hours, Minutes, Seconds");
MODULE_INFO(machinekit, "descr:\nTime\n\nWhen the time.N.start bit goes true the cycle timer resets and starts\nto time until time.N.start goes false. If you connect time.N.start to\nhalui.is-running as a cycle timer it will reset during a pause. See\nthe example connections below to keep the timer timing during a pause.\n\nTime returns the hours, minutes, and seconds that time.N.start is true.\n\nSample pyVCP code to display the hours:minutes:seconds.\n\n<pyvcp>\n  <hbox>\n  <label>\n    <text>\"Cycle Time\"</text>\n    <font>(\"Helvetica\",14)</font>\n  </label>\n  <u32>\n      <halpin>\"time-hours\"</halpin>\n      <font>(\"Helvetica\",14)</font>\n      <format>\"2d\"</format>\n  </u32>\n  <label>\n    <text>\":\"</text>\n    <font>(\"Helvetica\",14)</font>\n  </label>\n  <u32>\n      <halpin>\"time-minutes\"</halpin>\n      <font>(\"Helvetica\",14)</font>\n      <format>\"2d\"</format>\n  </u32>\n  <label>\n    <text>\":\"</text>\n    <font>(\"Helvetica\",14)</font>\n  </label>\n  <u32>\n      <halpin>\"time-seconds\"</halpin>\n      <font>(\"Helvetica\",14)</font>\n      <format>\"2d\"</format>\n  </u32>\n  </hbox>\n</pyvcp>\n\nIn your post-gui.hal file you might use the following to connect it up\n\n loadrt time\n loadrt not\n addf time.0 servo-thread\n addf not.0 servo-thread\n net prog-running not.0.in <= halui.program.is-idle\n net cycle-timer time.0.start <= not.0.out\n net cycle-seconds pyvcp.time-seconds <= time.0.seconds\n net cycle-minutes pyvcp.time-minutes <= time.0.minutes\n net cycle-hours pyvcp.time-hours <= time.0.hours\n\nThe start pin will start or restart the counter cumulatively\n\nThe zero pin will zero the counter for a fresh count\nattach to a momentary push button\n");
MODULE_INFO(machinekit, "author:John Thornton - adapted by ArcEye to instcomp");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "pin_ptr:start:bit:None:in:Timer On:0");
MODULE_INFO(machinekit, "pin_ptr:zero:bit:None:in:Timer On:0");
MODULE_INFO(machinekit, "pin_ptr:seconds:u32:None:out:Seconds:0");
MODULE_INFO(machinekit, "pin_ptr:minutes:u32:None:out:Minutes:0");
MODULE_INFO(machinekit, "pin_ptr:hours:u32:None:out:Hours:0");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr start;
    bit_pin_ptr zero;
    u32_pin_ptr seconds;
    u32_pin_ptr minutes;
    u32_pin_ptr hours;
    long totalnsecs;
    hal_bit_t old_start;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int timev2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->start = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.start", name);
    if (bit_pin_null(ip->start))
            return _halerrno;

    set_bit_pin(ip->start, 0);


    ip->zero = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.zero", name);
    if (bit_pin_null(ip->zero))
            return _halerrno;

    set_bit_pin(ip->zero, 0);


    ip->seconds = halx_pin_u32_newf(HAL_OUT, owner_id,
            "%s.seconds", name);
    if (u32_pin_null(ip->seconds))
            return _halerrno;

    set_u32_pin(ip->seconds, 0);


    ip->minutes = halx_pin_u32_newf(HAL_OUT, owner_id,
            "%s.minutes", name);
    if (u32_pin_null(ip->minutes))
            return _halerrno;

    set_u32_pin(ip->minutes, 0);


    ip->hours = halx_pin_u32_newf(HAL_OUT, owner_id,
            "%s.hours", name);
    if (u32_pin_null(ip->hours))
            return _halerrno;

    set_u32_pin(ip->hours, 0);

    ip->totalnsecs = 0;
    ip->old_start = false;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = timev2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int timev2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef start
#define start (ip->start)
#undef zero
#define zero (ip->zero)
#undef seconds
#define seconds (ip->seconds)
#undef minutes
#define minutes (ip->minutes)
#undef hours
#define hours (ip->hours)
#undef totalnsecs
#define totalnsecs (ip->totalnsecs)
#undef old_start
#define old_start (ip->old_start)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 86 "hal/i_components/timev2.icomp"

#include "rtapi_math.h"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

long lperiod = fa_current_period(fa);
hal_u32_t totalsecs;

    if(gb(zero)){
	// cater for restart	
	totalnsecs = totalsecs = 0; 
	su(seconds, 0);
	su(minutes, 0);
	su(hours, 0);
    }

    if(gb(start) && !old_start) 
		totalsecs = 0;

    if(gb(start)){
        totalnsecs += lperiod;
        totalsecs = (hal_u32_t)(totalnsecs / 1e9);

        su(seconds, totalsecs % 60);
        su(minutes, (totalsecs / 60) % 60);
        su(hours, totalsecs / 3600);
        }
    old_start = gb(start);

return 0;

}


