
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:49 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "updownv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:updownv2:Counts up or down, with optional limits and wraparound behavior");
MODULE_INFO(machinekit, "pin_ptr:countup:bit:None:in:Increment count when this pin goes from 0 to 1:None");
MODULE_INFO(machinekit, "pin_ptr:countdown:bit:None:in:Decrement count when this pin goes from 0 to 1:None");
MODULE_INFO(machinekit, "pin_ptr:reset:bit:None:in:Reset count when this pin goes from 0 to 1:None");
MODULE_INFO(machinekit, "pin_ptr:count:s32:None:out:The current count:None");
MODULE_INFO(machinekit, "pin_ptr:clamp:bit:None:io:If true, then clamp the output to the min and max parameters.:None");
MODULE_INFO(machinekit, "pin_ptr:wrap:bit:None:io:\nIf true, then wrap around when the count goes above or below the min and max parameters.  \nNote that wrap implies (and overrides) clamp.:None");
MODULE_INFO(machinekit, "pin_ptr:max:s32:None:io:If clamp or wrap is set, count will never exceed this number:0x7FFFFFFF");
MODULE_INFO(machinekit, "pin_ptr:min:s32:None:io:If clamp or wrap is set, count will never be less than this number:None");
MODULE_INFO(machinekit, "funct:_:0:Process inputs and update count if necessary");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

struct inst_data
    {
    bit_pin_ptr countup;
    bit_pin_ptr countdown;
    bit_pin_ptr reset;
    s32_pin_ptr count;
    bit_pin_ptr clamp;
    bit_pin_ptr wrap;
    s32_pin_ptr max;
    s32_pin_ptr min;
    hal_bit_t oldup;
    hal_bit_t olddown;
    hal_bit_t first;
    int local_argc;
    char **local_argv;
    };

static int maxpins __attribute__((unused)) = 0;
static int updownv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->countup = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.countup", name);
    if (bit_pin_null(ip->countup))
            return _halerrno;


    ip->countdown = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.countdown", name);
    if (bit_pin_null(ip->countdown))
            return _halerrno;


    ip->reset = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.reset", name);
    if (bit_pin_null(ip->reset))
            return _halerrno;


    ip->count = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.count", name);
    if (s32_pin_null(ip->count))
            return _halerrno;


    ip->clamp = halx_pin_bit_newf(HAL_IO, owner_id,
            "%s.clamp", name);
    if (bit_pin_null(ip->clamp))
            return _halerrno;


    ip->wrap = halx_pin_bit_newf(HAL_IO, owner_id,
            "%s.wrap", name);
    if (bit_pin_null(ip->wrap))
            return _halerrno;


    ip->max = halx_pin_s32_newf(HAL_IO, owner_id,
            "%s.max", name);
    if (s32_pin_null(ip->max))
            return _halerrno;

    set_s32_pin(ip->max, 0x7FFFFFFF);


    ip->min = halx_pin_s32_newf(HAL_IO, owner_id,
            "%s.min", name);
    if (s32_pin_null(ip->min))
            return _halerrno;

    ip->oldup = false;
    ip->olddown = false;
    ip->first = true;

    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = updownv2_,
        .arg = ip,
        .uses_fp = 0,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int updownv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef countup
#define countup (ip->countup)
#undef countdown
#define countdown (ip->countdown)
#undef reset
#define reset (ip->reset)
#undef count
#define count (ip->count)
#undef clamp
#define clamp (ip->clamp)
#undef wrap
#define wrap (ip->wrap)
#undef max
#define max (ip->max)
#undef min
#define min (ip->min)
#undef oldup
#define oldup (ip->oldup)
#undef olddown
#define olddown (ip->olddown)
#undef first
#define first (ip->first)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 22 "hal/i_components/updownv2.icomp"

FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

	hal_s32_t temp_count = gs(count);
	if (first) {
		oldup = gb(countup);
		olddown = gb(countdown);
		first = false;
	}
	if ((!oldup) && (gb(countup))) { // positive edge, count up
		temp_count++;
	}
	if ((!olddown) && (gb(countdown))) { // positive edge, count down
		temp_count--;
	}
	if (gb(reset)) {
		temp_count=0;
	}
	if (gb(wrap)) {
		if (temp_count > gs(max))
			temp_count = gs(min);
		else if (temp_count < gs(min))
			temp_count = gs(max);
	} else if (gb(clamp)) {
		if (temp_count > gs(max))
			temp_count = gs(max);
		else if (temp_count < gs(min))
			temp_count = gs(min);
	}
	ss(count, temp_count);
	oldup = gb(countup);
	olddown = gb(countdown);

return 0;
}


