
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:49 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "watchdogv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:watchdogv2:Input watchdog for Machinekit HAL");
MODULE_INFO(machinekit, "pin_ptr:input-##:bit:pincount:in:the input bit HAL pin:None");
MODULE_INFO(machinekit, "pin_ptr:ok-out:bit:None:out:high if all inputs are toggling, low otherwise:false");
MODULE_INFO(machinekit, "pin_ptr:enable:bit:None:in:only runs while this is high :false");
MODULE_INFO(machinekit, "pin_ptr:timeout-##:float:pincount:io:maximum allowed timeb without transition:None");
MODULE_INFO(machinekit, "instanceparam:pincount:int:Index used by all arrays of pins and variables:1");
MODULE_INFO(machinekit, "funct:process:1:");
MODULE_INFO(machinekit, "funct:set_timeouts:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_INFO(machinekit, "author:Stephen Wille Padnos - converted to icomp by ArcEye");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

#define MAXCOUNT 8
#define DEFAULTCOUNT 1

static int pincount = 1;
RTAPI_IP_INT(pincount, "Index used by all arrays of pins and variables");

struct inst_data
    {
    bit_pin_ptr input[8];
    bit_pin_ptr ok_out;
    bit_pin_ptr enable;
    float_pin_ptr timeout[8];
    hal_s32_t c_secs[8];
    hal_s32_t c_nsecs[8];
    hal_s32_t t_secs[8];
    hal_s32_t t_nsecs[8];
    hal_bit_t last[8];
    hal_float_t oldtimeout[8];
    hal_bit_t old_enable;
    int local_argc;
    char **local_argv;
    int local_pincount;
    };

static int maxpins __attribute__((unused)) = 8;
static int process(void *arg, const hal_funct_args_t *fa);

static int set_timeouts(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;
    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->input[j] = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.input-%02d", name, j);
        if (bit_pin_null(ip->input[j]))
            return _halerrno;
        }


    ip->ok_out = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.ok-out", name);
    if (bit_pin_null(ip->ok_out))
            return _halerrno;

    set_bit_pin(ip->ok_out, false);


    ip->enable = halx_pin_bit_newf(HAL_IN, owner_id,
            "%s.enable", name);
    if (bit_pin_null(ip->enable))
            return _halerrno;

    set_bit_pin(ip->enable, false);

    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->timeout[j] = halx_pin_float_newf(HAL_IO, owner_id,
            "%s.timeout-%02d", name, j);
        if (float_pin_null(ip->timeout[j]))
            return _halerrno;
        }

    ip->old_enable = false;

// if not set by instantiate() set to default
    if(! ip->local_pincount || ip->local_pincount == -1)
         ip->local_pincount = DEFAULTCOUNT;

    hal_print_msg(RTAPI_MSG_DBG,"export_halobjs() ip->local_pincount set to %d", ip->local_pincount);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t process_xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = process,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.process", name);
    r = hal_export_xfunctf(&process_xf, buf, name);
    if(r != 0)
        return r;

    // exporting an extended thread function:
    hal_export_xfunct_args_t set_timeouts_xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = set_timeouts,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.set-timeouts", name);
    r = hal_export_xfunctf(&set_timeouts_xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values
    hal_print_msg(RTAPI_MSG_DBG,"%s: int instance param: %s=%d",__FUNCTION__,"pincount", pincount);
//  if pincount=NN is passed, set local variable here, if not set to default
    int pin_param_value = pincount;
    if((pin_param_value == -1) || (pin_param_value == 0))
        pin_param_value = DEFAULTCOUNT;
    else if((pin_param_value > 0) && (pin_param_value > MAXCOUNT))
        pin_param_value = MAXCOUNT;
    ip->local_pincount = pincount = pin_param_value;
    hal_print_msg(RTAPI_MSG_DBG,"ip->local_pincount set to %d", pin_param_value);

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
//reset pincount to -1 so that instantiation without it will result in DEFAULTCOUNT
    pincount = -1;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int name(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef input
#define input(i) (ip->input[i])
#undef ok_out
#define ok_out (ip->ok_out)
#undef enable
#define enable (ip->enable)
#undef timeout
#define timeout(i) (ip->timeout[i])
#undef c_secs
#define c_secs(i) (ip->c_secs[i])
#undef c_nsecs
#define c_nsecs(i) (ip->c_nsecs[i])
#undef t_secs
#define t_secs(i) (ip->t_secs[i])
#undef t_nsecs
#define t_nsecs(i) (ip->t_nsecs[i])
#undef last
#define last(i) (ip->last[i])
#undef oldtimeout
#define oldtimeout(i) (ip->oldtimeout[i])
#undef old_enable
#define old_enable (ip->old_enable)
#undef local_pincount
#define local_pincount (ip->local_pincount)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 27 "hal/i_components/watchdogv2.icomp"

FUNCTION(process)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_s32_t i, fault = 0;

    // set_timeouts has to turn on the ok-out when it detects a valid
    // transition on enable
    if (!gb(enable) || !gb(ok_out))
        return 0;
    for (i = 0; i < local_pincount; i++)
        {
        if (gb(input(i)) != last(i))
            {
            c_secs(i) = t_secs(i);
            c_nsecs(i) = t_nsecs(i);
            }
        else
            {
            c_nsecs(i) -= period;
            if (c_nsecs(i) < 0)
                {
                c_nsecs(i) += 1000000000;
                if (c_secs(i) > 0)
                    c_secs(i)--;
                else
                    {
                    fault = 1;
                    c_secs(i) = c_nsecs(i) = 0;
                    }
                }
            }
        last(i) = gb(input(i));
        }
    if (fault)
        sb(ok_out, 0);

    return 0;
}

FUNCTION(set_timeouts)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

hal_s32_t i;
hal_float_t temp;

    for (i = 0; i < local_pincount; i++)
        {
        temp = gf(timeout(i));
        if (temp < 0)
            temp = 0;   // no negative timeout periods
        if (temp != oldtimeout(i))
            {
            // new timeout, convert to secs/ns
            oldtimeout(i) = temp;
            t_secs(i) = temp;
            temp -= t_secs(i);
            t_nsecs(i) = (1e9 * temp);
            }
        }

    if (!gb(ok_out))
        {
        if (gb(enable) && !old_enable)
            {
            // rising edge on enable, so we can restart
            for (i = 0; i < local_pincount; i++)
                {
                c_secs(i) = t_secs(i);
                c_nsecs(i) = t_nsecs(i);
                }
            sb(ok_out, 1);
            }
        }
    old_enable = gb(enable);

    return 0;
}


