
/* Autogenerated by ../bin/instcomp on Wed May 29 22:02:49 2019 -- do not edit */

#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"
#include "hal_priv.h"
#include "hal_accessor.h"
#include "hal_internal.h"

static int comp_id;


static char *compname = "wcompnv2";

#ifdef MODULE_INFO
MODULE_INFO(machinekit, "component:wcompnv2:N-range window comparator");
MODULE_INFO(machinekit, "pin_ptr:in:float:None:in:Value being compared:None");
MODULE_INFO(machinekit, "pin_ptr:value#:float:pincount:in:Boundary N for comparison:None");
MODULE_INFO(machinekit, "pin_ptr:default_out:s32:None:in:Default output value when input is not in range:-1");
MODULE_INFO(machinekit, "pin_ptr:out:s32:None:out:Returns the index of the window the \\fBin\\fR is currently in:None");
MODULE_INFO(machinekit, "pin_ptr:under:bit:None:out:True if \\fBin\\fR is less than \\fBvalue0\\fR:None");
MODULE_INFO(machinekit, "pin_ptr:over:bit:None:out:True if \\fBin\\fR is greater than or equal to \\fvalue<N-1>\\fR:None");
MODULE_INFO(machinekit, "pin_ptr:in_range:bit:None:out:True if \\fBin\\fR is strictly between \\fBvalue0\\fR and \\fBvalue<N-1>\\fR:None");
MODULE_INFO(machinekit, "notes:If \\fBmax\\fR <= \\fBmin\\fR or \\fBvalue<x>\\fR are not in ascending orderthen the behavior is undefined.");
MODULE_INFO(machinekit, "instanceparam:pincount:int::2");
MODULE_INFO(machinekit, "funct:_:1:");
MODULE_INFO(machinekit, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO
RTAPI_TAG(HAL,HC_INSTANTIABLE);

RTAPI_TAG(HAL,HC_SMP_SAFE);

#define MAXCOUNT 16
#define DEFAULTCOUNT 2

static int pincount = 2;
RTAPI_IP_INT(pincount, "");

struct inst_data
    {
    float_pin_ptr in;
    float_pin_ptr value[16];
    s32_pin_ptr default_out;
    s32_pin_ptr out;
    bit_pin_ptr under;
    bit_pin_ptr over;
    bit_pin_ptr in_range;
    int local_argc;
    char **local_argv;
    int local_pincount;
    };

static int maxpins __attribute__((unused)) = 16;
static int wcompnv2_(void *arg, const hal_funct_args_t *fa);

static int instantiate(const int argc, char* const *argv);

static int delete(const char *name, void *inst, const int inst_size);

#undef TRUE
#undef FALSE
#undef true
#define true (1)
#undef false
#define false (0)

static int export_halobjs(
struct inst_data *ip, int owner_id, const char *name,
const int argc, char * const *argv)
{
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int j __attribute__((unused)) = 0;
    int z __attribute__((unused)) = 0;

    ip->in = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.in", name);
    if (float_pin_null(ip->in))
            return _halerrno;

    z = pincount;
    if(z > maxpins) z = maxpins;
    for(j=0; j < z; j++)
        {
        ip->value[j] = halx_pin_float_newf(HAL_IN, owner_id,
            "%s.value%01d", name, j);
        if (float_pin_null(ip->value[j]))
            return _halerrno;
        }


    ip->default_out = halx_pin_s32_newf(HAL_IN, owner_id,
            "%s.default-out", name);
    if (s32_pin_null(ip->default_out))
            return _halerrno;

    set_s32_pin(ip->default_out, -1);


    ip->out = halx_pin_s32_newf(HAL_OUT, owner_id,
            "%s.out", name);
    if (s32_pin_null(ip->out))
            return _halerrno;


    ip->under = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.under", name);
    if (bit_pin_null(ip->under))
            return _halerrno;


    ip->over = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.over", name);
    if (bit_pin_null(ip->over))
            return _halerrno;


    ip->in_range = halx_pin_bit_newf(HAL_OUT, owner_id,
            "%s.in-range", name);
    if (bit_pin_null(ip->in_range))
            return _halerrno;


// if not set by instantiate() set to default
    if(! ip->local_pincount || ip->local_pincount == -1)
         ip->local_pincount = DEFAULTCOUNT;

    hal_print_msg(RTAPI_MSG_DBG,"export_halobjs() ip->local_pincount set to %d", ip->local_pincount);


    ip->local_argv = halg_dupargv(1, argc, argv);

    ip->local_argc = argc;


    // exporting an extended thread function:
    hal_export_xfunct_args_t __xf = 
        {
        .type = FS_XTHREADFUNC,
        .funct.x = wcompnv2_,
        .arg = ip,
        .uses_fp = 1,
        .reentrant = 0,
        .owner_id = owner_id
        };

    rtapi_snprintf(buf, sizeof(buf),"%s.funct", name);
    r = hal_export_xfunctf(&__xf, buf, name);
    if(r != 0)
        return r;
    return 0;
}

// constructor - init all HAL pins, funct etc here
static int instantiate(const int argc, char* const *argv)
{
struct inst_data *ip;
// argv[0]: component name
const char *name = argv[1];
int r;

// allocate a named instance, and some HAL memory for the instance data
int inst_id = hal_inst_create(name, comp_id, sizeof(struct inst_data), (void **)&ip);

    if (inst_id < 0)
        return -1;

// here ip is guaranteed to point to a blob of HAL memory of size sizeof(struct inst_data).
    hal_print_msg(RTAPI_MSG_DBG,"%s inst=%s argc=%d",__FUNCTION__, name, argc);

// Debug print of params and values
    hal_print_msg(RTAPI_MSG_DBG,"%s: int instance param: %s=%d",__FUNCTION__,"pincount", pincount);
//  if pincount=NN is passed, set local variable here, if not set to default
    int pin_param_value = pincount;
    if((pin_param_value == -1) || (pin_param_value == 0))
        pin_param_value = DEFAULTCOUNT;
    else if((pin_param_value > 0) && (pin_param_value > MAXCOUNT))
        pin_param_value = MAXCOUNT;
    ip->local_pincount = pincount = pin_param_value;
    hal_print_msg(RTAPI_MSG_DBG,"ip->local_pincount set to %d", pin_param_value);

// These pins - pin_ptrs- functs will be owned by the instance, and can be separately exited with delinst
    r = export_halobjs(ip, inst_id, name, argc, argv);
//reset pincount to -1 so that instantiation without it will result in DEFAULTCOUNT
    pincount = -1;

    return r;
}

int rtapi_app_main(void)
{
    comp_id = hal_xinit(TYPE_RT, 0, 0, instantiate, delete, compname);

    if (comp_id < 0)

        return -1;

    hal_ready(comp_id);

    return 0;
}

void rtapi_app_exit(void)
{
    hal_exit(comp_id);
}

// Custom destructor - delete()
// pins, pin_ptrs, and functs are automatically deallocated regardless if a
// destructor is used or not (see below)
//
// Some objects like vtables, rings, threads are not owned by a component
// interaction with such objects may require a custom destructor for
// cleanup actions
// Also allocated memory that hal_lib will know nothing about ie local_argv
//
// NB: if a customer destructor is used, it is called
// - after the instance's functs have been removed from their respective threads
//   (so a thread funct call cannot interact with the destructor any more)
// - any pins and params of this instance are still intact when the destructor is
//   called, and they are automatically destroyed by the HAL library once the
//   destructor returns


static int delete(const char *name, void *inst, const int inst_size)
{

    struct inst_data *ip = inst;

    HALDBG("Entering delete() : inst=%s size=%d %p local_argv = %p\n", name, inst_size, inst, ip->local_argv);

    HALDBG("Before free ip->local_argv[0] = %s\n", ip->local_argv[0]);

   	halg_free_argv(1, ip->local_argv);

    HALDBG("Now ip->local_argv[0] = %s\n", ip->local_argv[0]);

    return 0;

}


#undef FUNCTION
#define FUNCTION(name) static int wcompnv2_(void *arg, const hal_funct_args_t *fa)
#undef fperiod
#define fperiod (period * 1e-9)
#undef in
#define in (ip->in)
#undef value
#define value(i) (ip->value[i])
#undef default_out
#define default_out (ip->default_out)
#undef out
#define out (ip->out)
#undef under
#define under (ip->under)
#undef over
#define over (ip->over)
#undef in_range
#define in_range (ip->in_range)
#undef local_pincount
#define local_pincount (ip->local_pincount)
#undef local_argc
#define local_argc (ip->local_argc)
#undef local_argv
#define local_argv(i) (ip->local_argv[i])
#include <hal_accessor_macros.h>


#line 18 "hal/i_components/wcompnv2.icomp"
FUNCTION(_)
{
long period __attribute__((unused)) = fa_period(fa);
struct inst_data *ip __attribute__((unused)) = arg;

    hal_s32_t i;

    ss(out, gs(default_out));
    for (i=1; i < local_pincount; i++)
    {
        if ((gf(in) >= gf(value(i-1))) && (gf(in) < gf(value(i))))
        {
            ss(out, i-1);
        }
    }
    sb(under, (gf(in) < gf(value(0))));
    sb(over, (gf(in) >= gf(value(local_pincount-1))));
    sb(in_range, !(gb(under) || gb(over)));

    return 0;
}


