/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:ringread:demonstrate ring read operations");
MODULE_INFO(linuxcnc, "descr:\nDemonstartion of ringread operations\n\nWill output\n    \n    Number of underruns\n    Number of successful reads\n    Number of times writer outstripped the reader\n");
MODULE_INFO(linuxcnc, "pin:underrun:u32:0:out:number of failed read attempts:None:None");
MODULE_INFO(linuxcnc, "pin:received:u32:0:out:number of successful read attempts:None:None");
MODULE_INFO(linuxcnc, "pin:tooslow:u32:0:out:number of times the reader couldnt keep up with the writer:None:None");
MODULE_INFO(linuxcnc, "pin:circular:bit:0:in:circular flag - set to nonzero to enable circular record buffer:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPLv2 or later");
MODULE_LICENSE("GPLv2 or later");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_u32_t *underrun;
    hal_u32_t *received;
    hal_u32_t *tooslow;
    hal_bit_t *circular;
};
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_u32_newf(HAL_OUT, &(inst->underrun), comp_id,
        "%s.underrun", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->received), comp_id,
        "%s.received", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->tooslow), comp_id,
        "%s.tooslow", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->circular), comp_id,
        "%s.circular", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef underrun
#define underrun (*__comp_inst->underrun)
#undef received
#define received (*__comp_inst->received)
#undef tooslow
#define tooslow (*__comp_inst->tooslow)
#undef circular
#define circular (0+*__comp_inst->circular)


#line 27 "machinetalk/msgcomponents/ringread.comp"

#define MAXSIZE 1024

#include "hal_priv.h"
#include "hal_ring.h"	        /* ringbuffer declarations */

static char *ring = "ring_0";
RTAPI_MP_STRING(ring,  "name of ring to attach");

static ringbuffer_t rb;
static ringiter_t ri;
static char *name = "ringread";

FUNCTION(_) {
    ringvec_t vec[2];
    rrecsize_t rsize;
    const void *data;

    if (rb.header->type == RINGTYPE_STREAM) {
	// peek into the stream, non-copy mode
	stream_get_read_vector(&rb, vec);
	rsize = vec[0].rv_len + vec[1].rv_len;
	if (vec[0].rv_len) {
	    rtapi_print_msg(RTAPI_MSG_ERR, "%s(%s): bytes=%d '%.*s",
			    name, ring, rsize,
			    (int) vec[0].rv_len, (char *) vec[0].rv_base);
	    if (vec[1].rv_len) {
		rtapi_print_msg(RTAPI_MSG_ERR, "%.*s",
				(int) vec[1].rv_len, (char *) vec[1].rv_base);
	    }
	    rtapi_print_msg(RTAPI_MSG_ERR, "'\n");

	    // consume bytes read
	    stream_read_advance(&rb, rsize);
	    received++;
	    // if we have a scratchpad, leave a dropping there
	    if (rb.scratchpad) {
		rtapi_snprintf(rb.scratchpad,ring_scratchpad_size(&rb),
			       "received=%d underrun=%d",
			       received, underrun);
	    }
	} else
	    underrun++;
    } else {
	if (circular) {
	    char buf[MAXSIZE];
	    int result;
	    ringsize_t size;

	    result = record_iter_read(&ri, &data, &size);
	    switch (result) {
	    case EINVAL:
		// generation changed due to consumer too slow, renew
		tooslow++;
		record_iter_init(&rb, &ri);
		break;
	    case EAGAIN:
		// ring empty
		underrun++;
		break;
	    default:
		// record available, but commit only after successful iter_shift()
		memcpy(buf, data, size > sizeof(buf) ? sizeof(buf) : size);
		if (record_iter_shift(&ri) == EINVAL) {
		    tooslow++;
		    break;
		}
		// good to consume buffer
		rtapi_print_msg(RTAPI_MSG_ERR,
				"circular: %s(%s): reclen=%zu '%.*s', writer=%d\n",
				name, ring, (size_t)size, (int) size, buf,
				rb.header->writer);
		break;
	    }
	} else {
	    rsize = record_next_size(&rb);
	    if (rsize < 0) {
		// ring empty
		underrun++;
		return;
	    }
	    rtapi_print_msg(RTAPI_MSG_ERR, "%s(%s): reclen=%d '%.*s', writer=%d\n",
			    name, ring, rsize, rsize,
			    (char *) record_next(&rb),
			    rb.header->writer);
	    // consume record
	    record_shift(&rb);
	    received++;
	}
	if (rb.scratchpad) {
	    rtapi_snprintf(rb.scratchpad,ring_scratchpad_size(&rb),
			   "received=%d underrun=%d",
			   received, underrun);
	}
    }
}

int rtapi_app_main(void)
{
    int retval;

    comp_id = hal_init("ringread");
    if (comp_id < 0) {
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: hal_init() failed: %d\n",
			name, comp_id);
	return -1;
    }
    if ((retval = hal_ring_attachf(&rb, NULL, ring))) {
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: hal_ring_attach(%s) failed: %d\n",
			name, ring, retval);
	return -1;
    }

    rtapi_print_msg(RTAPI_MSG_INFO,
		    "%s: attached ring '%s' size=%zu type=%d"
		    " rmutex=%d wmutex=%d reader=%d writer=%d scratchpad=%zu\n",
		    name, ring, (size_t)rb.header->size,
		    rb.header->type,
		    ring_use_rmutex(&rb), ring_use_wmutex(&rb),
		    rb.header->reader, rb.header->writer,
		    (size_t)ring_scratchpad_size(&rb));

    rb.header->reader = comp_id;
    rb.header->reader_instance = rtapi_instance;

    record_iter_init(&rb, &ri);

    if ((retval = export(name, 0))) {
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: export(ringread) failed: %d\n",
			name, retval);
	return -1;
    }
    hal_ready(comp_id);
    return 0;
}

void rtapi_app_exit(void)
{
    int retval;
    rb.header->reader = 0;
    if ((retval = hal_ring_detach(&rb)) < 0)
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: hal_ring_detach(%s) failed: %d\n",
			name, ring, retval);
    hal_exit(comp_id);
}

static int __comp_get_data_size(void) { return 0; }
