/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:ringwrite:demonstrate wring write operations");
MODULE_INFO(linuxcnc, "descr:\nDemonstration of ringwrite operations\n\nWill output\n....\n    Number of messages\n    Number of failed writes\n    Number of dropped writes\n");
MODULE_INFO(linuxcnc, "pin:write:bit:0:in:send a message on pin transition:None:None");
MODULE_INFO(linuxcnc, "pin:sent:u32:0:out:number of messages written:None:None");
MODULE_INFO(linuxcnc, "pin:overrun:u32:0:out:number of failed write attempts:None:None");
MODULE_INFO(linuxcnc, "pin:dropped:u32:0:out:number of records deleted when writing to full buffer:None:None");
MODULE_INFO(linuxcnc, "pin:circular:bit:0:in:circular flag - set to nonzero to enable circular record buffer:None:None");
MODULE_INFO(linuxcnc, "funct:_:1:");
MODULE_INFO(linuxcnc, "license:GPLv2 or later");
MODULE_LICENSE("GPLv2 or later");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_bit_t *write;
    hal_u32_t *sent;
    hal_u32_t *overrun;
    hal_u32_t *dropped;
    hal_bit_t *circular;
    hal_bit_t write_prev;

};
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static void _(struct __comp_state *__comp_inst, long period);
static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    char buf[HAL_NAME_LEN + 1];
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_bit_newf(HAL_IN, &(inst->write), comp_id,
        "%s.write", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->sent), comp_id,
        "%s.sent", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->overrun), comp_id,
        "%s.overrun", prefix);
    if(r != 0) return r;
    r = hal_pin_u32_newf(HAL_OUT, &(inst->dropped), comp_id,
        "%s.dropped", prefix);
    if(r != 0) return r;
    r = hal_pin_bit_newf(HAL_IN, &(inst->circular), comp_id,
        "%s.circular", prefix);
    if(r != 0) return r;
    rtapi_snprintf(buf, sizeof(buf), "%s", prefix);
    r = hal_export_funct(buf, (void(*)(void *inst, long))_, inst, 1, 0, comp_id);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef write
#define write (0+*__comp_inst->write)
#undef sent
#define sent (*__comp_inst->sent)
#undef overrun
#define overrun (*__comp_inst->overrun)
#undef dropped
#define dropped (*__comp_inst->dropped)
#undef circular
#define circular (0+*__comp_inst->circular)
#undef write_prev
#define write_prev (__comp_inst->write_prev)


#line 28 "machinetalk/msgcomponents/ringwrite.comp"

#include "hal_priv.h"
#include "hal_ring.h"	        /* ringbuffer declarations */

#define BUFFERSIZE 100

static char *ring = "ring_0";
RTAPI_MP_STRING(ring,  "name of ring to attach");

static ringbuffer_t rb;
static char buffer[BUFFERSIZE];
static size_t length;
static char *name = "ringwrite";

FUNCTION(_) {
    if (write_prev ^  write) {
	rtapi_snprintf(buffer, sizeof(buffer), "message %u to %s, sender=comp %d",
		       sent, ring, comp_id);
	length = strlen(buffer);
	sent++;

	if (rb.header->type == RINGTYPE_STREAM) {
	    if (stream_write(&rb, buffer, length) != length)
		overrun++;
	} else {
	    if (circular) {
		// circular buffer behavior: drop oldest records if full
		while (record_write(&rb, buffer, length) ==  EAGAIN) {
		    dropped++;
		    record_shift(&rb);
		}
	    } else {
		// queue behavior: fail if insufficient space
		if (record_write(&rb, buffer, length))
		    overrun++;
	    }
	}
	write_prev = write;
    }
}

int rtapi_app_main(void)
{
    int retval;

    comp_id = hal_init(name);
    if (comp_id < 0) {
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: hal_init() failed: %d\n",
			name, comp_id);
	return -1;
    }
    if ((retval = hal_ring_attachf(&rb, NULL, ring))) {
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: hal_ring_attach(%s) failed: %d\n",
			name, ring, retval);
	return -1;
    }
    rb.header->writer = comp_id;
    rb.header->writer_instance = rtapi_instance;
    if ((retval = export(name, 0))) {
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: export(%s) failed: %d\n",
			name, name, retval);
	return -1;
    }
    hal_ready(comp_id);
    rtapi_print_msg(RTAPI_MSG_ERR,
		    "%s: attached to %s reader=%d writer=%d\n",
		    name, ring, rb.header->reader, rb.header->writer);

    return 0;
}

void rtapi_app_exit(void)
{
    int retval;
    rb.header->writer = 0;
    if ((retval = hal_ring_detach(&rb)) < 0)
	rtapi_print_msg(RTAPI_MSG_ERR,
			"%s: ERROR: hal_ring_detach(%s) failed: %d\n",
			name, ring, retval);
    hal_exit(comp_id);
}

static int __comp_get_data_size(void) { return 0; }
