/* Autogenerated by ../bin/comp -- do not edit */
#include "rtapi.h"
#ifdef RTAPI
#include "rtapi_app.h"
#endif
#include "rtapi_string.h"
#include "rtapi_errno.h"
#include "hal.h"

static int comp_id;

#ifdef MODULE_INFO
MODULE_INFO(linuxcnc, "component:adxl345:read an ADXL345 3-axis accelerometer");
MODULE_INFO(linuxcnc, "descr:\nreads the X,Y,Z acceleration values from an ADXL345 via the i2c bus.\n\ncomputes the roll, pitch and yaw rotations about the X, Y and Z axis. See also: https://en.wikipedia.org/wiki/Aircraft_principal_axes\n\nOptions:\n    -t msec       polling interval in msec, default 10ms\n    -b number     use /dev/i2c-<number>, default /dev/i2c-0\n    -g range      gravity range, default 3 - +/- 16g\n                  0: +/- 2g\n                  1: +/- 4g\n                  2: +/- 8g\n                  3: +/- 16g\n    -N            normal resolution (10bit), default 13bit\n");
MODULE_INFO(linuxcnc, "pin:x-accel:s32:0:out:X acceleration value:None:None");
MODULE_INFO(linuxcnc, "pin:y-accel:s32:0:out:Y acceleration value:None:None");
MODULE_INFO(linuxcnc, "pin:z-accel:s32:0:out:Z acceleration value:None:None");
MODULE_INFO(linuxcnc, "pin:roll:float:0:out:rotation about X axis, -180..180 deg:None:None");
MODULE_INFO(linuxcnc, "pin:pitch:float:0:out:rotation about Y axis, -180..180 deg:None:None");
MODULE_INFO(linuxcnc, "pin:yaw:float:0:out:rotation about Z axis, -180..180 deg:None:None");
MODULE_INFO(linuxcnc, "license:GPL");
MODULE_LICENSE("GPL");
#endif // MODULE_INFO


struct __comp_state {
    struct __comp_state *_next;
    hal_s32_t *x_accel;
    hal_s32_t *y_accel;
    hal_s32_t *z_accel;
    hal_float_t *roll;
    hal_float_t *pitch;
    hal_float_t *yaw;
};
#include <stdlib.h>
struct __comp_state *__comp_inst=0;
struct __comp_state *__comp_first_inst=0, *__comp_last_inst=0;

static int __comp_get_data_size(void);
#undef TRUE
#define TRUE (1)
#undef FALSE
#define FALSE (0)
#undef true
#define true (1)
#undef false
#define false (0)

static int export(char *prefix, long extra_arg) {
    int r = 0;
    int sz = sizeof(struct __comp_state) + __comp_get_data_size();
    struct __comp_state *inst = hal_malloc(sz);
    memset(inst, 0, sz);
    r = hal_pin_s32_newf(HAL_OUT, &(inst->x_accel), comp_id,
        "%s.x-accel", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->y_accel), comp_id,
        "%s.y-accel", prefix);
    if(r != 0) return r;
    r = hal_pin_s32_newf(HAL_OUT, &(inst->z_accel), comp_id,
        "%s.z-accel", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->roll), comp_id,
        "%s.roll", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->pitch), comp_id,
        "%s.pitch", prefix);
    if(r != 0) return r;
    r = hal_pin_float_newf(HAL_OUT, &(inst->yaw), comp_id,
        "%s.yaw", prefix);
    if(r != 0) return r;
    if(__comp_last_inst) __comp_last_inst->_next = inst;
    __comp_last_inst = inst;
    if(!__comp_first_inst) __comp_first_inst = inst;
    if(!__comp_inst) __comp_inst = inst;
    return 0;
}
int rtapi_app_main(void) {
    int r = 0;
    comp_id = hal_init("adxl345");
    if(comp_id < 0) return comp_id;
    r = export("adxl345", 0);
    if(r) {
        hal_exit(comp_id);
    } else {
        hal_ready(comp_id);
    }
    return r;
}

void rtapi_app_exit(void) {
    hal_exit(comp_id);
}
static void user_mainloop(void);
int argc=0; char **argv=0;
int main(int argc_, char **argv_) {
    argc = argc_; argv = argv_;


    if(rtapi_app_main() < 0) return 1;
    user_mainloop();
    rtapi_app_exit();
    return 0;
}

#undef FUNCTION
#define FUNCTION(name) static void name(struct __comp_state *__comp_inst, long period)
#undef EXTRA_SETUP
#define EXTRA_SETUP() static int extra_setup(struct __comp_state *__comp_inst, char *prefix, long extra_arg)
#undef EXTRA_CLEANUP
#define EXTRA_CLEANUP() static void extra_cleanup(void)
#undef fperiod
#define fperiod (period * 1e-9)
#undef x_accel
#define x_accel (*__comp_inst->x_accel)
#undef y_accel
#define y_accel (*__comp_inst->y_accel)
#undef z_accel
#define z_accel (*__comp_inst->z_accel)
#undef roll
#define roll (*__comp_inst->roll)
#undef pitch
#define pitch (*__comp_inst->pitch)
#undef yaw
#define yaw (*__comp_inst->yaw)
#undef FOR_ALL_INSTS
#define FOR_ALL_INSTS() for(__comp_inst = __comp_first_inst; __comp_inst; __comp_inst = __comp_inst->_next)


#line 36 "hal/user_comps/adxl345.comp"
#include <rtapi_math.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/limits.h>
#include <linux/i2c.h>
#include <linux/i2c-dev.h>

enum RANGE {
    PLUSMINUS_2_G 		= 0,  // plus/minus 2g
    PLUSMINUS_4_G 		= 1,  // plus/minus 4g
    PLUSMINUS_8_G 		= 2,  // plus/minus 8g
    PLUSMINUS_16_G 		= 3   // plus/minus 16g
};

// The resolution of the sensor. High is only available in +/- 16g range.
enum RESOLUTION {
    NORMAL = 0,                         // NORMAL 10-bit resolution
    HIGH = 1                            // HIGH 13-bit resolution
};

#define POWER_CTL      0x2D   //Power-saving features control
#define DATA_FORMAT    0x31   //Data format control
#define DATAX0         0x32   //X-axis Data 0
#define DATAX1         0x33   //X-axis Data 1
#define DATAY0         0x34   //Y-axis Data 0
#define DATAY1         0x35   //Y-axis Data 1
#define DATAZ0         0x36   //Z-axis Data 0
#define DATAZ1         0x37   //Z-axis Data 1
#define BUFFER_SIZE    0x40

static int usec = 10000;
static int bus = 0;    // /dev/i2c-0
static int device = 0x53;
static int range = PLUSMINUS_16_G;
static int resolution = HIGH;
static unsigned char buffer[BUFFER_SIZE];

static inline int reg_value(const unsigned char msb,
			    const unsigned char lsb)
{
    return (short)((msb << 8)| lsb);
}

static int i2c_open(const int bus, const int device)
{
    char fname[PATH_MAX];
    rtapi_snprintf(fname, sizeof fname, "/dev/i2c-%d", bus);

    int fd = open(fname, O_RDWR);
    if (fd < 0) {
	rtapi_print_msg(RTAPI_MSG_ERR, "%s: failed to open '%s': %s",
			__FUNCTION__, fname, strerror(errno));
	return fd;
    }

    if (ioctl(fd, I2C_SLAVE, device) < 0) {
	rtapi_print_msg(RTAPI_MSG_ERR, "%s: failed to connect to i2c device 0x%x",
			__FUNCTION__, device);
	return -errno;
    }
    return fd;
}

static int i2c_write(const int fd, const unsigned char value)
{
    if (write(fd, &value, 1) != 1) {
	rtapi_print_msg(RTAPI_MSG_ERR, "%s: failed to write to i2c device: %s",
			__FUNCTION__, strerror(errno));
	return 1;
    }
    return 0;
}

static int i2c_write_at(const int fd, const unsigned addr,
			const unsigned char value)
{
    unsigned char buffer[2];
    buffer[0] = addr;
    buffer[1] = value;
    if (write(fd, buffer, 2) != 2) {
	rtapi_print_msg(RTAPI_MSG_ERR, "%s: failed to write to i2c device: %s",
			__FUNCTION__, strerror(errno));
	return 1;
    }
    return 0;
}

static int i2c_readregs(const int fd, const unsigned count,
			const unsigned from, unsigned char *buffer)
{
    int n;
    if (i2c_write(fd, from))
	return 1;
    if ((n = read(fd, buffer, count)) != count) {
	rtapi_print_msg(RTAPI_MSG_ERR, "%s: failed to read %d bytes - got %d: %s",
			__FUNCTION__, count, n, strerror(errno));
	return 1;
    }
    return 0;
}

void user_mainloop(void)
{
    int fd;
    int flags, opt;

    while ((opt = getopt(argc, argv, "b:t:g:N")) != -1) {
	switch (opt) {
	case 'b':
	    bus =  atoi(optarg);
	    break;
	case 'g':
	    range = atoi(optarg);
	    break;
	case 'N':
	    resolution = NORMAL;
	    break;
	case 't':
	    usec = atoi(optarg) * 1000;
	    break;
	default:
	    rtapi_print_msg(RTAPI_MSG_ERR,
			    "Usage: %s [-t msec] [-b i2c bus number] [-g range] [-N]\n",
			    argv[0]);
	    exit(EXIT_FAILURE);
	}
    }

    double gravity_range;
    switch (range) {
    case PLUSMINUS_16_G: gravity_range = 32.0; break;
    case PLUSMINUS_8_G: gravity_range = 16.0; break;
    case PLUSMINUS_4_G: gravity_range = 8.0; break;
    default: gravity_range = 4.0; break;
    }
    double res = 1024.0;
    if (resolution == HIGH)
	res = 8192.0; //13-bit resolution
    double factor = gravity_range/res;

    if ((fd = i2c_open(bus, device)) < 0)
	exit(EXIT_FAILURE);

    if (i2c_write_at(fd, POWER_CTL, 0x08) < 0)
	exit(EXIT_FAILURE);

    char data_format = (resolution << 3) | range;
    if (i2c_write_at(fd, DATA_FORMAT, data_format) < 0)
	exit(EXIT_FAILURE);

    while(1) {
	usleep(usec);
	FOR_ALL_INSTS() {
	    if (i2c_readregs(fd, BUFFER_SIZE, 0, buffer)) {
		rtapi_print_msg(RTAPI_MSG_ERR,
				"%s: failed to read %d from i2c device: %s",
				__FUNCTION__, BUFFER_SIZE, strerror(errno));
		break;
	    }
	    x_accel = reg_value(buffer[DATAX1], buffer[DATAX0]);
	    y_accel = reg_value(buffer[DATAY1], buffer[DATAY0]);
	    z_accel = reg_value(buffer[DATAZ1], buffer[DATAZ0]);
	    double accXg = x_accel * factor;
	    double accYg = y_accel * factor;
	    double accZg = z_accel * factor;
	    double accXSquared = accXg * accXg ;
	    double accYSquared = accYg * accYg ;
	    double accZSquared = accZg * accZg ;
	    pitch = 180 * rtapi_atan(accXg / rtapi_sqrt(accYSquared + accZSquared)) / M_PI;
	    roll =  180 * rtapi_atan(accYg / rtapi_sqrt(accXSquared + accZSquared)) / M_PI;
	    yaw =   180 * rtapi_atan(accZg / rtapi_sqrt(accXSquared + accZSquared))/M_PI;
	}
    }
}

static int __comp_get_data_size(void) { return 0; }
